-- name=int_button_guide_impl
--******************************************************************************************
function public.Init ()

  public.DIRECTION = 1;
  public.POSITION = -171;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet("obj_int_button_guide", {

    event_mdown = int_button_guide.MouseDown,
    event_menter = function () common_impl.DialogButtonMouseEnter( "int_button_guide" ) end,
    event_mleave = function () common_impl.DialogButtonMouseLeave( "int_button_guide" ) end
    --pos_x = 1000,
    --pos_y = 512,
  });
  

end;
--******************************************************************************************
--******************************************************************************************
function public.WideScreenUpdate()

--  if ( not GetWideScreen() ) then
--
--    ObjSet( "int_button_guide_impl", { pos_x = public.POSITION } );
--  
--  else
--
--    ObjSet( "int_button_guide_impl", { pos_x = public.POSITION } );
--
--  end;
--  interface.WideScreenUpdate( "button_guide" );

end;
--******************************************************************************************
function private.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

  PlaySfx( "assets/levels/common/audio/aud_guidance", 0, 0 );

  local obj = "spr_int_button_guide_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

  interface.InventoryOpen();

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT ); 
  local obj = "spr_int_button_guide_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

  interface.InventoryClose();

end;
--******************************************************************************************