-- name=mg_traproom
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_traproom";
  

  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_traproom = function ()

  local effects_table = 
  {
    "spr_traproom_light_add",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_traproom", update_performance_mode_traproom, private.room_objname );
  --------------------------------------------------------------------------------------------
  
  --private.ang_center = { 0, -2.0944, -4.1888};
  private.ang_round  = { 0, -1.256, -2.512, -3.768, -5.024 };
  --private.position = { 3, 5, 2};
  private.coord = {
                   { {45, -49}, {62, 30}, {-8, 70 }, {-69, 17}, {-35, -54} },
                   { {15, -63}, {65, -3}, {26, 63}, {-50, 47}, {-57, -30} },  
                   { {-6, -63}, {60, -27}, {44, 50}, {-31, 58}, {-60, -10 }}
                  }; 
  private.round_ang = {{ 0, -1.15, -2.54, 2.39,  1.23 },
                       { 0, -1.12, -2.53, 2.49,  1.29 },
                       { 0, -1.32, -2.5, 2.65,  1.35 },
                      };               
   --private.ang = {
   --               }               
  --private.coord = { { -8, 70}, { -57, -30}, { 60, -27} };                 
  local table_multiset = {};

  for i = 1,3 do

    table.insert( table_multiset, { "spr_traproom_round_"..i.."_btn", { 
      event_mdown = function()  private.Rotate( i ) end; 
      event_menter = function() private.ButtonMouseEnter( i ) end, 
      event_mleave = function() private.ButtonMouseLeave( i ) end;
      } } );

  end;
    
  for i = 1,3 do

    table.insert( table_multiset, { "obj_traproom_btn_center_"..i, { 
    event_mdown = function()  private.Grab( i ) end; 
    event_menter = function() private.EnterCenter( i ) end, 
    event_mleave = function() private.LeaveCenter( i ) end;
      } } );

  end;
    
   table.insert( table_multiset, { "obj_traproom_btn_center", { 
   event_mdown = function()  private.Turn() end; 
   event_menter = function() private.Enter() end, 
   event_mleave = function() private.Leave() end;
      } } );
   
  
  ObjMultiSet( table_multiset
  );
  --local array_start = { 1,2,3,5,4 }
  --local array2 = private.turn_array( array_start );
  common_impl.hint[ "win_traproom" ] = {
    type = "win",
    room = "rm_corridor",
    zz = "mg_traproom",
    zz_gate = "gmg_corridor_traproom"
  };
  --------------------------------------------------------------------------------------------
  -- function win_traproom () end;
  --------------------------------------------------------------------------------------------
  local win_traproom = function ()

  if ( cmn.IsEventDone( "win_traproom" ) ) then  
    
      ObjSet( "obj_int_button_map_button", { input = true } );
      ObjSet( "spr_int_button_map_button", { alp = 1 } );

    else
    
    --DbgTrace(tostring(ng_global.progress[ "std" ][ "win_traproom" ].state[1]));
    ng_global.progress[ "std" ][ "win_traproom" ].position = { 3, 5, 2};
    for i = 1, 3  do
      ng_global.progress[ "std" ][ "win_traproom" ].state[i] = 0;
      ObjSet( "obj_traproom_round_"..i.."_chip", { ang = ng_global.progress[ "std" ][ "win_traproom" ].state[i]});
     --ObjSet( "obj_traproom_round_"..i.."_chip", { ang = 0 });
      if ng_global.progress[ "std" ][ "win_traproom" ].grab[i] ~= 0 then
        
        ObjAttach("spr_traproom_round_chip_"..ng_global.progress[ "std" ][ "win_traproom" ].grab[i], "obj_traproom_grab_"..i);
        ObjSet("spr_traproom_round_chip_"..ng_global.progress[ "std" ][ "win_traproom" ].grab[i], {pos_x = 0, pos_y = 0, ang = ng_global.progress[ "std" ][ "win_traproom" ].ang_center[i] });
        -- ObjSet("spr_traproom_pincer_"..i.."_right_part_2", { ang = 1.52 });
        ObjSet("anm_traproom_pincer_down_"..i, { alp = 1 });
        ObjSet("anm_traproom_pincer_up_"..i, { alp = 0 });
      end;  
      
    end;
   
    for i = 1, 5  do
      
        
      ObjAttach( "spr_traproom_round_chip_"..ng_global.progress[ "std" ][ "win_traproom" ].round_1[i], "obj_traproom_round_1_chip");
      ObjSet( "spr_traproom_round_chip_"..ng_global.progress[ "std" ][ "win_traproom" ].round_1[i], { pos_x =  private.coord[1][i][1], pos_y = private.coord[1][i][2], ang =  private.round_ang [1][i] });
      ObjAttach( "spr_traproom_round_chip_"..ng_global.progress[ "std" ][ "win_traproom" ].round_2[i], "obj_traproom_round_2_chip");
      ObjSet( "spr_traproom_round_chip_"..ng_global.progress[ "std" ][ "win_traproom" ].round_2[i], { pos_x =  private.coord[2][i][1], pos_y = private.coord[2][i][2], ang =  private.round_ang [2][i] });
      ObjAttach( "spr_traproom_round_chip_"..ng_global.progress[ "std" ][ "win_traproom" ].round_3[i], "obj_traproom_round_3_chip");
      ObjSet( "spr_traproom_round_chip_"..ng_global.progress[ "std" ][ "win_traproom" ].round_3[i], { pos_x =  private.coord[3][i][1], pos_y = private.coord[3][i][2], ang =  private.round_ang [3][i] });
      
     
    
    end;
    
     ObjSet( "obj_traproom_center", { ang = ng_global.progress[ "std" ][ "win_traproom" ].state[4]});
    
    
    
    
    

        end;

  end;

  cmn.AddSubscriber( "win_traproom", win_traproom, private.room_objname );
  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_traproom" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
    --private.coord_get( 1,1 );
   
  
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_traproom" ) ) then
    
    ng_global.progress[ "std" ][ "win_traproom" ].state = {0, 0, 0, 0};
    --ng_global.progress[ "std" ][ "win_traproom" ].round_1 = { 1, 2, 3, 4, 5};
    --ng_global.progress[ "std" ][ "win_traproom" ].round_2 = { 6, 7, 8, 9, 10};
    --ng_global.progress[ "std" ][ "win_traproom" ].round_3 = { 11, 12, 13, 14, 15};
    ng_global.progress[ "std" ][ "win_traproom" ].position = { 3, 5, 2};
    ng_global.progress[ "std" ][ "win_traproom" ].round_1 = { 6, 15, 4, 3, 12};
    ng_global.progress[ "std" ][ "win_traproom" ].round_2 = { 1, 13, 2, 8, 7};
    ng_global.progress[ "std" ][ "win_traproom" ].round_3 = { 10, 9, 11, 14, 5};
    ng_global.progress[ "std" ][ "win_traproom" ].ang_center = { 0, 0, 0};
    ng_global.progress[ "std" ][ "win_traproom" ].grab = {0, 0, 0};
    private.start_chip();
    --ObjAttach("spr_traproom_round_2_chip_5","obj_traproom_round_3_chip");
    --ObjAttach("spr_traproom_round_3_chip_5","obj_traproom_round_2_chip");
    --ObjSet("spr_traproom_round_2_chip_5", { pos_x = -60,pos_y = -10, ang = 1.35});
    --ObjSet("spr_traproom_round_3_chip_5", { pos_x = -57,pos_y = -30, ang = 1.29});
  end;
  
  ObjSet( "obj_int_button_map_button", { input = false } );
  ObjSet( "spr_int_button_map_button", { alp = 0 } );
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_traproom" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
-----------------------------------------------------------------------------------------------
function private.Rotate( circle )

  local start_ang = ng_global.progress[ "std" ][ "win_traproom" ].state[circle]
  local end_ang = ng_global.progress[ "std" ][ "win_traproom" ].state[circle] - 1.25664;
  local func_after = function()

    common_impl.Lock( false );
   
    if circle == 1 then 
      
      ng_global.progress[ "std" ][ "win_traproom" ].state[circle] = private.ang_set( end_ang );
      DbgTrace(tostring(ng_global.progress[ "std" ][ "win_traproom" ].state[circle]));
      ng_global.progress[ "std" ][ "win_traproom" ].round_1 = private.turn_array(ng_global.progress[ "std" ][ "win_traproom" ].round_1);
      private.get_position( 1 );
      
    end;
    if circle == 2 then 
      
      ng_global.progress[ "std" ][ "win_traproom" ].state[circle] = private.ang_set( end_ang );
      ng_global.progress[ "std" ][ "win_traproom" ].round_2 = private.turn_array(ng_global.progress[ "std" ][ "win_traproom" ].round_2);
      private.get_position( 2 );
    end;
    if circle == 3 then 
      
      ng_global.progress[ "std" ][ "win_traproom" ].state[circle] = private.ang_set( end_ang );
      ng_global.progress[ "std" ][ "win_traproom" ].round_3 = private.turn_array(ng_global.progress[ "std" ][ "win_traproom" ].round_3);
      private.get_position( 3 );
    end;
    --DbgTrace("angl = "..tostring(ObjGet("obj_traproom_round_"..circle.."_chip").ang));
    
    --number = (circle)*3;
    --local temp  = ng_global.progress[ "ext" ][ "win_rescue" ].pos[number];

  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_traproom_click_flower", 0, "", 0 );
  ObjAnimate( "obj_traproom_round_"..circle.."_chip", "ang", 0, 0, func_after,
  { 
    0.0, 0, start_ang, 
    0.4, 3, end_ang
  });

  --ObjAnimate("spr_rescue_circle_"..circle.."_button_click", "alp", 0, 0, "",
  --{ 
  --  0.0, 0, 0, 
  --  0.2, 0, 1,
  --  0.4, 0, 0
  --});

  --common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_rescue_rotate", 0, "", 0 );

end;
function private.Grab( pincer ) 
  
  local gear = 0;
  local pos = 0;

  gear = private.gear_get(pincer);
  
  
  local func_after = function()


    common_impl.Lock( false );
    ObjSet("anm_traproom_pincer_down_"..pincer, { alp = 1 });
    ObjSet("anm_traproom_pincer_up_"..pincer, { alp = 0 });
    --private.flag_grab[pincer] = private.coord_get( gear );
    ng_global.progress[ "std" ][ "win_traproom" ].grab[pincer] = private.coord_get( gear );
    --private.set_null( gear );
    --ObjAttach("spr_traproom_round_"..gear.."_chip_3","obj_traproom_grab_"..pincer);
    ng_global.progress[ "std" ][ "win_traproom" ].ang_center[pincer] = ObjGet("spr_traproom_round_chip_"..private.coord_get( gear )).ang;
    ObjAttach( "spr_traproom_round_chip_"..private.coord_get( gear ), "obj_traproom_grab_"..pincer);
    ObjSet("spr_traproom_round_chip_"..private.coord_get( gear ), {pos_x = 0, pos_y = 0, ang = ObjGet("obj_traproom_round_"..gear.."_chip").ang - ObjGet("obj_traproom_center").ang + ObjGet("spr_traproom_round_chip_"..private.coord_get( gear )).ang } );
    private.set_null( gear );
  
  end;
  local func_after_2 = function()

    common_impl.Lock( false );
    --private.set_chip( gear, pincer );
    --chip = private.chip_get(gear);
    ObjSet("anm_traproom_pincer_down_"..pincer, { alp = 0 });
    ObjSet("anm_traproom_pincer_up_"..pincer, { alp = 1 });
    pos = ng_global.progress[ "std" ][ "win_traproom" ].position[gear];
    ObjAttach( "spr_traproom_round_chip_"..ng_global.progress[ "std" ][ "win_traproom" ].grab[pincer], "obj_traproom_round_"..gear.."_chip");
    ObjSet( "spr_traproom_round_chip_"..ng_global.progress[ "std" ][ "win_traproom" ].grab[pincer], { pos_x = private.coord[gear][pos][1], pos_y = private.coord[gear][pos][2], ang = - ObjGet("obj_traproom_round_"..gear.."_chip").ang + ObjGet("obj_traproom_center").ang + ObjGet("spr_traproom_round_chip_"..ng_global.progress[ "std" ][ "win_traproom" ].grab[pincer]).ang });
    if private.check_win() then    private.Win()     end;
    --ObjSet("spr_traproom_round_chip_"..private.coord_get( gear ), {pos_x = 0, pos_y = 0});
    --private.flag_grab[pincer] = 0;
    private.set_chip( gear, pincer );
    ng_global.progress[ "std" ][ "win_traproom" ].grab[pincer] = 0;
    
  end;
  
  if ( ng_global.progress[ "std" ][ "win_traproom" ].grab[pincer] == 0 and private.check( gear )) then
    
    common_impl.Lock( true );  
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_traproom_get", 0, "", 0 ); 
    AnimPlay( "anm_traproom_pincer_up_"..pincer, "DoAnim", func_after );
    --ObjAttach( "spr_traproom_round_chip_"..ng_global.progress[ "std" ][ "win_traproom" ].grab[pincer], "obj_traproom_round_"..gear.."_chip");
   --ObjAnimate( "spr_traproom_pincer_"..pincer.."_left_part_2", "ang", 0, 0, func_after,
    --{ 
    --  0.0, 0, ObjGet("spr_traproom_pincer_"..pincer.."_left_part_2").ang, 
    --  0.6, 3, ObjGet("spr_traproom_pincer_"..pincer.."_left_part_2").ang - 0.9
    --});
    
  end;
    --ObjAnimate( "obj_traproom_pincer_"..pincer, "pos_xy", 0, 0, func_after,
    --{ 
    --  0.0, 0, ObjGet("obj_traproom_pincer_"..pincer).pos_x, ObjGet("obj_traproom_pincer_"..pincer).pos_y,
    --  0.6, 0, ObjGet("obj_traproom_pincer_"..pincer).pos_x, ObjGet("obj_traproom_pincer_"..pincer).pos_y,
    --  0.9, 3, 0,0
    --});
  
    if  ( ng_global.progress[ "std" ][ "win_traproom" ].grab[pincer] ~= 0 and not(private.check( gear ))) then
      
       common_impl.Lock( true );   
       common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_traproom_release", 0, "", 0 ); 
       AnimPlay( "anm_traproom_pincer_down_"..pincer, "DoAnim", func_after_2 );
    --ObjAnimate( "spr_traproom_pincer_"..pincer.."_right_part_2", "ang", 0, 0, func_after_2,
    --{ 
    --  0.0, 0, ObjGet("spr_traproom_pincer_"..pincer.."_right_part_2").ang, 
    --  0.6, 3, ObjGet("spr_traproom_pincer_"..pincer.."_right_part_2").ang - 0.9
    --});
    --ObjAnimate( "spr_traproom_pincer_"..pincer.."_left_part_2", "ang", 0, 0, "",
    --{ 
    --  0.0, 0, ObjGet("spr_traproom_pincer_"..pincer.."_left_part_2").ang, 
    --  0.6, 3, ObjGet("spr_traproom_pincer_"..pincer.."_left_part_2").ang + 0.9
    --});
   --ObjAnimate( "obj_traproom_pincer_"..pincer, "pos_xy", 0, 0, func_after,
   -- { 
   --   0.0, 0, ObjGet("obj_traproom_pincer_"..pincer).pos_x, ObjGet("obj_traproom_pincer_"..pincer).pos_y,
   --   0.6, 0, ObjGet("obj_traproom_pincer_"..pincer).pos_x, ObjGet("obj_traproom_pincer_"..pincer).pos_y,
   --   0.9, 3, 0,0
   -- });
 end;

end;
--------------------------------------------------------------------------------------------
function private.Turn()
  
  local start_ang = ng_global.progress[ "std" ][ "win_traproom" ].state[4]
  local end_ang = ng_global.progress[ "std" ][ "win_traproom" ].state[4] - 2.0944;
  local bufer = 0;
  
  local func_after = function()

    common_impl.Lock( false );
    ng_global.progress[ "std" ][ "win_traproom" ].state[4] = private.ang_set( end_ang );
    --private.position = { 3, 5, 2};
    --ObjSet( "obj_traproom_center", { ang = private.ang_set( end_ang ) } );
    --bufer = private.flag_grab[1];
    --private.flag_grab[1] = private.flag_grab[3];
    --private.flag_grab[3] = private.flag_grab[2];
    --private.flag_grab[2] = bufer;
    --bufer = ng_global.progress[ "std" ][ "win_traproom" ].grab[1];
    --ng_global.progress[ "std" ][ "win_traproom" ].grab[1] = ng_global.progress[ "std" ][ "win_traproom" ].grab[3];
    --ng_global.progress[ "std" ][ "win_traproom" ].grab[3] = ng_global.progress[ "std" ][ "win_traproom" ].grab[2];
    --ng_global.progress[ "std" ][ "win_traproom" ].grab[2] = bufer;
   
   
  end;
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_traproom_click_central", 0, "", 0 );
  ObjAnimate( "obj_traproom_center", "ang", 0, 0, func_after,
  { 
    0.0, 0, start_ang, 
    0.4, 3, end_ang
  });
  private.Rotate( 1 );
  private.Rotate( 2 );
  private.Rotate( 3 );
  
end;  
--------------------------------------------------------------------------------------------
function private.ang_set( ang )

  if ang < -6.1 then

    ang = 0;

  end;

  return ang;

end;
--------------------------------------------------------------------------------------------
--function private.chip_get( gear )
--  local state = { 3, 5, 2};
--  local chip = 0;
--  
--  if ng_global.progress[ "std" ][ "win_traproom" ].state[ gear ] == 0 then
--    
--    chip = 1;
--    
--  end;
--  if ng_global.progress[ "std" ][ "win_traproom" ].state[ gear ] < private.ang_round[ 5 ] then
--    
--    chip = 5;
--    
--  end;
--  for i = 2, 4  do
--    
--    if ng_global.progress[ "std" ][ "win_traproom" ].state[ gear ] < private.ang_round[ i ] and 
--       ng_global.progress[ "std" ][ "win_traproom" ].state[ gear ] > private.ang_round[ i + 1 ] then
--       
--       chip = i;
--       
--    end;
--     
--  end;
--  
--   return chip;
--
--end;
--------------------------------------------------------------------------------------------
function private.coord_get( gear )
  
  local array = { 0, 0, 0, 0, 0 };
  local index = 0; 
  if gear == 1 then array = ng_global.progress[ "std" ][ "win_traproom" ].round_1; index = 3; end;
  if gear == 2 then array = ng_global.progress[ "std" ][ "win_traproom" ].round_2; index = 5; end;
  if gear == 3 then array = ng_global.progress[ "std" ][ "win_traproom" ].round_3; index = 2; end;
  
  return array[index];
  
  
end;
--------------------------------------------------------------------------------------------
function private.gear_get( pincer )

  local gear = 0;
  
    
  if ng_global.progress[ "std" ][ "win_traproom" ].state[4] == 0 then
      
      gear = pincer; 
 
    end;
    
    if ng_global.progress[ "std" ][ "win_traproom" ].state[4] > -2.1 and ng_global.progress[ "std" ][ "win_traproom" ].state[4] < -2 then
      
      if pincer ~= 3 then gear = pincer + 1
    
      else
 
      gear = 1;
      
      end;
    
    end;
  
  if ng_global.progress[ "std" ][ "win_traproom" ].state[4] > - 4.2 and ng_global.progress[ "std" ][ "win_traproom" ].state[4] < - 4.1 then
      
      if pincer ~= 1 then gear = pincer - 1
    
      else
 
      gear = 3;
      
      end;
    
    end;


  return gear;

end;

function private.turn_array( array )

 local buf = 0;
 local n = 5;
  
 for  i = n, 1, -1  do
    
   if i == n then buf = array[n]
    
    else
    
   array[i+1] = array[i];
   
   end;

 end;
  array[1] = buf; 
  return array;
end;
---------------------------------------------------------------------------------
function private.check( gear )
  
  check  = true;
  local array = { 0, 0, 0, 0, 0};
  
  if gear == 1 then array = ng_global.progress[ "std" ][ "win_traproom" ].round_1;
  
     if array[3] == 0 then check = false;
     
     end;  
  end;
  if gear == 2 then array = ng_global.progress[ "std" ][ "win_traproom" ].round_2; 
  
     if array[5] == 0 then check = false;
     
     end;  
  end;
  if gear == 3 then array = ng_global.progress[ "std" ][ "win_traproom" ].round_3; 
  
     if array[2] == 0 then check = false;
     
     end;
   
  end;
  return check;
end;
---------------------------------------------------------------------------------------------
function private.set_null( gear )
  
   if gear == 1 then ng_global.progress[ "std" ][ "win_traproom" ].round_1[3] = 0; end;
   if gear == 2 then ng_global.progress[ "std" ][ "win_traproom" ].round_2[5] = 0; end;
   if gear == 3 then ng_global.progress[ "std" ][ "win_traproom" ].round_3[2] = 0; end;
     
end;
---------------------------------------------------------------------------------------------
function private.set_chip( gear, pincer )
  
   if gear == 1 then ng_global.progress[ "std" ][ "win_traproom" ].round_1[3] = ng_global.progress[ "std" ][ "win_traproom" ].grab[pincer]; end;
   if gear == 2 then ng_global.progress[ "std" ][ "win_traproom" ].round_2[5] = ng_global.progress[ "std" ][ "win_traproom" ].grab[pincer]; end;
   if gear == 3 then ng_global.progress[ "std" ][ "win_traproom" ].round_3[2] = ng_global.progress[ "std" ][ "win_traproom" ].grab[pincer]; end;
     
end;
---------------------------------------------------------------------------------------------
function private.get_position( gear )
    
     ng_global.progress[ "std" ][ "win_traproom" ].position[gear] = ng_global.progress[ "std" ][ "win_traproom" ].position[gear] - 1; 
     if ng_global.progress[ "std" ][ "win_traproom" ].position[gear] < 1 then ng_global.progress[ "std" ][ "win_traproom" ].position[gear] = 5; end;
     
      
end;
--------------------------------------------------------------------------------------------
function private.check_win()
  win = false;
  win_count = 1;
  for  i = 1, 5  do
    
    if ng_global.progress[ "std" ][ "win_traproom" ].round_1[i] < 6 and ng_global.progress[ "std" ][ "win_traproom" ].round_1[i] ~= 0 then win_count = win_count + 1; end;
    if ng_global.progress[ "std" ][ "win_traproom" ].round_2[i] < 11 and ng_global.progress[ "std" ][ "win_traproom" ].round_2[i] > 5 then win_count = win_count + 1;end;
    if ng_global.progress[ "std" ][ "win_traproom" ].round_3[i] > 10  then win_count = win_count + 1;end;
    
  end;
  DbgTrace(win_count);
 if win_count == 15 then win = true; end;
 return win;
 
end; 
---------------------------------------------------------------------------------------------
function private.start_chip()
--первое колесо
   ObjAttach("spr_traproom_round_chip_6","obj_traproom_round_1_chip");
   ObjAttach("spr_traproom_round_chip_15","obj_traproom_round_1_chip");
   ObjAttach("spr_traproom_round_chip_4","obj_traproom_round_1_chip");
   ObjAttach("spr_traproom_round_chip_3","obj_traproom_round_1_chip");
   ObjAttach("spr_traproom_round_chip_12","obj_traproom_round_1_chip");
   ObjSet( "spr_traproom_round_chip_6", { pos_x = 45 , pos_y = -49  } );
   ObjSet( "spr_traproom_round_chip_15", { pos_x = 62 , pos_y = 30, ang = -1.15 } );
   ObjSet( "spr_traproom_round_chip_4", { pos_x = -8 , pos_y = 70, ang = -2.54} );
   ObjSet( "spr_traproom_round_chip_3", { pos_x = -69 , pos_y = 17, ang = 2.39} );
   ObjSet( "spr_traproom_round_chip_12", { pos_x = -35 , pos_y = -54, ang = 1.23 } );
  --второе колесо
   ObjAttach("spr_traproom_round_chip_1","obj_traproom_round_2_chip");
   ObjAttach("spr_traproom_round_chip_13","obj_traproom_round_2_chip");
   ObjAttach("spr_traproom_round_chip_2","obj_traproom_round_2_chip");
   ObjAttach("spr_traproom_round_chip_8","obj_traproom_round_2_chip");
   ObjAttach("spr_traproom_round_chip_7","obj_traproom_round_2_chip");
   ObjSet( "spr_traproom_round_chip_1", { pos_x = 15 , pos_y = -63  } );
   ObjSet( "spr_traproom_round_chip_13", { pos_x = 65 , pos_y = -3, ang = -1.12 } );
   ObjSet( "spr_traproom_round_chip_2", { pos_x = 26 , pos_y = 63, ang = -2.53} );
   ObjSet( "spr_traproom_round_chip_8", { pos_x = -50 , pos_y = 47, ang = 2.49} );
   ObjSet( "spr_traproom_round_chip_7", { pos_x = -57 , pos_y = -30, ang = 1.29 } );
--третье колесо
   ObjAttach("spr_traproom_round_chip_10","obj_traproom_round_3_chip");
   ObjAttach("spr_traproom_round_chip_9","obj_traproom_round_3_chip");
   ObjAttach("spr_traproom_round_chip_11","obj_traproom_round_3_chip");
   ObjAttach("spr_traproom_round_chip_14","obj_traproom_round_3_chip");
   ObjAttach("spr_traproom_round_chip_5","obj_traproom_round_3_chip");
   ObjSet( "spr_traproom_round_chip_10", { pos_x = -6 , pos_y = -63  } );
   ObjSet( "spr_traproom_round_chip_9", { pos_x = 60 , pos_y = -27, ang = -1.32 } );
   ObjSet( "spr_traproom_round_chip_11", { pos_x = 44 , pos_y = 50, ang = -2.5} );
   ObjSet( "spr_traproom_round_chip_14", { pos_x = -31 , pos_y = 58, ang = 2.65} );
   ObjSet( "spr_traproom_round_chip_5", { pos_x = -60 , pos_y = -10, ang = 1.35 } );   

end;  
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  
  private.start_chip();
  ng_global.progress[ "std" ][ "win_traproom" ].state = {0, 0, 0, 0};
  ng_global.progress[ "std" ][ "win_traproom" ].round_1 = { 6, 15, 4, 3, 12};
  ng_global.progress[ "std" ][ "win_traproom" ].round_2 = { 1, 13, 2, 8, 7};
  ng_global.progress[ "std" ][ "win_traproom" ].round_3 = { 10, 9, 11, 14, 5};
  ng_global.progress[ "std" ][ "win_traproom" ].grab = {0, 0, 0};
  ng_global.progress[ "std" ][ "win_traproom" ].position = { 3, 5, 2 };
  ObjSet("obj_traproom_center", { ang = 0 });
  ObjSet("obj_traproom_round_1_chip", { ang = 0 });
  ObjSet("obj_traproom_round_2_chip", { ang = 0 });
  ObjSet("obj_traproom_round_3_chip", { ang = 0 });
  ObjSet( "spr_traproom_pincer_1_right_part_2", { ang = -0.62 });
  ObjSet( "spr_traproom_pincer_2_right_part_2", { ang = -0.62 });
  ObjSet( "spr_traproom_pincer_3_right_part_2", { ang = -0.62 });
  ObjSet( "spr_traproom_pincer_1_left_part_2", { ang = 0.62 });
  ObjSet( "spr_traproom_pincer_2_left_part_2", { ang = 0.62 });
  ObjSet( "spr_traproom_pincer_3_left_part_2", { ang = 0.62 });
end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   

  cmn.MiniGameHide();
   common_impl.Lock( false );
  common_impl.PassingMgWin();
  cmn.SetEventDone( "win_traproom" );
  cmn.CallEventHandler( "win_traproom" );

  cmn.GotoRoom( "rm_corridor" );

end;
--*********************************************************************************************************************
function private.Win()

  local func_after = function ()
  
    private.WinEnd();
    
    
  end;
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_traproom_win", 0, "", 0 );
  common_impl.Lock( true );
  for i = 1, 3  do
    
    ObjAnimate( "obj_traproom_round_"..i.."_chip", "ang", 0, 0, func_after,
    { 
    0.0, 0, ObjGet("obj_traproom_round_"..i.."_chip").ang, 
    1.4, 3, ObjGet("obj_traproom_round_"..i.."_chip").ang - 28.0
    });
    func_after = ""; 
  end;
  

end;
--*********************************************************************************************************************
function private.ButtonMouseEnter ( but_name )

  common_impl.SetCursor( CURSOR_HAND );

  local obj = "spr_traproom_round_"..but_name.."_btn_add";

  if ( not ObjGet( obj ) ) then return; end;

  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

  --common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );

end;
--******************************************************************************************
function private.ButtonMouseLeave ( but_name )

  common_impl.SetCursor( CURSOR_DEFAULT );

  local obj = "spr_traproom_round_"..but_name.."_btn_add";

  if ( not ObjGet( obj ) ) then return; end;

  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.EnterCenter ( i )

  common_impl.SetCursor( CURSOR_HAND );

  local obj = "spr_traproom_btn_center_"..i.."_add";

  if ( not ObjGet( obj ) ) then return; end;

  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

  --common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );

end;
--******************************************************************************************
function private.LeaveCenter ( i )

  common_impl.SetCursor( CURSOR_DEFAULT );

  local obj = "spr_traproom_btn_center_"..i.."_add";

  if ( not ObjGet( obj ) ) then return; end;

  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.Enter (  )

  common_impl.SetCursor( CURSOR_HAND );

  local obj = "spr_traproom_btn_center_add";

  if ( not ObjGet( obj ) ) then return; end;

  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

  --common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );

end;
--******************************************************************************************
function private.Leave (  )

  common_impl.SetCursor( CURSOR_DEFAULT );

  local obj = "spr_traproom_btn_center_add";

  if ( not ObjGet( obj ) ) then return; end;

  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;