-- name=mg_superpuzzle_2
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_superpuzzle_2";
  
  ObjMultiSet({ 
  { "spr_superpuzzle_2_coldsource", { event_mdown = private.get_coldsource }},
  });
  private.mmg2_el_type = {  { 1 },
                            { 1, 1, 1}, 
                            { 1, -1, 0, 0, 1},
                            { 1, -1, 0, -1, -1 },
                            { 1, -1, 0, 1, 0 },
                            { 1,1,1 },
                            };

  private.mmg4_winmas = { 3,2,1,6,5,4,9,8,7 };
  private.mmg4_winmas2 = { 5,6,1,3,9,7,8,2,4 };
  private.anim_static = false;
  private.curent_anim = 1;
  private.anim = { "1", "2_return", "3", "1_return", "2", "3_return" };
  
  for i = 1,5 do
    
    for j = 1,#private.mmg2_el_type[i] do
      
      ObjSet( "spr_superpuzzle_2_mg_2_circle_"..i.."_"..j, {
      event_mdown = function() private.mmg2_clk( i, j ) end,
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      } )
    
    end;
  
  end;

  local table_multiset = {};
  for i = 1, 3 do

    table.insert( table_multiset, {"spr_superpuzzle_2_mg_3_circle_"..i.."_add", 
       {
         event_mdown =  function() private.mmg3_clk_circle( i ) common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_superpuzzle_2_flowers_rotate", 0, "", 0 ); end,
          event_menter = function() private.ButtonMouseEnter ( "spr_superpuzzle_2_mg_3_circle_"..i.."_add" ); end ,
         event_mleave = function() private.ButtonMouseLeave ( "spr_superpuzzle_2_mg_3_circle_"..i.."_add" ) end
       }
    } );

  end; 
  for i = 1, 2 do

    table.insert( table_multiset, {"obj_superpuzzle_2_mg_3_clk_arrow_"..i, 
       {
         event_mdown =  function() private.mmg3_change( i, 3 ) common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_superpuzzle_2_flowers_move", 0, "", 0 ); end,
       event_menter = function() private.ButtonMouseEnter ( "obj_superpuzzle_2_mg_3_arrows_"..i ) end ,
       event_mleave = function() private.ButtonMouseLeave ( "obj_superpuzzle_2_mg_3_arrows_"..i ) end
       }
    } );

    

  end; 
  for i = 1,9 do
    table.insert( table_multiset, {"spr_superpuzzle_2_mg_6_button_"..i, 
       {
       drag = true,
       event_startdrag =  function() private.mmg6_StartDrag( i ) end,
       event_dragdrop =  function() private.mmg6_DropDrag() end,
       event_menter = function() common_impl.SetCursor( CURSOR_GET ) end ,
       event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end
       }
    } );
    
    table.insert( table_multiset, {"spr_superpuzzle_2_mg_4_button_"..i, 
       {
       drag = true,
       event_startdrag =  function() private.mmg4_StartDrag( i ) end,
       event_dragdrop =  function() private.mmg4_DropDrag() end,
       event_menter = function() common_impl.SetCursor( CURSOR_GET ) end ,
       event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end
       }
    } );
  end;
  
  
  for i = 2, 6 do

    table.insert( table_multiset, {"obj_superpuzzle_2_gate_"..i, 
       {
       event_mdown =  function() private.GotoMmg( i ) end,
       event_menter = function() common_impl.SetCursor( CURSOR_LOUPE ) end ,
       event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end
       }
    } );
    table.insert( table_multiset, {"obj_superpuzzle_2_gate_"..i.."_back", 
       {
       event_mdown =  function() private.LeaveMmg( i ) end,
       event_menter = function() common_impl.SetCursor( CURSOR_DOWN ) end ,
       event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end
       }
    } );
  end;
  
  table.insert( table_multiset, { "spr_superpuzzle_2_puzzlehelp", 
  {
    event_mdown =  function() private.PuszzleHintClk("spr_superpuzzle_2_puzzlehelp") end,
    event_menter = function() private.ButtonMouseEnter("spr_superpuzzle_2_puzzlehelp_add") end ,
    event_mleave = function() private.ButtonMouseLeave("spr_superpuzzle_2_puzzlehelp_add") end
  }
  });
  table.insert( table_multiset, { "spr_superpuzzle_2_mg_2_puzzlehelp", 
  {
    event_mdown =  function() private.PuszzleHintClk("spr_superpuzzle_2_mg_2_puzzlehelp") end,
    event_menter = function() private.ButtonMouseEnter("spr_superpuzzle_2_mg_2_puzzlehelp_add") end ,
    event_mleave = function() private.ButtonMouseLeave("spr_superpuzzle_2_mg_2_puzzlehelp_add") end
  }
  });
  table.insert( table_multiset, { "spr_superpuzzle_2_mg_3_puzzlehelp", 
  {
    event_mdown =  function() private.PuszzleHintClk("spr_superpuzzle_2_mg_3_puzzlehelp") end,
    event_menter = function() private.ButtonMouseEnter("spr_superpuzzle_2_mg_3_puzzlehelp_add") end ,
    event_mleave = function() private.ButtonMouseLeave("spr_superpuzzle_2_mg_3_puzzlehelp_add") end
  }
  });
  table.insert( table_multiset, { "spr_superpuzzle_2_mg_4_puzzlehelp", 
  {
    event_mdown =  function() private.PuszzleHintClk("spr_superpuzzle_2_mg_4_puzzlehelp") end,
    event_menter = function() private.ButtonMouseEnter("spr_superpuzzle_2_mg_4_puzzlehelp_add") end ,
    event_mleave = function() private.ButtonMouseLeave("spr_superpuzzle_2_mg_4_puzzlehelp_add") end
  }
  });
  table.insert( table_multiset, { "spr_superpuzzle_2_mg_6_puzzlehelp", 
  {
    event_mdown =  function() private.PuszzleHintClk("spr_superpuzzle_2_mg_6_puzzlehelp") end,
    event_menter = function() private.ButtonMouseEnter("spr_superpuzzle_2_mg_6_puzzlehelp_add") end ,
    event_mleave = function() private.ButtonMouseLeave("spr_superpuzzle_2_mg_6_puzzlehelp_add") end
  }
  });
  
  ObjMultiSet( table_multiset );

  ObjSet( "spr_superpuzzle_2_mg_5_point_1", { event_mdown = function() private.mmg5_rotate( 1 ) end });
    
  --------------------------------------------------------------------------------------------
  -- function get_coldsource () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_coldsource" ] = {
    type = "get",
    get_obj = "spr_superpuzzle_2_coldsource",
    room = "rm_groundfloor",
    zz = "mg_superpuzzle_2",
    zz_gate = "gzz_groundfloor_superpuzzle_2"
  };
    
  local get_coldsource_inv = function ()
  
    interface.InventoryItemAdd( "inv_coldsource", "spr_superpuzzle_2_coldsource" );
  
  end;
  
  local get_coldsource_closezz = function ()
  
    ObjDelete( "gfx_superpuzzle_2_coldsource" );
    --ObjDelete( "gzz_superpuzzle_2_superpuzzle_2" );
  
  end;
  
  cmn.AddSubscriber( "get_coldsource", get_coldsource_inv );
  cmn.AddSubscriber( "get_coldsource", get_coldsource_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_superpuzzle_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_superpuzzle_2" ] = {
    type = "win",
    room = "rm_groundfloor",
    zz = "mg_superpuzzle_2",
    zz_gate = "gmg_groundfloor_superpuzzle_2"
  };
  local win_superpuzzle_2 = function ()

    if ( cmn.IsEventDone( "win_superpuzzle_2" ) ) then  

    else

     --mmg2
     for i = 1,6 do
       for j = 1,#ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg2_state do
         if ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg2_state[i][j] then
           ObjSet( "spr_superpuzzle_2_mg_2_circle_"..i.."_"..j, { input = true, alp = 1 } );
         end;
       end;
     end;
     --mmg3
     for i = 1,15 do
       circle = math.ceil((i-0.2)/5);
       ObjAttach( "spr_superpuzzle_2_mg_3_part_"..ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg3_state[i], "obj_superpuzzle_2_mg_3_circle_"..circle.."_"..(i-1)%5+1 );
     end;
     --mmg4
     for i = 1,9 do
       ObjAttach( "spr_superpuzzle_2_mg_4_button_"..i, "obj_superpuzzle_2_mg_4_slot_"..ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg4_state[i])
     end;
     --mmg5
     --mmg6
     for i = 1,9 do
       ObjAttach( "spr_superpuzzle_2_mg_6_button_"..i, "obj_superpuzzle_2_mg_6_button_"..ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg6_state[i]);
     end;

    for i = 1,6 do
      if ng_global.progress[ "std" ][ "win_superpuzzle_2" ].state[i] then
        
        ObjSet( "obj_superpuzzle_2_gate_2", { input = false } );
        ObjSet( "obj_superpuzzle_2_mmg_"..i.."_light", { alp = 0 } );
        
      end;
    end;
    
    end;
    if ng_global.progress[ "std" ][ "win_superpuzzle_2" ].state[2] then
      
        ObjSet( "obj_superpuzzle_2_room", { input = true });
        ObjSet( "obj_superpuzzle_2_mg_2", { input = false });
        ObjSet( "obj_superpuzzle_2_gate_2", { input = false });
        ObjSet( "obj_superpuzzle_2_gate_4", { input = true });
        ObjSet( "anm_superpuzzle_2_block_4", { frame = 46 });
        ObjSet( "anm_superpuzzle_2_block_2", { alp = 0 });
        ObjSet( "spr_superpuzzle_2_block_2", { alp = 1 });
        
    end;
    if ng_global.progress[ "std" ][ "win_superpuzzle_2" ].state[3] then
      
        ObjSet( "obj_superpuzzle_2_room", { input = true });
        ObjSet( "obj_superpuzzle_2_mg_3", { input = false });
        ObjSet( "obj_superpuzzle_2_gate_3", { input = false });
        ObjSet( "obj_superpuzzle_2_gate_2", { input = true });
        ObjSet( "anm_superpuzzle_2_block_2", { frame = 45 });
        --ObjSet( "anm_superpuzzle_2_block_3", { alp = 0 });
        --ObjSet( "spr_superpuzzle_2_block_3", { alp = 1 });
    end;
    if ng_global.progress[ "std" ][ "win_superpuzzle_2" ].state[4] then
      
        ObjSet( "obj_superpuzzle_2_room", { input = true });
        ObjSet( "obj_superpuzzle_2_mg_4", { input = false });
        ObjSet( "obj_superpuzzle_2_gate_4", { input = false });
        ObjSet( "obj_superpuzzle_2_gate_6", { input = true });
        ObjSet( "anm_superpuzzle_2_block_6", { frame = 45 });
        ObjSet( "anm_superpuzzle_2_block_4", { alp = 0 });
        ObjSet( "spr_superpuzzle_2_block_4", { alp = 1 });
    
    end;
    if ng_global.progress[ "std" ][ "win_superpuzzle_2" ].state[6] then -- последняя мг
      
      ObjSet( "obj_superpuzzle_2_room", { input = true });
      ObjSet( "obj_superpuzzle_2_mg_6", { input = false });
      ObjSet( "obj_superpuzzle_2_gate_6", { input = false });
      ObjSet( "anm_superpuzzle_2_block_6", { alp = 0 });
      ObjSet( "spr_superpuzzle_2_block_6", { alp = 1 });
      
    end;
  
  end;

  cmn.AddSubscriber( "win_superpuzzle_2", win_superpuzzle_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_groundfloor_coldsource () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_groundfloor_coldsource" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_groundfloor_coldsource",
    
  };
  local vid_groundfloor_coldsource_end = function ()
  
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_groundfloor_coldsource", vid_groundfloor_coldsource_end, private.room_objname  );
  cmn.AddSubscriber( "vid_groundfloor_coldsource_end", vid_groundfloor_coldsource_end, private.room_objname  );
  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_superpuzzle_2" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  private.AnimStart ();
  if ( not cmn.IsEventStart( "win_superpuzzle_2" ) ) then
    ng_global.progress[ "std" ][ "win_superpuzzle_2" ].state = { true, false, false, false, true, false };
    ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg2_state = {  { true },
                            { false, false, false}, 
                            { false, false, false, false, false},
                            { false, false, false, false, false},
                            { false, false, false, false, false },
                            { false, false, false }
                         };
    ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg3_state = { 7, 11, 3, 10, 15, 6, 1, 14, 12, 4, 2, 9, 13, 8, 5 }
    ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg4_state = { 1,2,3,4,5,6,7,8,9 };
    ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg6_state = { 1,2,3,4,5,6,7,8,9 };
    --mmg2
     for i = 1,6 do
       for j = 1,#ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg2_state do
         if ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg2_state[i][j] then
           ObjSet( "spr_superpuzzle_2_mg_2_circle_"..i.."_"..j, { input = true, alp = 1 } );
         end;
       end;
     end;
     --mmg3
     for i = 1,15 do
       circle = math.ceil((i-0.2)/5);
       ObjAttach( "spr_superpuzzle_2_mg_3_part_"..ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg3_state[i], "obj_superpuzzle_2_mg_3_circle_"..circle.."_"..(i-1)%5+1 );
    end;
    ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( private.room_objname ) ].puzzle_num = 3;
    
  end;
   
  private.CheckWinSp();
  common_impl.PlayAudio( "env", "common/audio/level2/aud_mg_superpuzzle_2_env", 1, "", 0 );
  
  --common_impl.PlayAudio( "mus", "common/audio/aud_enigma_mus", 0, "", 0 );
  
end;
--*********************************************************************************************************************
function public.Close()
  
  --common_impl.StopAudio( "mus", "common/audio/aud_enigma_mus", 0.5 );
  common_impl.StopAudio( "env", "common/audio/level2/aud_mg_superpuzzle_2_env", 0.5 );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_superpuzzle_2" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_coldsource()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  ObjSet( "spr_superpuzzle_2_coldsource", { alp = 1 } );
  ObjSet( "anm_superpuzzle_2_coldsource", { alp = 0 } );
  cmn.SetEventDone( "get_coldsource" );
  cmn.CallEventHandler( "get_coldsource" );

end;
--*********************************************************************************************************************
-- function *** MMG2 *** () end;
--*********************************************************************************************************************
  function private.mmg2_clk( circle, number )
    
    if circle ~= 1 then
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_superpuzzle_2_circle_click", 0, "", 0 );
    else
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_superpuzzle_2_circle_button", 0, "", 0 );
    end;
    common_impl.Lock( true );
    
    if private.mmg2_el_type[ circle ][ number ] == -1 or private.mmg2_el_type[ circle ][ number ] == 0 then

      for i = 1, #private.mmg2_el_type[ circle-1 ] do

        if common.ApplyObj( "spr_superpuzzle_2_mg_2_circle_"..circle.."_"..number, "spr_superpuzzle_2_mg_2_circle_"..(circle-1).."_"..i  ) then
          
          local anim_1_after = function()
          
            ObjSet( "spr_superpuzzle_2_mg_2_circle_"..(circle-1).."_"..i, { input = true } )
            ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg2_state[circle-1][i] = true;
          
          end;
          
          ObjAnimate( "spr_superpuzzle_2_mg_2_circle_"..(circle-1).."_"..i, "alp",0,0,anim_1_after,
          {
            0.0, 0, 0.0, 
            0.2, 0, 1.0
          });
          
        end;
        
      end;
      
    end;
    if private.mmg2_el_type[ circle ][ number ] == 1 or private.mmg2_el_type[ circle ][ number ] == 0 then

      for i = 1, #private.mmg2_el_type[ circle+1 ] do
        
        if common.ApplyObj( "spr_superpuzzle_2_mg_2_circle_"..circle.."_"..number,"spr_superpuzzle_2_mg_2_circle_"..(circle+1).."_"..i  ) then
          
          local anim_2_after = function()
          
            ObjSet( "spr_superpuzzle_2_mg_2_circle_"..(circle+1).."_"..i, { input = true } )
            ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg2_state[circle+1][i] = true;
            
          end;
          
          if circle+1 == 6 then 
            
            common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_superpuzzle_2_circle_lamp", 0, "", 0 );
            
          end;
          ObjAnimate( "spr_superpuzzle_2_mg_2_circle_"..(circle+1).."_"..i, "alp",0,0,anim_2_after,
          {
            0.0, 0, 0.0, 
            0.2, 0, 1.0
          });
          
        end;
        
      end; 
      
    end;
    
    --if ( tostring( circle ) ~= tostring( 1 ) )  then
    local func_after = function()

      local win = true;
      for i = 1,3 do
        
        if ObjGet( "spr_superpuzzle_2_mg_2_circle_6_"..i ).alp ~= 1 then
          
          win = false;
          
        end;
        
      end;
      
      if win then
        
        ObjSet( "spr_superpuzzle_2_mg_2_circle_6_1", { input = false } )
        private.mmg2_win()
        
      else
        
        ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg2_state[circle][number] = false;
        private.mmg2_check();
        
      end;

    end;
         
    ObjSet( "spr_superpuzzle_2_mg_2_circle_"..circle.."_"..number, { input = false } )
    ObjAnimate( "spr_superpuzzle_2_mg_2_circle_"..circle.."_"..number, "alp",0,0,func_after,
    {
     0.0, 0, 1.0, 
     0.25, 0, 0.0
    });
    
  end;

  function private.mmg2_win()

    local light_after = function()
    
      local anim_open = function()
     
        local func_after = function()

          common_impl.Lock( false );
          ObjSet( "obj_superpuzzle_2_room", { input = true });
          ObjSet( "obj_superpuzzle_2_mg_2", { input = false });
          ObjSet( "obj_superpuzzle_2_gate_2", { input = false });
          ObjSet( "obj_superpuzzle_2_gate_4", { input = true });
          
          private.CheckWinSp();
          ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( private.room_objname ) ].puzzle_num = 4;
        
        end;
        
        common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_superpuzzle_2_part_win", 0 );   
        AnimPlay( "anm_superpuzzle_2_block_4", "DoAnim", func_after );
        
      end;
      
      ObjSet( "anm_superpuzzle_2_block_2", { alp = 0 });
      ObjSet( "spr_superpuzzle_2_block_2", { alp = 1 });

      ng_global.progress[ "std" ][ "win_superpuzzle_2" ].state[2] = true;
      common_impl.Lock( true );
      ObjAnimate( "obj_superpuzzle_2_mg_2", "alp",0,0, anim_open,
      {
      0.0, 0, 1, 
      0.3, 0, 0
      });
      
    end;
    
    ObjAnimate( "spr_superpuzzle_2_mg_2_light_red", "alp",0,0, light_after,
    {
      0.0, 0, 1, 
      0.3, 0, 0
    });
    ObjAnimate( "spr_superpuzzle_2_mg_2_light_green", "alp",0,0, "",
    {
      0.0, 0, 0, 
      0.3, 0, 1
    });    
  
  end;
  function private.mmg2_check()
    
    common_impl.Lock( false );
    local reset = true;
    for i = 1,5 do
      
      for j = 1,#private.mmg2_el_type[i] do
        
        if  ( ObjGet( "spr_superpuzzle_2_mg_2_circle_"..i.."_"..j ).input == true ) then
          
          reset = false;
          break;
          
        end;
    
      end;
        
    end;
    
    if reset then
      DbgTrace( "Reset" );
      private.mmg2_reset();
    end;
  
  end;
  
  function private.mmg2_reset()
      
    for i = 2,5 do
      
      for j = 1,#private.mmg2_el_type[i] do
        
        ObjSet( "spr_superpuzzle_2_mg_2_circle_"..i.."_"..j, {
          alp = 0, input = false;
        } );
      
      end;
    
    end;
    
    for i = 1,3 do
    
        ObjSet( "spr_superpuzzle_2_mg_2_circle_6_"..i, {
        input = false, alp = 0
        } );
      
    end;
      
    ObjSet( "spr_superpuzzle_2_mg_2_circle_1_1", {
    input = true;
    } );
    
  end;
  
  function public.SkipPuzzle2()
    
    private.mmg2_win();
    
    ng_global.progress[ "std" ][ "win_superpuzzle_2" ].puzzletimer = 1;
    interface.PuzzleHelpReload( 1 );
    interface.PuzzleHelpHide();
    ObjSet( "tmr_superpuzzle_2_skip", { playing = false } );
    
  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG3 *** () end;
--*********************************************************************************************************************
  function private.mmg3_clk_circle( number )
    
    local obj = "obj_superpuzzle_2_mg_3_circle_"..number
    
    local func_after = function()

      common_impl.Lock( false );
      if ObjGet( obj ).ang < -6.27 then
        ObjSet( obj, { ang = 0 } );
      end;
    
    end;
    
    common_impl.Lock( true );
    ObjAnimate( obj, "ang",0,0,func_after,
    {
    0.0, 0, ObjGet( obj ).ang, 
    0.4, 0, ObjGet( obj ).ang - 1.256
    });
  
  end;
  function private.mmg3_change( number1, number2 )
    
    local ang_step = 1.256
    local saves = ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg3_state;
    local obj1 = "obj_superpuzzle_2_mg_3_circle_"..number1
    local obj2 = "obj_superpuzzle_2_mg_3_circle_"..number2
    local el1_pos = math.abs(math.ceil(((ObjGet( obj1 ).ang-0.2)/ang_step))) +1;
    local el2_pos = math.abs(math.ceil(((ObjGet( obj2 ).ang-0.2)/ang_step))) +1;

    if number1 == 1 then
      if el2_pos == 1 then
        el2_pos = 5;
      else
        el2_pos = el2_pos - 1;
      end;
    end;
    local el1_number = saves[( number1 - 1 ) * 5 + el1_pos];
    local el2_number = saves[( number2 - 1 ) * 5 + el2_pos];
    local el1_name = "spr_superpuzzle_2_mg_3_part_"..el1_number;
    local el2_name = "spr_superpuzzle_2_mg_3_part_"..el2_number;
    
    local change_after = function()

      ObjSet( el1_name, { drawoff_y = -78 } )
      ObjSet( el2_name, { drawoff_y = -78 } )
      local func_after = function()
      
        common_impl.Lock( false );
        ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg3_state[( number1 - 1 ) * 5 + el1_pos] = el2_number;
        ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg3_state[( number2 - 1 ) * 5 + el2_pos] = el1_number;      
        private.mmg3_checkwin()
        
      end;
      common_impl.Lock( true );
      ObjAttach( el1_name, obj2.."_"..el2_pos);
      ObjAttach( el2_name, obj1.."_"..el1_pos);
      --ObjAnimate( el1_name, "alp",0,0,func_after,
      --{
      --0.0, 0, 0, 
      --0.4, 0, 1
      --});
      --ObjAnimate( el2_name, "alp",0,0, "",
      --{
      --0.0, 0, 0, 
      --0.4, 0, 1
      --});
      func_after();
      
    end;
    
    common_impl.Lock( true );
    ObjSet( el1_name, { drawoff_y = 0 } )
    ObjSet( el2_name, { drawoff_y = 0 } )
    
    if number1 == 1 then
      
    ObjAttach( el1_name, "obj_superpuzzle_2_mg_3_traposrt_1_3" );
    ObjAttach( el2_name, "obj_superpuzzle_2_mg_3_traposrt_3_1" );
      private.AnimChange_1_3( change_after );
      private.AnimChange_3_1();
      
    else 
      
      ObjAttach( el1_name, "obj_superpuzzle_2_mg_3_traposrt_2_3" );
      ObjAttach( el2_name, "obj_superpuzzle_2_mg_3_traposrt_3_2" );
      private.AnimChange_2_3( change_after );
      private.AnimChange_3_2();  
    
    end;  
    --ObjAnimate( el1_name, "alp",0,0,change_after,
    --{
    --0.0, 0, 1, 
    --0.4, 0, 0
    --});
    --ObjAnimate( el2_name, "alp",0,0, "",
    --{
    --0.0, 0, 1, 
    --0.4, 0, 0
    --});
  
  end;
  function private.mmg3_checkwin()
  
    flag = true;
    for i = 1,15 do
      if ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg3_state[i]/5 > math.ceil(i/5) then
        flag = false;
      end;
    end;
    if flag then
      private.mmg3_win()
    end;
    
  end;
  function private.mmg3_win()
    
    local anim_open = function()
    
      local func_after = function()

        common_impl.Lock( false );
        ObjSet( "obj_superpuzzle_2_room", { input = true });
        ObjSet( "obj_superpuzzle_2_mg_3", { input = false });
        ObjSet( "obj_superpuzzle_2_gate_3", { input = false });
        ObjSet( "obj_superpuzzle_2_gate_2", { input = true });
        ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( private.room_objname ) ].puzzle_num = 2;
        private.CheckWinSp();
      
      end;
      
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_superpuzzle_2_part_win", 0 );   
      AnimPlay( "anm_superpuzzle_2_block_2", "DoAnim", func_after );
      
    end;

    ng_global.progress[ "std" ][ "win_superpuzzle_2" ].state[3] = true;
    common_impl.Lock( true );
    ObjAnimate( "obj_superpuzzle_2_mg_3", "alp",0,0, anim_open,
    {
    0.0, 0, 1, 
    0.3, 0, 0
    });
  
  end;
  
  function private.mmg3_reset()
    
    ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg3_state = { 7, 11, 3, 10, 15, 6, 1, 14, 12, 4, 2, 9, 13, 8, 5 }
    for i = 1,15 do
      circle = math.ceil((i-0.2)/5);
      ObjAttach( "spr_superpuzzle_2_mg_3_part_"..ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg3_state[i], "obj_superpuzzle_2_mg_3_circle_"..circle.."_"..(i-1)%5+1 );
    end;
    
  end;
  function public.SkipPuzzle3( )
    
    private.mmg3_win();
    ng_global.progress[ "std" ][ "win_superpuzzle_2" ].puzzletimer = 1;
    interface.PuzzleHelpReload( 1 );
    interface.PuzzleHelpHide();
    ObjSet( "tmr_superpuzzle_2_skip", { playing = false } );
    
  end;
  function private.AnimChange_1_3( func_after )
    
    ObjAnimate( "obj_superpuzzle_2_mg_3_traposrt_1_3", "pos_xy",0,0, func_after,
    {
      0.0, 0, -144, -79,
      0.4, 0, -80, -79,
      0.8, 0, -42, -150
    });
    ObjAnimate( "obj_superpuzzle_2_mg_3_traposrt_1_3", "ang",0,0, "",
    {
    0.0, 0, 0, 
    0.8, 0, 2.512
    });
    
  end;
  function private.AnimChange_3_1()
    
    ObjAnimate( "obj_superpuzzle_2_mg_3_traposrt_3_1", "pos_xy",0,0, func_after,
    {
      0.0, 0, -42, -150,
      0.4, 0, -110, -150,
      0.8, 0, -144, -79 
    });
    ObjAnimate( "obj_superpuzzle_2_mg_3_traposrt_3_1", "ang",0,0, "",
    {
    0.0, 0, 2.512, 
    0.8, 0, 0
    });
    
  end;
  
  function private.AnimChange_3_2()
    
    ObjAnimate( "obj_superpuzzle_2_mg_3_traposrt_3_2", "pos_xy",0,0, "",
    {
      0.0, 0, 50, -150,
      0.4, 0, 110, -150,
      0.8, 0, 144, -79 
    });
    ObjAnimate( "obj_superpuzzle_2_mg_3_traposrt_3_2", "ang",0,0, "",
    {
    0.0, 0, -2.512, 
    0.8, 0, 0
    });
    
  end;
  
  function private.AnimChange_2_3( func_after )
    
    ObjAnimate( "obj_superpuzzle_2_mg_3_traposrt_2_3", "pos_xy",0,0, func_after,
    {
      0.0, 0, 144, -79,
      0.4, 0, 80, -79,
      0.8, 0, 50, -150
    });
    ObjAnimate( "obj_superpuzzle_2_mg_3_traposrt_2_3", "ang",0,0, "",
    {
    0.0, 0, 0, 
    0.8, 0, -2.512
    });
    
  end;
--*********************************************************************************************************************
-- function *** MMG4 *** () end;
--*********************************************************************************************************************
  function private.mmg4_StartDrag( number )
    
    
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_superpuzzle_2_typewriter_get", 0 );
    private.mmg4_drag = number;
    ObjSet( "obj_superpuzzle_2_mg_4_slot_"..ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg4_state[number], { pos_z = 3 } );
    
  end;
  
  function private.mmg4_DropDrag()
    
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_superpuzzle_2_typewriter_set", 0 );
    ObjSet( "obj_superpuzzle_2_mg_4_slot_"..ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg4_state[private.mmg4_drag], { pos_z = 0 } );
    for i = 1,9 do
      if ((private.mmg4_drag ~=i) and (common.ApplyObj( "obj_superpuzzle_2_mg_4_button_"..private.mmg4_drag.."_apply", "obj_superpuzzle_2_mg_4_button_"..i.."_apply", false ))) then
        
        ObjAttach( "spr_superpuzzle_2_mg_4_button_"..private.mmg4_drag, "obj_superpuzzle_2_mg_4_slot_"..ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg4_state[i])
        ObjAttach( "spr_superpuzzle_2_mg_4_button_"..i, "obj_superpuzzle_2_mg_4_slot_"..ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg4_state[private.mmg4_drag])
        local temp_pos = ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg4_state[private.mmg4_drag];
        ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg4_state[private.mmg4_drag] = ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg4_state[i]
        ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg4_state[i] = temp_pos;
        private.mmg4_checkwin();
        
        break;
        
      end;
    end;
    
  end;
  
  function private.mmg4_checkwin()
    
    local flag = true;
    local flag2 = true;
    for i =1,9 do
      if ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg4_state[i] ~= private.mmg4_winmas[i] then
        flag = false;
      end;
    end;
    for i =1,9 do
      if ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg4_state[i] ~= private.mmg4_winmas2[i] then
        flag2 = false;
      end;
    end;
    if flag or flag2 then
      ng_global.progress[ "std" ][ "win_superpuzzle_2" ].state[4] = true;
      private.mmg4_win();
    end;  
    
  end;
  function private.mmg4_win()
    
    local anim_light = function()
    
      local anim_open = function()
      
        local func_after = function()

          common_impl.Lock( false );
          ObjSet( "obj_superpuzzle_2_room", { input = true });
          ObjSet( "obj_superpuzzle_2_mg_4", { input = false });
          ObjSet( "obj_superpuzzle_2_gate_4", { input = false });
          ObjSet( "obj_superpuzzle_2_gate_6", { input = true });
          ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( private.room_objname ) ].puzzle_num = 6;
          private.CheckWinSp();
        
        end;
        
        common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_superpuzzle_2_part_win", 0 );   
        AnimPlay( "anm_superpuzzle_2_block_6", "DoAnim", func_after );
        
      end;

      ObjSet( "anm_superpuzzle_2_block_4", { alp = 0 });
      ObjSet( "spr_superpuzzle_2_block_4", { alp = 1 });
      common_impl.Lock( true );
      ObjAnimate( "obj_superpuzzle_2_mg_4", "alp",0,0, anim_open ,
      {
      0.0, 0, 1, 
      0.3, 0, 0
      });
            
    end;
    
    ng_global.progress[ "std" ][ "win_superpuzzle_2" ].state[4] = true;
    ObjAnimate( "spr_superpuzzle_2_mg_4_light_red", "alp",0,0, anim_light,
    {
      0.0, 0, 1, 
      0.3, 0, 0
    });
    ObjAnimate( "spr_superpuzzle_2_mg_4_light_green", "alp",0,0, "",
    {
      0.0, 0, 0, 
      0.3, 0, 1
    });    
  
    
  end;
  function private.mmg4_reset()
    ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg4_state = { 1,2,3,4,5,6,7,8,9 };
    for i = 1,9 do
        ObjAttach( "spr_superpuzzle_2_mg_4_button_"..i, "obj_superpuzzle_2_mg_4_slot_"..ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg6_state[i])
    end;
  end;
  function public.SkipPuzzle4()
    
    private.mmg4_win();
    ng_global.progress[ "std" ][ "win_superpuzzle_2" ].puzzletimer = 1;
    interface.PuzzleHelpReload( 1 );
    interface.PuzzleHelpHide();
    ObjSet( "tmr_superpuzzle_2_skip", { playing = false } );
    
  end;
--*********************************************************************************************************************
-- function *** MMG5 *** () end;
--*********************************************************************************************************************
  function private.mmg5_rotate( number )
    
    point = "spr_superpuzzle_2_mg_5_point_"..number;
    
    for i = 1,6 do
      
      if ( common.ApplyObj( point, "spr_superpuzzle_2_mg_5_part_"..i, false ) ) then
        private.local_rotate( point, "superpuzzle_2_mg_5_part_"..i );
      end;
      
    end;
    
  end;
  function private.local_rotate( point, part )
    
    obj_part = "obj_"..part;
    obj_point = "obj_"..string.sub( point, 5,string.len(point) );
    ObjSet( obj_point, { ang = 0 } );
    local point_x = ObjGet( point ).pos_x;
    local point_y = ObjGet( point ).pos_y;
    local part_x = ObjGet( obj_part ).pos_x;
    local part_y = ObjGet( obj_part ).pos_y;
    ObjSet( obj_part, {pos_x = - point_x + part_x, pos_y = - point_y + part_y } )
    ObjAttach( obj_part, obj_point );
    
    local func_after = function()
      
      ObjAttach( obj_part, "obj_superpuzzle_2_mg_5_parts" );
      ObjSet( obj_part, {pos_x = point_x - part_x, pos_y = point_y - part_y} )
      local new_ang = (ObjGet( "spr_"..part ).ang) + 3.14;
      if new_ang > 6 then
        new_ang = 0;
      end;
      ObjSet( "spr_"..part, {ang = new_ang } );
      common_impl.Lock( false );

    end;
    
    common_impl.Lock( true );
    ObjAnimate( obj_point, "ang",0,0, func_after,
    {
      0.0, 0, 0, 
      0.3, 0, 3.14
    }); 
    
  end;
--*********************************************************************************************************************
-- function *** MMG6 *** () end;
--*********************************************************************************************************************
  function private.mmg6_StartDrag( number )
    
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_superpuzzle_2_typewriter_get", 0 );
    private.mmg6_drag = number;
    ObjSet( "obj_superpuzzle_2_mg_6_button_"..ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg6_state[private.mmg6_drag], { pos_z = 3 } );
    
  end;
  function private.mmg6_DropDrag()
    
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_superpuzzle_2_typewriter_set", 0 );
    ObjSet( "obj_superpuzzle_2_mg_6_button_"..ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg6_state[private.mmg6_drag], { pos_z = 0 } );

    for i = 1,9 do
      if (private.mmg6_drag ~=i) and (common.ApplyObj( "spr_superpuzzle_2_mg_6_button_"..private.mmg6_drag, "spr_superpuzzle_2_mg_6_button_"..i, false )) then
        
        DbgTrace( private.mmg6_drag.."  "..i );
        ObjAttach( "spr_superpuzzle_2_mg_6_button_"..private.mmg6_drag, "obj_superpuzzle_2_mg_6_button_"..ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg6_state[i])
        ObjAttach( "spr_superpuzzle_2_mg_6_button_"..i, "obj_superpuzzle_2_mg_6_button_"..ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg6_state[private.mmg6_drag])
        local temp_pos = ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg6_state[private.mmg6_drag];
        ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg6_state[private.mmg6_drag] = ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg6_state[i]
        ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg6_state[i] = temp_pos;
        
        if private.mmg6_checkwin() then

          DbgTrace( "win6" );
          private.mmg6_win();
        end;
        
        break;
        
      end;
    end;
    
  end;
  function private.mmg6_checkwin()
    saves = ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg6_state;
    if ( private.mmg6_return_number(1) * private.mmg6_return_number(2) - private.mmg6_return_number(3) == 5 ) and
       ( private.mmg6_return_number(4) / private.mmg6_return_number(5) + private.mmg6_return_number(6) == 7 ) and
       ( private.mmg6_return_number(7) + private.mmg6_return_number(8) - private.mmg6_return_number(9) == 9 ) then
       return true;
    end;
    
  end;
  function private.mmg6_return_number(number)
      
    for i = 1,9 do
      if ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg6_state[i] == number then
        return i;
      end;
    end;
      
  end;
  function private.mmg6_reset()
    ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg6_state = { 1,2,3,4,5,6,7,8,9 };
    for i = 1,9 do
        ObjAttach( "spr_superpuzzle_2_mg_6_button_"..i, "obj_superpuzzle_2_mg_6_button_"..ng_global.progress[ "std" ][ "win_superpuzzle_2" ].mmg6_state[i])
    end;
  end;
  function private.mmg6_win()
    
    local func_after = function()

      common_impl.Lock( false );
      ObjSet( "obj_superpuzzle_2_room", { input = true });
      ObjSet( "obj_superpuzzle_2_mg_6", { input = false });
      ObjSet( "obj_superpuzzle_2_gate_6", { input = false });
      private.CheckWinSp();
    
    end;

    ng_global.progress[ "std" ][ "win_superpuzzle_2" ].state[6] = true;
    common_impl.Lock( true );
    
    ObjSet( "anm_superpuzzle_2_block_6", { alp = 0 });
    ObjSet( "spr_superpuzzle_2_block_6", { alp = 1 });
    ObjSet( "anm_superpuzzle_2_block_3", { alp = 0 });
    ObjSet( "spr_superpuzzle_2_block_3", { alp = 1 });
    ObjAnimate( "obj_superpuzzle_2_mg_6", "alp",0,0, "",
    {
    0.0, 0, 1, 
    0.3, 0, 0
    });
    ObjAnimate( "obj_superpuzzle_2_mmg_6_light", "alp",0,0,func_after,
    {
    0.0, 0, 1, 
    0.3, 0, 1,
    0.6, 0, 0
    });
    ObjAnimate( "spr_superpuzzle_2_mg_light_1", "alp",0,0, "",
    {
    0.0, 0, 1, 
    0.3, 0, 0
    });
    ObjAnimate( "spr_superpuzzle_2_mg_light_red", "alp",0,0, "",
    {
    0.0, 0, 1, 
    0.3, 0, 0
    });
    ObjAnimate( "spr_superpuzzle_2_mg_light_2", "alp",0,0, "",
    {
    0.0, 0, 0, 
    0.3, 0, 1
    });
    ObjAnimate( "spr_superpuzzle_2_mg_light_green", "alp",0,0, "",
    {
    0.0, 0, 0, 
    0.3, 0, 1
    });
  
  end;
  
  function public.SkipPuzzle6()
    
    private.mmg6_win();
    ng_global.progress[ "std" ][ "win_superpuzzle_2" ].puzzletimer = 1;
    interface.PuzzleHelpReload( 1 );
    interface.PuzzleHelpHide();
    
  end;
--*********************************************************************************************************************
function public.Reset()

  private.mmg2_reset();
  private.mmg3_reset()
  private.mmg4_reset();
  private.mmg6_reset();
  
end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  private.vid_superpuzzle_2_coldsource();

end;
--*********************************************************************************************************************
function private.WinEnd()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   

  cmn.MiniGameHide();
  common_impl.PassingMgWin();
  cmn.SetEventDone( "win_superpuzzle_2" );
  cmn.CallEventHandler( "win_superpuzzle_2" );
  private.get_coldsource();
  cmn.GotoRoom( "rm_groundfloor" );

end;
--*********************************************************************************************************************
function private.CheckWinSp()
  
  for i = 1,6 do
    if not ng_global.progress[ "std" ][ "win_superpuzzle_2" ].state[i] then
      return;
    end;
  end;
  private.vid_superpuzzle_2_coldsource()
  
  
end;
function private.Win()
  
  private.WinEnd();

end;
function private.GotoMmg( number )

  if number == 2 then
    
    common_impl.PlayAudio( "env", "common/audio/level2/aud_mg_superpuzzle_2_circle_env", 1, "", 0 );
  
  end;
  
  local func_after = function()

    common_impl.Lock( false );
    ObjSet( "obj_superpuzzle_2_room", { input = false });
    ObjSet( "obj_superpuzzle_2_mg_"..number, { input = true });
    
  end;

  common_impl.Lock( true );
  ObjAnimate( "obj_superpuzzle_2_mg_"..number, "alp",0,0,func_after,
  {
    0.0, 0, 0, 
    0.3, 0, 1
  });

end;

function private.LeaveMmg( number )

  local func_after = function()
    if number == 2 then
      
      common_impl.StopAudio( "env", "common/audio/level2/aud_mg_superpuzzle_2_circle_env", 0.5 );
      
    end;
    common_impl.Lock( false );
    ObjSet( "obj_superpuzzle_2_room", { input = true });
    ObjSet( "obj_superpuzzle_2_mg_"..number, { input = false });
    
  end;

  common_impl.Lock( true );
  ObjAnimate( "obj_superpuzzle_2_mg_"..number, "alp",0,0,func_after,
  {
  0.0, 0, 1, 
  0.3, 0, 0
  });

end;
--*********************************************************************************************************************
-- function *** ANIMS *** () end;
--*********************************************************************************************************************
  function private.ButtonMouseEnter ( but_name )

    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_superpuzzle_2_flowers_navigate", 0, "", 0 );
    SetCursor( CURSOR_HAND );

    local obj = but_name;
    if ( not ObjGet( obj ) ) then return; end;

    local alp = ObjGet( obj ).alp;
    ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

    --common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );

  end;
  --******************************************************************************************
  function private.ButtonMouseLeave ( but_name )

    SetCursor( CURSOR_DEFAULT );

    local obj = but_name;

    if ( not ObjGet( obj ) ) then return; end;

    local alp = ObjGet( obj ).alp;
    ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

  end;
  --******************************************************************************************
  function private.AnimStart ()
    
    if not private.anim_static then
      private.anim_static = true;
      private.AnimChange()
    end;
    
  end;
function private.AnimStop()
    
  ObjSet( "anm_superpuzzle_2_stacker_"..private.anim[private.curent_anim], {alp = 0} );
  if string.len(private.anim[private.curent_anim]) > 1 then
    
    ObjSet( "anm_superpuzzle_2_stacker_"..(string.sub(private.anim[private.curent_anim], 1,1 ).."_static" ), {alp = 1} );

  end;
    
    if private.curent_anim == #private.anim then
    
      private.curent_anim = 1;
      
    else
      
      private.curent_anim = private.curent_anim + 1;
      
    end;
    
    ObjSet( "tmr_superpuzzle_2_stackers", { playing = true, time = 10, endtrig = function() private.AnimChange() end })
    
  end;
  function private.AnimChange()
    
    ObjSet( "anm_superpuzzle_2_stacker_"..(string.sub(private.anim[private.curent_anim], 1,1 ).."_static" ), {alp = 0} );
    ObjSet( "anm_superpuzzle_2_stacker_"..private.anim[private.curent_anim], {alp = 1 } );
    AnimPlay( "anm_superpuzzle_2_stacker_"..private.anim[private.curent_anim], "DoAnim", function() private.AnimStop() end );

    
  end;
--*********************************************************************************************************************
-- function *** Puszzle Hint ***() end
--*********************************************************************************************************************
  function private.PuszzleHintClk ( button, postfix )
  
    local postfix = ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( private.room_objname ) ].puzzle_num;

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_puzzle_hint", 0, "", 0 );
    interface.PuzzleHelpShow( "ifo_superpuzzle_2_"..postfix );
  
    ObjAnimate( button, "alp", 0, 0, func_end, { 0,3,0, 0.3,0,1, 0.6,0,0 } );
    ObjAnimate( button.."_add", "alp", 0, 0, "", { 0,3,0, 0.3,0,1, 0.6,0,0 } );

  end;
--*********************************************************************************************************************
  function private.PuszzleHintEnter ( button )

    common_impl.SetCursor( CURSOR_HAND );
    ObjSet( button, { alp = 1 } );

  end;
--*********************************************************************************************************************
  function private.PuszzleHintLeave ( button )

    common_impl.SetCursor( CURSOR_DEFAULT );
    ObjSet( button, { alp = 0 } );

  end;
--*********************************************************************************************************************
function private.vid_superpuzzle_2_coldsource()

  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_groundfloor_coldsource" );
    cmn.CallEventHandler( "vid_groundfloor_coldsource_end" );
    common_impl.ShowBbt( 'bbt_vid_groundfloor_coldsource', 1 );
  
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/level2/aud_groundfloor_coldsource", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/level2/aud_groundfloor_coldsource_voc", 0.2 );
      
    end;

    private.Win();
    common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 0, "", 0 );

  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_groundfloor_coldsource", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/level2/aud_groundfloor_coldsource_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_groundfloor_coldsource", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_groundfloor_coldsource", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
ObjAnimate("obj_superpuzzle_mg_2_circle_2", "ang",1,0,"",
{
  0.0, 0, 0.0, 
  9.0, 0, 6.28
});
ObjAnimate("obj_superpuzzle_mg_2_circle_3", "ang",1,0,"",
{
  0.0, 0, 0.0, 
  13.0, 0, -6.28
});
ObjAnimate("obj_superpuzzle_mg_2_circle_4", "ang",1,0,"",
{
  0.0, 0, 0.0, 
  10.0, 0, 6.28
});
ObjAnimate("obj_superpuzzle_mg_2_circle_5", "ang",1,0,"",
{
  0.0, 0, 0.0, 
  15.0, 0, -6.28
});
ObjAnimate("spr_superpuzzle_light2_red_all_add", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  3.0, 0, 0.28,
  6.0, 0, 1.0
});
ObjAnimate("obj_superpuzzle_2_darklight", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  4.0, 0, 0.6,
  8.0, 0, 1.0
});
ObjAnimate("spr_superpuzzle_2_mg_3_light_0_add", "pos_xy",1,0,"",
{
  0.0, 0, -135, 146,
  2.0, 0, -135, 146,
  3.0, 0, 121, 146
});
ObjAnimate("spr_superpuzzle_2_mg_3_light_0_add", "alp",1,0,"",
{
  0.0, 0, 0.0, 
  2.0, 3, 0.0,
  2.3, 3, 1.0,
  2.7, 3, 1.0,
  3.0, 0, 0.0
});
ObjAnimate("spr_superpuzzle_2_mg_3_light_1_add", "pos_xy",1,0,"",
{
  0.0, 0, 35, -173,
  2.0, 0, 35, -173,
  3.0, 0, 169, -32
});
ObjAnimate("spr_superpuzzle_2_mg_3_light_1_add", "alp",1,0,"",
{
  0.0, 0, 0.0, 
  2.0, 3, 0.0,
  2.3, 3, 1.0,
  2.7, 3, 1.0,
  3.0, 0, 0.0
});
ObjAnimate("spr_superpuzzle_2_mg_3_light_2_add", "pos_xy",1,0,"",
{
  0.0, 0, -8, -197,
  2.0, 0, -8, -197,
  3.0, 0, -149, -57
});
ObjAnimate("spr_superpuzzle_2_mg_3_light_2_add", "alp",1,0,"",
{
  0.0, 0, 0.0, 
  2.0, 3, 0.0,
  2.3, 3, 1.0,
  2.7, 3, 1.0,
  3.0, 0, 0.0
});


