-- name=rm_bar_2
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_bar_2";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_wineshelf_2", "room_hub" );
  ObjAttach( "zz_darts", "room_hub" );
  ObjAttach( "zz_jukebox", "room_hub" );
  ObjAttach( "zz_crest", "room_hub" );
  
  private.Init_Subroom();
  
  local table_multiset = {};
  
  private.matrix_scale = { 
                           {  1  , 1.05, 1.08, 1.1 , 1.13 },
                           { 0.95,  1  ,  1  , 1.05, 1.09 },
                           { 0.91,  1  ,  1  , 1.05, 1.08 },
                           { 0.87, 0.94, 0.96,  1  , 1.03 },
                           { 0.85, 0.88, 0.9 , 0.95,  1   }
                          };
  private.matrix_pos_x =  { 
                           { -65, -1, 66, 145, 220 },
                           { -70, -6, 59, 137, 212 },
                           { -71, -7, 59, 133, 212 },
                           { -62, -2, 69, 145, 223 },
                           { -65,  0, 66, 142, 220 }
                          };                     
  private.matrix_pos_y =  { 
                           { -33, -23, -23, -18, -17 },
                           { -33, -23, -23, -18, -10 },
                           { -35, -23, -23, -18, -12 },
                           { -35, -24, -21, -18, -12 },
                           { -33, -26, -23, -18, -12 }
                          };  
                        
  private.startmas = { 5, 2, 1, 4, 3 }; 
  private.win = { 1, 2, 3, 4, 5 }; 
  private.position = 0;
  
  private.volume = 0;
  
  -- loupe --
  
  private.loupe_mmg_win_pointer = 0;
  private.loupe_mmg_input_stop_drag = false;
  private.start_drag_auto = false;
  
  private.loupe_mmg_anim();

  for k = 1, 2 do
      
    for j = 1, 4 do
      
      ObjSet( "spr_bar_2_loupe_mg_sign_"..k.."_"..j, { event_mdown = function() private.loupe_mmg_clk_sign( k, j ) end,
                                                          event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                                          event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } );
      
    end;
      
  end;
                                                      
 -- loupe end --
  

  for k = 1, 3 do
 
    table.insert( table_multiset, { "obj_jukebox_clk_button_"..k, { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_button( k ) end,
    }} ); 
    
  end;
  
  for i = 1, 5 do  
    
    table.insert( table_multiset, { "spr_wineshelf_2_bottle_"..i, { 
   -- event_menter = function() private.EnterAnim( i ) end,
   -- event_mleave = function() private.( i ) end,
    event_mdown = function() private.clk_bottle( i ) end,
    }} );
    
  end;
  
  ObjMultiSet( table_multiset );
  
  ObjMultiSet({ 
  { "spr_wineshelf_2_zipperslider", { event_mdown = private.get_zipperslider }},
  { "spr_wineshelf_2_ruby", { event_mdown = private.get_ruby }},
  { "spr_darts_truckkey", { event_mdown = private.get_truckkey }},
  { "spr_jukebox_mechanismpart", { event_mdown = private.get_mechanismpart }},
  { "spr_jukebox_crestfragment", { event_mdown = private.get_crestfragment }},
  { "spr_jukebox_rifle", { event_mdown = private.get_rifle }},
  { "spr_crest_mtmap", { event_mdown = private.get_mtmap }},
  { "spr_crest_dart", { event_mdown = private.get_dart }},
  { "spr_crest_musictracklist", { event_mdown = private.get_musictracklist }},
  { "spr_crest_button_2_1", { event_mdown = private.get_button_2_1 }},
  { "spr_crest_board", { event_mdown = private.get_board }},
  { "spr_crest_badgeelement_2_1", { event_mdown = private.get_badgeelement_2_1 }},
  { "obj_wineshelf_2_use_bartenderbadge", { event_mdown = private.clk_door_chest }},
  { "obj_bar_2_clk_man", { event_mdown = function() private.clk_anim( "man" ) end } },
  { "obj_bar_2_clk_hat", { event_mdown = function() private.clk_anim( "hat" ) end } },
  { "obj_bar_2_clk_jacket", { event_mdown = function() private.clk_anim( "jacket" ) end } },
  { "obj_bar_2_clk_airplane_2", { event_mdown = function() private.clk_airplane_2() end } }, 
  { "spr_bar_2_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_crest_collect_2", { event_mdown = function () private.get_collect_2_2_4(); end,
                                  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
  
  });
  
--  local ho_items = {};
--
--  interface.TaskPanelTaskAdd( ho_items, "ring",          1, 0, { { "spr_chestroom_microchip_2" } } );
--  
--
--  interface.TaskPanelShow( ho_items );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_bar_2 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gho_bar_2_chesthos",
    "gmg_bar_2_secretpassage",
    "gzz_bar_2_wineshelf_2",
    "gzz_bar_2_darts",
    "gzz_bar_2_jukebox",
    "gzz_bar_2_crest"   
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_wineshelf_2",
    "zz_darts",
    "zz_jukebox",
    "zz_crest"    
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_bar_2", update_game_mode_bar_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_bar_2 = function ()

  local effects_table = 
  {
    "obj_bar_2_anim",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_bar_2", update_performance_mode_bar_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_bar_2 () end;
  --------------------------------------------------------------------------------------------
  local opn_bar_2_map = function ()

    common_impl.VisitMapRoom( "bar_2" );

  end;
  cmn.AddSubscriber( "opn_bar_2", opn_bar_2_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_zipperslider () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_zipperslider" ] = {
    type = "get",
    get_obj = "spr_wineshelf_2_zipperslider",
    room = private.room_objname,
    zz = "zz_wineshelf_2",
    zz_gate = "gzz_bar_2_wineshelf_2"
  };
    
  local get_zipperslider_inv = function ()
  
     interface.InventoryItemAdd( "inv_zipperslider", "spr_wineshelf_2_zipperslider" );
     ObjSet("spr_bag_2_plus_light", { alp = 1 });
  
  end;
  
  local get_zipperslider_closezz = function ()
 
  --ObjSet("spr_bag_2_plus_light", { alp = 1 });
  
  end;
  
  cmn.AddSubscriber( "get_zipperslider", get_zipperslider_inv );
  cmn.AddSubscriber( "get_zipperslider", get_zipperslider_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ruby () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ruby" ] = {
    type = "get",
    get_obj = "spr_wineshelf_2_ruby",
    room = private.room_objname,
    zz = "zz_wineshelf_2",
    zz_gate = "gzz_bar_2_wineshelf_2"
  };
    
  local get_ruby_inv = function ()
  
    interface.InventoryItemAdd( "inv_ruby", "spr_wineshelf_2_ruby" );
  
  end;
  
  local get_ruby_closezz = function ()
  
    ObjDelete( "gfx_wineshelf_2_ruby" );
    
    ObjDelete( "spr_bar_2_stone" );
    --ObjDelete( "gzz_bar_2_wineshelf_2" );
  
  end;
  
  cmn.AddSubscriber( "get_ruby", get_ruby_inv );
  cmn.AddSubscriber( "get_ruby", get_ruby_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_truckkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_truckkey" ] = {
    type = "get",
    get_obj = "spr_darts_truckkey",
    room = private.room_objname,
    zz = "zz_darts",
    zz_gate = "gzz_bar_2_darts"
  };
    
  local get_truckkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_truckkey", "spr_darts_truckkey" );
  
  end;
  
  local get_truckkey_closezz = function ()
  
    ObjDelete( "gfx_darts_truckkey" );
    ObjDelete( "spr_darts_truckkey_shadow" );
    ObjDelete( "spr_darts_truckkey_shadow_up" );
    
    ObjDelete( "spr_bar_2_mg_key" );
  
  end;
  
  cmn.AddSubscriber( "get_truckkey", get_truckkey_inv );
  cmn.AddSubscriber( "get_truckkey", get_truckkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mechanismpart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mechanismpart" ] = {
    type = "get",
    get_obj = "spr_jukebox_mechanismpart",
    room = private.room_objname,
    zz = "zz_jukebox",
    zz_gate = "gzz_bar_2_jukebox"
  };
    
  local get_mechanismpart_inv = function ()
  
    interface.InventoryItemAdd( "inv_mechanismpart", "spr_jukebox_mechanismpart" );
  
  end;
  
  local get_mechanismpart_closezz = function ()
  
    ObjDelete( "gfx_jukebox_mechanismpart" );
    ObjDelete( "spr_jukebox_mechanismpart_shadow" );
    ObjDelete( 'spr_jukebox_mechanismpart_shadow_up' );
    
    if( cmn.IsEventDone("get_crestfragment") and cmn.IsEventDone("get_rifle") )then
      
      ObjDelete( "gzz_bar_2_jukebox" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_mechanismpart", get_mechanismpart_inv );
  cmn.AddSubscriber( "get_mechanismpart", get_mechanismpart_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crestfragment () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crestfragment" ] = {
    type = "get",
    get_obj = "spr_jukebox_crestfragment",
    room = private.room_objname,
    zz = "zz_jukebox",
    zz_gate = "gzz_bar_2_jukebox"
  };
    
  local get_crestfragment_inv = function ()
  
    interface.InventoryItemAdd( "inv_crestfragment", "spr_jukebox_crestfragment" );
  
  end;
  
  local get_crestfragment_closezz = function ()
  
    ObjDelete( "gfx_jukebox_crestfragment" );
    ObjDelete( "spr_jukebox_crestfragment_shadow" );
    
    ObjDelete( "spr_bar_2_unicorn" );
    
    if( cmn.IsEventDone("get_mechanismpart") and cmn.IsEventDone("get_rifle") )then
      
      ObjDelete( "gzz_bar_2_jukebox" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_crestfragment", get_crestfragment_inv );
  cmn.AddSubscriber( "get_crestfragment", get_crestfragment_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rifle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rifle" ] = {
    type = "get",
    get_obj = "spr_jukebox_rifle",
    room = private.room_objname,
    zz = "zz_jukebox",
    zz_gate = "gzz_bar_2_jukebox"
  };
    
  local get_rifle_inv = function ()
  
    interface.InventoryItemAdd( "inv_rifle", "spr_jukebox_rifle" );
    ObjSet( "inv_rifle", { drag = false } );
  
  end;
  
  local get_rifle_closezz = function ()
  
    ObjDelete( "gfx_jukebox_rifle" );
    ObjDelete( "spr_jukebox_rifle_shadow" );
    
    ObjDelete( "spr_bar_2_gun" );
    
    if( cmn.IsEventDone("get_crestfragment") and cmn.IsEventDone("get_mechanismpart") )then
      
      ObjDelete( "gzz_bar_2_jukebox" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_rifle", get_rifle_inv );
  cmn.AddSubscriber( "get_rifle", get_rifle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mtmap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mtmap" ] = {
    type = "get",
    get_obj = "spr_crest_mtmap",
    room = private.room_objname,
    zz = "zz_crest",
    zz_gate = "gzz_bar_2_crest"
  };
    
  local get_mtmap_inv = function ()
  
    interface.InventoryItemAdd( "inv_mtmap", "spr_crest_mtmap" );
  
  end;
  
  local get_mtmap_closezz = function ()
  
    ObjDelete( "gfx_crest_mtmap" );
    ObjDelete( "spr_crest_mtmap_shadow" );
    ObjDelete( "spr_crest_mtmap_shadow_up" );
    
    ObjDelete( "spr_bar_2_mtmap" );
    
    if( cmn.IsEventDone("get_musictracklist") )then
      ObjSet( "obj_crest_use_bomb", { input = true } );
    end;
    
    if( cmn.IsEventDone("get_dart") and cmn.IsEventDone("get_musictracklist") and common_impl.IsGetCollect( "get_collect_2_2_4" )
      and cmn.IsEventDone("get_button_2_1") and cmn.IsEventDone("get_board") and cmn.IsEventDone("get_badgeelement_2_1") )then
      
      ObjDelete( "gzz_bar_2_crest" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_mtmap", get_mtmap_inv );
  cmn.AddSubscriber( "get_mtmap", get_mtmap_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_dart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_dart" ] = {
    type = "get",
    get_obj = "spr_crest_dart",
    room = private.room_objname,
    zz = "zz_crest",
    zz_gate = "gzz_bar_2_crest"
  };
    
  local get_dart_inv = function ()
  
    interface.InventoryItemAdd( "inv_dart", "spr_crest_dart" );
  
  end;
  
  local get_dart_closezz = function ()
  
    ObjDelete( "gfx_crest_dart" );
    ObjDelete( "spr_crest_dart_shadow" );
    ObjDelete( "spr_darts_truckkey_over" );
    
    ObjDelete( "spr_bar_2_dart" );
    
    if( cmn.IsEventDone("get_mtmap") and cmn.IsEventDone("get_musictracklist") and common_impl.IsGetCollect( "get_collect_2_2_4" )
      and cmn.IsEventDone("get_button_2_1") and cmn.IsEventDone("get_board") and cmn.IsEventDone("get_badgeelement_2_1") )then
      
      ObjDelete( "gzz_bar_2_crest" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_dart", get_dart_inv );
  cmn.AddSubscriber( "get_dart", get_dart_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_musictracklist () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_musictracklist" ] = {
    type = "get",
    get_obj = "spr_crest_musictracklist",
    room = private.room_objname,
    zz = "zz_crest",
    zz_gate = "gzz_bar_2_crest"
  };
    
  local get_musictracklist_inv = function ()
  
    interface.InventoryItemAdd( "inv_musictracklist", "spr_crest_musictracklist" );
  
  end;
  
  local get_musictracklist_closezz = function ()
  
    ObjDelete( "gfx_crest_musictracklist" );
    ObjDelete( "spr_crest_musictracklist_shadow" );
    
    ObjDelete( "spr_bar_2_tracklist" );
    
    if( cmn.IsEventDone("get_mtmap") )then
      ObjSet( "obj_crest_use_bomb", { input = true } );
    end;
    
    if( cmn.IsEventDone("get_mtmap") and cmn.IsEventDone("get_dart") and common_impl.IsGetCollect( "get_collect_2_2_4" )
      and cmn.IsEventDone("get_button_2_1") and cmn.IsEventDone("get_board") and cmn.IsEventDone("get_badgeelement_2_1") )then
      
      ObjDelete( "gzz_bar_2_crest" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_musictracklist", get_musictracklist_inv );
  cmn.AddSubscriber( "get_musictracklist", get_musictracklist_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_button_2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button_2_1" ] = {
    type = "get",
    get_obj = "spr_crest_button_2_1",
    room = private.room_objname,
    zz = "zz_crest",
    zz_gate = "gzz_bar_2_crest"
  };
    
  local get_button_2_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_button_2_1", "spr_crest_button_2_1" );
  
  end;
  
  local get_button_2_1_closezz = function ()
  
    ObjDelete( "gfx_crest_button_2_1" );
    ObjDelete( "spr_crest_button_shadow" );
    ObjDelete( "spr_bar_2_button_2_1" );
    
    ObjSet( "spr_crest_board", { input = true } );
    ObjSet( "gfx_crest_board", { active = true } );
    
    if( cmn.IsEventDone("get_mtmap") and cmn.IsEventDone("get_dart") and common_impl.IsGetCollect( "get_collect_2_2_4" )
      and cmn.IsEventDone("get_musictracklist") and cmn.IsEventDone("get_board") and cmn.IsEventDone("get_badgeelement_2_1") )then
      
      ObjDelete( "gzz_bar_2_crest" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_button_2_1", get_button_2_1_inv );
  cmn.AddSubscriber( "get_button_2_1", get_button_2_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_board () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_board" ] = {
    type = "get",
    get_obj = "spr_crest_board",
    room = private.room_objname,
    zz = "zz_crest",
    zz_gate = "gzz_bar_2_crest"
  };
    
  local get_board_inv = function ()
  
    interface.InventoryItemAdd( "inv_board", "spr_crest_board" );
    ObjSet( "inv_board", { drag = false } )
  
  end;
  
  local get_board_closezz = function ()
  
    ObjDelete( "gfx_crest_board" );
    
    ObjDelete( "spr_bar_2_board" );
    
    if( cmn.IsEventDone("get_mtmap") and cmn.IsEventDone("get_dart") and common_impl.IsGetCollect( "get_collect_2_2_4" )
      and cmn.IsEventDone("get_musictracklist") and cmn.IsEventDone("get_button_2_1") and cmn.IsEventDone("get_badgeelement_2_1") )then
      
      ObjDelete( "gzz_bar_2_crest" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_board", get_board_inv );
  cmn.AddSubscriber( "get_board", get_board_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_badgeelement_2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_badgeelement_2_1" ] = {
    type = "get",
    get_obj = "spr_crest_badgeelement_2_1",
    room = private.room_objname,
    zz = "zz_crest",
    zz_gate = "gzz_bar_2_crest"
  };
    
  local get_badgeelement_2_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_badgeelement_2_1", "spr_crest_badgeelement_2_1" );
    ObjSet( "spr_bartendersbadge_plus_light", { alp = 1 });
  
  end;
  
  local get_badgeelement_2_1_closezz = function ()
  
    ObjDelete( "gfx_crest_badgeelement_2_1" );
    
    ObjDelete( "spr_bar_2_badgeelement_2_1" );
    
    if( cmn.IsEventDone("get_mtmap") and cmn.IsEventDone("get_dart") and common_impl.IsGetCollect( "get_collect_2_2_4" )
      and cmn.IsEventDone("get_musictracklist") and cmn.IsEventDone("get_button_2_1") and cmn.IsEventDone("get_board") )then
      
      ObjDelete( "gzz_bar_2_crest" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_badgeelement_2_1", get_badgeelement_2_1_inv );
  cmn.AddSubscriber( "get_badgeelement_2_1", get_badgeelement_2_1_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_2 = function ()
  
    ObjDelete( "obj_bar_2_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_2", get_collect_morph_item_2_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_2_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_2_4 = function ()
 
    ObjDelete( "spr_crest_collect_2" );
    ObjDelete( "spr_crest_collect_2_shadow" );

    if ( cmn.IsEventDone("get_dart") and cmn.IsEventDone("get_musictracklist") and cmn.IsEventDone("get_mtmap")
      and cmn.IsEventDone("get_button_2_1") and cmn.IsEventDone("get_board") and cmn.IsEventDone("get_badgeelement_2_1") ) then
      
      ObjDelete( "gzz_bar_2_crest" );
      
    end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_2_4", get_collect_2_2_4, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_bottle_2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bottle_2_1" ] = {
    type = "use",
    inv_obj = "inv_bottle_2_1",
    use_place = "obj_wineshelf_2_use_bottle_2_1",
    room = private.room_objname,
    zz = "zz_wineshelf_2",
    zz_gate = "gzz_bar_2_wineshelf_2"
  };
  local use_bottle_2_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_bottle_2_1" );
  
  end;
  local use_bottle_2_1_beg = function ()
  
    ObjDelete( "obj_wineshelf_2_use_bottle_2_1" );
  
  end;
  local use_bottle_2_1_end = function ()
  
     ObjSet( "spr_wineshelf_2_bottle_2", { alp = 1 });
     ObjSet( "spr_wineshelf_2_shadow_3", { alp = 1 });
     ObjSet( "spr_bar_2_bottle_1", { alp = 1 } );
     
     if cmn.IsEventDone( "use_bottle_2_2" ) then
    
       ObjSet( "obj_wineshelf_2_mmg_shelf", {input = true, active = true });
       ObjSet( "obj_wineshelf_2_bottle", { input = true, active = true });
       ObjSet( "obj_wineshelf_2_mmg", { input = true });
        
     end;
  
    --ObjSet( "spr_wineshelf_2_key", { input = true, visible = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bottle_2_1", use_bottle_2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottle_2_1", use_bottle_2_1_inv );
  cmn.AddSubscriber( "use_bottle_2_1", use_bottle_2_1_end, private.room_objname );
  cmn.AddSubscriber( "use_bottle_2_1_inv", use_bottle_2_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_bottle_2_1_beg", use_bottle_2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottle_2_1_end", use_bottle_2_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bottle_2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bottle_2_2" ] = {
    type = "use",
    inv_obj = "inv_bottle_2_2",
    use_place = "obj_wineshelf_2_use_bottle_2_2",
    room = private.room_objname,
    zz = "zz_wineshelf_2",
    zz_gate = "gzz_bar_2_wineshelf_2"
  };
  local use_bottle_2_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_bottle_2_2" );
  
  end;
  local use_bottle_2_2_beg = function ()
  
    ObjDelete( "obj_wineshelf_2_use_bottle_2_2" );
  
  end;
  local use_bottle_2_2_end = function ()
  
   ObjSet( "spr_wineshelf_2_bottle_4", { alp = 1 });
   ObjSet( "spr_wineshelf_2_shadow_4", { alp = 1 });
   ObjSet( "spr_bar_2_bottle_2", { alp = 1 } );
   
   if cmn.IsEventDone( "use_bottle_2_1" ) then
    
       ObjSet( "obj_wineshelf_2_mmg_shelf", {input = true, active = true });
       ObjSet( "obj_wineshelf_2_bottle", { input = true, active = true });
       ObjSet( "obj_wineshelf_2_mmg", { input = true }); 
   end;
    --ObjSet( "spr_wineshelf_2_key", { input = true, visible = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bottle_2_2", use_bottle_2_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottle_2_2", use_bottle_2_2_inv );
  cmn.AddSubscriber( "use_bottle_2_2", use_bottle_2_2_end, private.room_objname );
  cmn.AddSubscriber( "use_bottle_2_2_inv", use_bottle_2_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_bottle_2_2_beg", use_bottle_2_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottle_2_2_end", use_bottle_2_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bartenderbadge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bartenderbadge" ] = {
    type = "use",
    inv_obj = "inv_bartenderbadge",
    use_place = "obj_wineshelf_2_use_bartenderbadge",
    room = private.room_objname,
    zz = "zz_wineshelf_2",
    zz_gate = "gzz_bar_2_wineshelf_2"
  };
  local use_bartenderbadge_inv = function ()
  
    interface.InventoryItemRemove( "inv_bartenderbadge" );
  
  end;
  local use_bartenderbadge_beg = function ()
  
    ObjDelete( "obj_wineshelf_2_use_bartenderbadge" );
  
  end;
  local use_bartenderbadge_end = function ()
  
    ObjSet( "gho_bar_2_chesthos", { input = true, active = true, alp = 1 });
    ObjDelete( "gzz_bar_2_wineshelf_2" );
    
    ObjSet( "spr_bar_2_ho", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bartenderbadge", use_bartenderbadge_beg, private.room_objname );
  cmn.AddSubscriber( "use_bartenderbadge", use_bartenderbadge_inv );
  cmn.AddSubscriber( "use_bartenderbadge", use_bartenderbadge_end, private.room_objname );
  cmn.AddSubscriber( "use_bartenderbadge_inv", use_bartenderbadge_inv, private.room_objname );
  cmn.AddSubscriber( "use_bartenderbadge_beg", use_bartenderbadge_beg, private.room_objname );
  cmn.AddSubscriber( "use_bartenderbadge_end", use_bartenderbadge_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_dart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_dart" ] = {
    type = "use",
    inv_obj = "inv_dart",
    use_place = "obj_darts_use_dart",
    room = private.room_objname,
    zz = "zz_darts",
    zz_gate = "gzz_bar_2_darts"
  };
  local use_dart_inv = function ()
  
    interface.InventoryItemRemove( "inv_dart" );
  
  end;
  local use_dart_beg = function ()
  
    ObjDelete( "obj_darts_use_dart" );
  
  end;
  local use_dart_end = function ()
    
    ObjDelete( "obj_darts_darts" ); 
    ObjSet( "spr_darts_mg", { alp = 1 } );
    ObjSet( "spr_darts_mg_open", { alp = 1 } );
    ObjSet( "obj_darts_use_mechanismpart", { input = true } );
    
    ObjSet( "obj_bar_2_darts_open", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dart", use_dart_beg, private.room_objname );
  cmn.AddSubscriber( "use_dart", use_dart_inv );
  cmn.AddSubscriber( "use_dart", use_dart_end, private.room_objname );
  cmn.AddSubscriber( "use_dart_inv", use_dart_inv, private.room_objname );
  cmn.AddSubscriber( "use_dart_beg", use_dart_beg, private.room_objname );
  cmn.AddSubscriber( "use_dart_end", use_dart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mechanismpart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mechanismpart" ] = {
    type = "use",
    inv_obj = "inv_mechanismpart",
    use_place = "obj_darts_use_mechanismpart",
    room = private.room_objname,
    zz = "zz_darts",
    zz_gate = "gzz_bar_2_darts"
  };
  local use_mechanismpart_inv = function ()
  
    interface.InventoryItemRemove( "inv_mechanismpart" );
  
  end;
  local use_mechanismpart_beg = function ()
  
    ObjDelete( "obj_darts_use_mechanismpart" );
  
  end;
  local use_mechanismpart_end = function ()
  
    ObjDelete( "gzz_bar_2_darts" );
    ObjSet( "spr_darts_mg_mechanismpart", { alp = 1 } );
    ObjSet( "gmg_bar_2_secretpassage", { input = true, active = true } );
    
    ObjDelete( "spr_bar_2_mg_hole" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mechanismpart", use_mechanismpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_mechanismpart", use_mechanismpart_inv );
  cmn.AddSubscriber( "use_mechanismpart", use_mechanismpart_end, private.room_objname );
  cmn.AddSubscriber( "use_mechanismpart_inv", use_mechanismpart_inv, private.room_objname );
  cmn.AddSubscriber( "use_mechanismpart_beg", use_mechanismpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_mechanismpart_end", use_mechanismpart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_2_2" ] = {
    type = "use",
    inv_obj = "inv_elf_2_1",
    use_place = "obj_jukebox_use_elf_2_2",
    room = private.room_objname,
    zz = "zz_jukebox",
    zz_gate = "gzz_bar_2_jukebox"
  };
  local use_elf_2_2_inv = function ()
  
  end;
  local use_elf_2_2_beg = function ()
  
    ObjDelete( "obj_jukebox_use_elf_2_2" );
  
  end;
  local use_elf_2_2_end = function ()
  
    ObjDelete( "vid_jukebox_use_elf" );
    ObjSet( "spr_jukebox_crestfragment", { input = true, alp = 1, pos_x = -80, pos_y = 225 } );
    ObjSet( "gfx_jukebox_crestfragment", { active = true } ); 
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_2_2", use_elf_2_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_2", use_elf_2_2_inv );
  cmn.AddSubscriber( "use_elf_2_2", use_elf_2_2_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_2_inv", use_elf_2_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_2_beg", use_elf_2_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_2_end", use_elf_2_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_25pence () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_25pence" ] = {
    type = "use",
    inv_obj = "inv_25pence",
    use_place = "obj_jukebox_use_25pence",
    room = private.room_objname,
    zz = "zz_jukebox",
    zz_gate = "gzz_bar_2_jukebox"
  };
  local use_25pence_inv = function ()
  
    interface.InventoryItemRemove( "inv_25pence" );
  
  end;
  local use_25pence_beg = function ()
  
    ObjDelete( "obj_jukebox_use_25pence" );
  
  end;
  local use_25pence_end = function ()
  
    ObjDelete( "anm_jukebox_coin" );
    ObjSet( "spr_jukebox_door_add", { alp = 1 } );
    ObjSet( "spr_jukebox_lamp_add", { alp = 1 } );
    ObjSet( "obj_jukebox_clk_button", { input = true } );
    ObjSet( "spr_bar_2_shine", { alp = 1 } );
    
    ObjSet( "anm_jukebox_lamp_add_2", { alp = 1, playing = true } );
    ObjDelete( "anm_jukebox_lamp_add" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_25pence", use_25pence_beg, private.room_objname );
  cmn.AddSubscriber( "use_25pence", use_25pence_inv );
  cmn.AddSubscriber( "use_25pence", use_25pence_end, private.room_objname );
  cmn.AddSubscriber( "use_25pence_inv", use_25pence_inv, private.room_objname );
  cmn.AddSubscriber( "use_25pence_beg", use_25pence_beg, private.room_objname );
  cmn.AddSubscriber( "use_25pence_end", use_25pence_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_musictracklist () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_musictracklist" ] = {
    type = "use",
    inv_obj = "inv_musictracklist",
    use_place = "obj_jukebox_use_musictracklist",
    room = private.room_objname,
    zz = "zz_jukebox",
    zz_gate = "gzz_bar_2_jukebox"
  };
  local use_musictracklist_inv = function ()
  
    interface.InventoryItemRemove( "inv_musictracklist" );
  
  end;
  local use_musictracklist_beg = function ()
  
    ObjDelete( "obj_jukebox_use_musictracklist" );
  
  end;
  local use_musictracklist_end = function ()
  
    ObjSet( "spr_jukebox_list", { alp = 1 } );
    ObjSet( "obj_jukebox_use_25pence", { input = true } );
    
    ObjSet( "spr_bar_2_mustracklist", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_musictracklist", use_musictracklist_beg, private.room_objname );
  cmn.AddSubscriber( "use_musictracklist", use_musictracklist_inv );
  cmn.AddSubscriber( "use_musictracklist", use_musictracklist_end, private.room_objname );
  cmn.AddSubscriber( "use_musictracklist_inv", use_musictracklist_inv, private.room_objname );
  cmn.AddSubscriber( "use_musictracklist_beg", use_musictracklist_beg, private.room_objname );
  cmn.AddSubscriber( "use_musictracklist_end", use_musictracklist_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crestfragment () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crestfragment" ] = {
    type = "use",
    inv_obj = "inv_crestfragment",
    use_place = "obj_crest_use_crestfragment",
    room = private.room_objname,
    zz = "zz_crest",
    zz_gate = "gzz_bar_2_crest"
  };
  local use_crestfragment_inv = function ()
  
    interface.InventoryItemRemove( "inv_crestfragment" );
  
  end;
  local use_crestfragment_beg = function ()
  
    ObjDelete( "obj_crest_use_crestfragment" );
  
  end;
  local use_crestfragment_end = function ()
  
    ObjDelete( "spr_crest_crest" );
    ObjDelete( "anm_crest_falling" );
    ObjSet( "spr_crest_mtmap", { input = true, active = true } );
    ObjSet( "spr_crest_musictracklist", { input = true, active = true } );
    
    ObjDelete( "spr_bar_2_crest" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crestfragment", use_crestfragment_beg, private.room_objname );
  cmn.AddSubscriber( "use_crestfragment", use_crestfragment_inv );
  cmn.AddSubscriber( "use_crestfragment", use_crestfragment_end, private.room_objname );
  cmn.AddSubscriber( "use_crestfragment_inv", use_crestfragment_inv, private.room_objname );
  cmn.AddSubscriber( "use_crestfragment_beg", use_crestfragment_beg, private.room_objname );
  cmn.AddSubscriber( "use_crestfragment_end", use_crestfragment_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bomb () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bomb" ] = {
    type = "use",
    inv_obj = "inv_bomb",
    use_place = "obj_crest_use_bomb",
    room = private.room_objname,
    zz = "zz_crest",
    zz_gate = "gzz_bar_2_crest"
  };
  local use_bomb_inv = function ()
  
    interface.InventoryItemRemove( "inv_bomb" );
  
  end;
  local use_bomb_beg = function ()
  
    ObjDelete( "obj_crest_use_bomb" );
  
  end;
  local use_bomb_end = function ()
 
    ObjSet( "spr_crest_bomb", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bomb", use_bomb_beg, private.room_objname );
  cmn.AddSubscriber( "use_bomb", use_bomb_inv );
  cmn.AddSubscriber( "use_bomb", use_bomb_end, private.room_objname );
  cmn.AddSubscriber( "use_bomb_inv", use_bomb_inv, private.room_objname );
  cmn.AddSubscriber( "use_bomb_beg", use_bomb_beg, private.room_objname );
  cmn.AddSubscriber( "use_bomb_end", use_bomb_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_emblem () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_emblem" ] = {
    type = "use",
    inv_obj = "inv_emblem",
    use_place = "obj_crest_use_emblem",
    room = private.room_objname,
    zz = "zz_crest",
    zz_gate = "gzz_bar_2_crest"
  };
  local use_emblem_inv = function ()
  
    interface.InventoryItemRemove( "inv_emblem" );
  
  end;
  local use_emblem_beg = function ()
  
    ObjDelete( "obj_crest_use_emblem" );
  
  end;
  local use_emblem_end = function ()
  
    --ObjSet( "spr_crest_button_2_1", { input = true, active = true, alp = 1 } );
    --ObjSet( "spr_crest_board", { input = true, active = true, alp = 1 } );
    --ObjSet( "spr_crest_badgeelement_2_1", { input = true, active = true, alp = 1 } );
    
    ObjDelete( "obj_crest_door" );
    ObjDelete( "spr_bar_2_crest_close" );
    
    ObjSet( "obj_crest_door_open", { alp = 1, input = true } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_emblem", use_emblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_emblem", use_emblem_inv );
  cmn.AddSubscriber( "use_emblem", use_emblem_end, private.room_objname );
  cmn.AddSubscriber( "use_emblem_inv", use_emblem_inv, private.room_objname );
  cmn.AddSubscriber( "use_emblem_beg", use_emblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_emblem_end", use_emblem_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_device_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_device_2" ] = {
  
    type = "click",
    use_place = "obj_int_button_apparat",  
    room = private.room_objname,
    
  };
  local use_device_2_inv = function ()
  
  end;
  local use_device_2_beg = function ()
  
  
  end;
  local use_device_2_end = function ()
  
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_device_2", use_device_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_device_2", use_device_2_inv );
  cmn.AddSubscriber( "use_device_2", use_device_2_end, private.room_objname );
  cmn.AddSubscriber( "use_device_2_inv", use_device_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_device_2_beg", use_device_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_device_2_end", use_device_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_airplane () end;
  --------------------------------------------------------------------------------------------  
  ----------------------------------------------------------------------------------------
  local clk_airplane_end = function ()
      
    ObjDelete( "obj_bar_2_clk_airplane_2" );
    ObjDelete( "anm_bar_2_airplane_2" );
      
  end; 
  ----------------------------------------------------------------------------------------  
  cmn.AddSubscriber( "clk_airplane", clk_airplane_end, private.room_objname );
  cmn.AddSubscriber( "clk_airplane_end", clk_airplane_end, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function clk_jukebox () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_jukebox" ] = {
    type = "click",
    use_place = "obj_jukebox_clk_button_2",
    room = private.room_objname,
    zz_gate = "gzz_bar_2_jukebox",
    zz = "zz_jukebox"
  };
  ----------------------------------------------------------------------------------------
  local clk_jukebox_beg = function ()
  
  --ObjDelete( "obj_jukebox_clk_button" );
      
  end;
  ----------------------------------------------------------------------------------------
  local clk_jukebox_end = function ()
      
    ObjDelete( "spr_jukebox_door" );
    ObjSet( "spr_jukebox_mechanismpart", { input = true, active = true } );
    ObjSet( "spr_jukebox_rifle", { input = true, active = true } );
    ObjDelete( "spr_bar_2_jukebox_cover" );
    ObjDelete( "obj_jukebox_clk_button" );
    ObjDelete( "anm_jukebox_lamp_add_2" );
      
  end; 
  ----------------------------------------------------------------------------------------  
  cmn.AddSubscriber( "clk_jukebox", clk_jukebox_beg, private.room_objname );
  cmn.AddSubscriber( "clk_jukebox", clk_jukebox_end, private.room_objname );
  cmn.AddSubscriber( "clk_jukebox_beg", clk_jukebox_beg, private.room_objname );
  cmn.AddSubscriber( "clk_jukebox_end", clk_jukebox_end, private.room_objname ); 
  --------------------------------------------------------------------------------------------
  -- function win_bottle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_bottle" ] = {

    type = "win",    
    room = private.room_objname,
    use_place = "obj_wineshelf_2_mmg",
    zz_gate = "gzz_bar_2_wineshelf_2",
    zz = "zz_wineshelf_2"

  };

  local win_bottle = function ()
  
   local posy = 0;

    if ( cmn.IsEventDone( "win_bottle" ) ) then
        
        ObjDelete( "obj_wineshelf_2_mmg" );
        ObjDelete( "spr_wineshelf_2_door");
        ObjSet( "obj_wineshelf_2_use_bartenderbadge", { input = true, active = true });
        ObjSet( "spr_wineshelf_2_ruby", { active = true, input = true });
        
        
        ObjDelete( "spr_bar_2_bottle_close" );
        ObjDelete( "spr_bar_2_door" );
        ObjSet( "spr_bar_2_bottle_open", { alp = 1 } );
        
    elseif ( cmn.IsEventStart( "win_bottle" ) and not cmn.IsEventDone( "win_bottle" ) ) then 
      
        
        for i = 1, 5  do
          
          --ObjSet()ng_global.progress[ "std" ][ "win_bottle" ].array[position_1]
          ObjSet( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].array[i], { pos_x = private.matrix_pos_x[ng_global.progress[ "std" ][ "win_bottle" ].array[i] ][i], pos_y = private.matrix_pos_y[ng_global.progress[ "std" ][ "win_bottle" ].array[i] ][i], pos_z = i , scale_x = private.matrix_scale[ng_global.progress[ "std" ][ "win_bottle" ].array[i] ][i], scale_y = private.matrix_scale[ng_global.progress[ "std" ][ "win_bottle" ].array[i] ][i]}); 
          
        end;
        
        if ng_global.progress[ "std" ][ "win_bottle" ].flag ~= 0 then 
          
          ObjSet( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag.."_add", { alp = 1});
          posy = ObjGet("spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag).pos_y - 70;
          ObjSet( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag, { pos_y = posy });
          --private.position = ObjGet().pos_z
        end;  
    end;
      
  end;

  cmn.AddSubscriber( "win_bottle", win_bottle, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function win_chesthos () end;
  --------------------------------------------------------------------------------------------
  local win_chesthos = function ()

    if ( cmn.IsEventDone( "win_chesthos" ) ) then

      ObjDelete( "gho_bar_2_chesthos" )

    end;

  end;

  cmn.AddSubscriber( "win_chesthos", win_chesthos, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function win_secretpassage () end;
  --------------------------------------------------------------------------------------------
  local win_secretpassage = function ()

    if ( cmn.IsEventDone( "win_secretpassage" ) ) then

      ObjDelete( "gmg_bar_2_secretpassage" );
      ObjSet( "anm_bar_2_door", { alp = 1 } );
      ObjDelete( "obj_bar_2_darts_open" );
      ObjSet( "spr_bar_2_loc", { alp = 1 } );

    end;

  end;

  cmn.AddSubscriber( "win_secretpassage", win_secretpassage, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function clk_secretpassage () end;
  --------------------------------------------------------------------------------------------
  local clk_secretpassage = function ()

    ObjSet( "spr_bar_2_mg_open", { alp = 1 } );
  
  end;

  cmn.AddSubscriber( "clk_secretpassage", clk_secretpassage, private.room_objname ); 
  
   --------------------------------------------------------------------------------------------
  -- function clk_bar_2_door () end;
  --------------------------------------------------------------------------------------------
  local clk_bar_2_door = function ()

    ObjDelete( "anm_bar_2_door" );
 
    ObjSet( "grm_bar_2_base", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_bar_2_base_focus");
    end;    
  end;

  cmn.AddSubscriber( "clk_bar_2_door", clk_bar_2_door, private.room_objname );
 
 --------------------------------------------------------------------------------------------
  -- function win_bar_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_bar_2" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "obj_bar_2_loupe_mg",
   
  };

  local win_bar_2 = function ()
  
    if cmn.IsEventDone( "win_bar_2" ) then

      ObjDelete( "obj_bar_2_loupe_mg" );
      
    else
      
      for i = 1, 2 do
        
        for j = 1, 4 do
          
          for k = 1, 4 do
            
            if ng_global.progress["std"]["win_bar_2"].saves[i][j][k] == 1 then
              
              local pos_star = GetObjPosByObj( "spr_bar_2_loupe_mg_sign_"..i.."_"..j, "obj_bar_2_loupe_mg" );
              
              local pos_star_2 = GetObjPosByObj( "spr_bar_2_loupe_mg_sign_"..(3-i).."_"..k, "obj_bar_2_loupe_mg" );
              
              private.loupe_mmg_make_line( pos_star, pos_star_2, (3-i), k, i, j, true );
              
              private.loupe_mmg_win_pointer = private.loupe_mmg_win_pointer + 1;
              
              ObjSet( "spr_bar_2_loupe_mg_sign_"..(3-i).."_"..k.."_light", { alp = 1 } );
              
              ObjSet( "spr_bar_2_loupe_mg_sign_"..i.."_"..j, { input = false } );
  
            end;
            
          end;
          
        end;
        
      end;
      
    end;
  
  end;

  cmn.AddSubscriber( "win_bar_2", win_bar_2, private.room_objname );  
 
  --------------------------------------------------------------------------------------------
  -- function vid_bar_2_loupe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_bar_2_loupe" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_bar_2_loupe",
    
  };

  local vid_bar_2_loupe = function ()

    ObjSet( "gzz_bar_2_darts", { input = true, active = true } );
  
  end;

  cmn.AddSubscriber( "vid_bar_2_loupe", vid_bar_2_loupe, private.room_objname ); 

  --------------------------------------------------------------------------------------------
  -- function clk_elevator_button () end;
  --------------------------------------------------------------------------------------------  
  local clk_elevator_button_bar = function ()
    
    ObjSet( "spr_bar_2_loc_elevator", { alp = 1 } );
  
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_elevator_button", clk_elevator_button_bar, private.room_objname  );  
  --------------------------------------------------------------------------------------------
  -- function vid_bar_2_bomb () end;
  --------------------------------------------------------------------------------------------
  local vid_bar_2_bomb_end = function ()

    ObjDelete( "vid_bar_2_bomb" );
    ObjDelete( "vid_bar_2_bomb_add" );
    ObjDelete( "spr_crest_bomb" );
    ObjSet( "spr_crest_hole", { alp = 1, input = true } );
    ObjSet( "obj_crest_use_emblem", { input = true } ); 
    ObjSet( "spr_bar_2_crest_open", { alp = 1 } );
  
  end;

  cmn.AddSubscriber( "vid_bar_2_bomb", vid_bar_2_bomb_end, private.room_objname );
  cmn.AddSubscriber( "vid_bar_2_bomb_end", vid_bar_2_bomb_end, private.room_objname  );
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
 subroom.Define( "zz_jukebox" ); 
 subroom.Define( "zz_wineshelf_2" );  
 subroom.Define( "zz_darts" );
 subroom.Define( "zz_crest" );
 
 --------------------------------------------------------------------------------------------  
 function zz_crest.PreOpen()
   
   if( cmn.IsEventDone( "vid_bar_2_bomb" ) ) then
     
     common_impl.PlayAudio( "env", "common/audio/level2/aud_after_explosion_crest_env", 1, "", 0 );
     
   end;
   
 end; 
 --------------------------------------------------------------------------------------------  
 function zz_crest.PreClose()
   
    common_impl.StopAudio( "env", "common/audio/level2/aud_after_explosion_crest_env", 0.2 );
   
 end;
 --------------------------------------------------------------------------------------------  
 function zz_crest.Close()

   if( cmn.IsEventDone("use_bomb") and not cmn.IsEventDone( "vid_bar_2_bomb" ) ) then
      
      local func_after = function()

        common_impl.Lock( false );
        cmn.SetEventDone( "vid_bar_2_bomb" );
        cmn.CallEventHandler( "vid_bar_2_bomb_end" );
        
        local posxy = { ObjGet("gzz_bar_2_crest").pos_x, ObjGet("gzz_bar_2_crest").pos_y };
    
        ObjSet( "tmr_bar_2_gotozz", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoSubRoom( "zz_crest", posxy , { 512, 384 }, true ); end } );
         
      end;

      common_impl.Lock( true );
      ObjSet( "vid_bar_2_bomb", { active = true, alp = 1 });
      ObjSet( "vid_bar_2_bomb_add", { active = true, alp = 1 });
      VidPlay( "vid_bar_2_bomb_add", "" );
      VidPlay( "vid_bar_2_bomb", func_after );
      
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_crest_bomb", 0, "", 0 );
      
    end;
    
 end;
 --------------------------------------------------------------------------------------------  
 function zz_darts.Close()

    if ( cmn.IsEventDone( "use_mechanismpart" ) ) then
      
      ObjSet( "tmr_bar_2_gotomg", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoRoom( 'mg_secretpassage' ) end } );
      
    end;

 end; 
 ---------------------------------------------------------------------------------------------
 function zz_wineshelf_2.PreOpen()
   
   local bool = true;
    
    if ( cmn.IsEventDone( "use_bottle_2_1" ) and cmn.IsEventDone( "use_bottle_2_2" )) and not cmn.IsEventDone( "win_bottle" ) then
    
      cmn.MiniGameShow( 'bottle' );
      common_impl.PassingMgStart( "bottle" );
      
    end;

 end;
 --------------------------------------------------------------------------------------------
 function zz_wineshelf_2.Open ()
  
 end;
 --------------------------------------------------------------------------------------------
 function zz_wineshelf_2.PreClose()

    if ( cmn.IsEventDone( "use_bottle_2_1" ) and cmn.IsEventDone( "use_bottle_2_2" )) and not cmn.IsEventDone( "win_bottle" ) then

       cmn.MiniGameHide( 'bottle' );
       common_impl.PassingMgStop( "bottle" );

    end;

  end;
 --------------------------------------------------------------------------------------------
 function zz_jukebox.PreOpen()
   
   if ( not common_impl.CheckMusPlaying() ) then
    
    local volume = GetSoundVolume( "soundtrack" );
    
    SetSoundVolume( "jukebox_loc",  0 );
    SetSoundVolume( "jukebox_zz",  private.volume );
    
  end;
 
 end; 
 --------------------------------------------------------------------------------------------
 function zz_jukebox.PreClose()
   
   if ( not common_impl.CheckMusPlaying() ) then
    
      local volume = GetSoundVolume( "soundtrack" );
      
      SetSoundVolume( "jukebox_loc",  private.volume );
      SetSoundVolume( "jukebox_zz",  0 );
    
    end;
    
  end;
 
 end;
--*********************************************************************************************************************
function public.Open()

  private.opn_bar_2();
  
  private.AnimPlay();
  
  common_impl.LoupeMgCheck();
 
  if cmn.IsEventDone( "win_secretpassage" ) and not cmn.IsEventDone( "clk_bar_2_door" ) then
   
    local func_after  = function()
    
      common_impl.Lock( false );
      cmn.SetEventDone( "clk_bar_2_door" );
      cmn.CallEventHandler( "clk_bar_2_door" )
      interface.KeyTaskDone( 'storage', true );
      ObjSet( "anm_bar_2_dust", { alp = 1, playing = true } );
      
    end;
    
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_open_secretpassage", 0, "", 0 );
    
    AnimPlay( "anm_bar_2_door", "DoAnim", func_after );
    
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  if ng_global.progress["std"]["opn_bar_2"].see_anim then
  
    ObjSet( "anm_bar_2_airplane", { alp = 0, playing = false } );
    
  end;
  
  common_impl.MorphItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/level2/aud_bar_env" }, "", 0.5 );
  
  common_impl.PlayAudio( "env", "common/audio/level2/aud_sleeping_man_env", 1, "", 0 );
  
  if not common_impl.CheckMusPlaying() then
    
    private.volume = GetSoundVolume( "soundtrack" );
    
    SetSoundVolume( "jukebox_loc",  private.volume );
    SetSoundVolume( "jukebox_zz",  0 );
    
    SndPlay( "assets/levels/common/audio/level2/aud_jukebox_loc_mus", "jukebox_loc", 1, 0, 0.2 );
    SndPlay( "assets/levels/common/audio/level2/aud_jukebox_zz_mus", "jukebox_zz", 1, 0, 0.2 );
    
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  private.StopAnims();
  
  common_impl.StopAudio( "env", "common/audio/level2/aud_sleeping_man_env", 0.2 );
  
end;
--*********************************************************************************************************************
function public.PreClose()
  
  SndStop( "assets/levels/common/audio/level2/aud_jukebox_loc_mus", "jukebox_loc", 1 );
  SndStop( "assets/levels/common/audio/level2/aud_jukebox_zz_mus", "jukebox_zz", 1 );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_bottle_2_1()

  local item = "inv_bottle_2_1";

  if ( common.ApplyObj( item, "obj_wineshelf_2_use_bottle_2_1", true ) ) then

    cmn.CallEventHandler( "use_bottle_2_1_inv" );
    cmn.CallEventHandler( "use_bottle_2_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_bottle_2_1" );
      cmn.CallEventHandler( "use_bottle_2_1_end" );
      if ( cmn.IsEventDone( "use_bottle_2_2" ) ) then
        
        cmn.MiniGameShow( 'bottle' );
        common_impl.PassingMgStart( "bottle" );
        ng_global.progress[ "std" ][ "win_bottle" ].array = {5,2,1,4,3};
        ng_global.progress[ "std" ][ "win_bottle" ].flag = 0;
        
      end;
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_bottle_wineshelf_2", 0, "", 0 );
  
    ObjAnimate( "spr_wineshelf_2_bottle_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_wineshelf_2_shadow_3", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
  return true;
  
  elseif common.ApplyObj( item, "gzz_bar_2_wineshelf_2", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wineshelf_2", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bottle_2_2()

  local item = "inv_bottle_2_2";

  if ( common.ApplyObj( item, "obj_wineshelf_2_use_bottle_2_2", true ) ) then

    cmn.CallEventHandler( "use_bottle_2_2_inv" );
    cmn.CallEventHandler( "use_bottle_2_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_bottle_2_2" );
      cmn.CallEventHandler( "use_bottle_2_2_end" );
      if ( cmn.IsEventDone( "use_bottle_2_1" ) ) then
        
        cmn.MiniGameShow( 'bottle' );
        common_impl.PassingMgStart( "bottle" );
        ng_global.progress[ "std" ][ "win_bottle" ].array = {5,2,1,4,3};
        ng_global.progress[ "std" ][ "win_bottle" ].flag = 0;
        
      end;
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_bottle_wineshelf_2", 0, "", 0 );
  
    ObjAnimate( "spr_wineshelf_2_bottle_4", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_wineshelf_2_shadow_4", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_bar_2_wineshelf_2", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wineshelf_2", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bartenderbadge()

  local item = "inv_bartenderbadge";

  if ( common.ApplyObj( item, "obj_wineshelf_2_use_bartenderbadge", true ) ) then

    cmn.CallEventHandler( "use_bartenderbadge_inv" );
    cmn.CallEventHandler( "use_bartenderbadge_beg" );

    local func_after = function ()
      
     local func_end = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_bartenderbadge" );
      cmn.CallEventHandler( "use_bartenderbadge_end" );
      common.CloseSubRoom();
     end;
    
      ObjAnimate( "spr_wineshelf_2_cap_close", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      ObjAnimate( "spr_wineshelf_2_cap_open", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
   
  
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_bartenderbadge_wineshelf_2", 0, "", 0 );
  
    ObjAnimate( "spr_wineshelf_2_badge", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_bar_2_wineshelf_2", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wineshelf_2", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_dart()

  local item = "inv_dart";

  if ( common.ApplyObj( item, "obj_darts_use_dart", true ) and cmn.IsEventDone("get_truckkey") ) then

    cmn.CallEventHandler( "use_dart_inv" );
    cmn.CallEventHandler( "use_dart_beg" );

    local func_after = function ()
    
      local func_end = function () 
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_dart" );
        cmn.CallEventHandler( "use_dart_end" );
        
      end;

      ObjSet( "anm_darts_dart_open", { alp = 1, playing = true, endtrig = func_end } );
      ObjSet( "anm_darts_dart", { alp = 0 } );
      ObjSet( "spr_darts_darts", { alp = 0 } );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_dart_darts", 0, "", 0 );
    
    ObjSet( "anm_darts_dart", { alp = 1, playing = true, endtrig = func_after } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_bar_2_darts", false ) and cmn.IsEventDone("get_truckkey") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_darts", nil, { 512, 320 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mechanismpart()

  local item = "inv_mechanismpart";

  if ( common.ApplyObj( item, "obj_darts_use_mechanismpart", true ) and cmn.IsEventDone("use_dart") ) then

    cmn.CallEventHandler( "use_mechanismpart_inv" );
    cmn.CallEventHandler( "use_mechanismpart_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_mechanismpart" );
      cmn.CallEventHandler( "use_mechanismpart_end" );
      common.CloseSubRoom();
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_mechanismpart_darts", 0, "", 0 );
    
    ObjAnimate( "spr_darts_mg_mechanismpart", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_bar_2_darts", false ) and cmn.IsEventDone("use_dart") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_darts", nil, { 512, 320 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_2_2()

  local item = "inv_elf_2_1";

  if ( common.ApplyObj( item, "obj_jukebox_use_elf_2_2", true ) ) then

    cmn.CallEventHandler( "use_elf_2_2_inv" );
    cmn.CallEventHandler( "use_elf_2_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_elf_2_2" );
      cmn.CallEventHandler( "use_elf_2_2_end" );
      
      private.get_crestfragment();
      
      ObjSet( "spr_jukebox_use_elf", { alp = 1 });
      
      interface.InventoryItemAdd( "inv_elf_2_1", "spr_jukebox_use_elf", nil, "video" );
      
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
      
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_jukebox_use_elf", 0, "", 0 );
    
    ObjSet( "vid_jukebox_use_elf", { pos_z = 4,  playing = true, endtrig = func_after });
    
    ObjAnimate( "spr_jukebox_crestfragment", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      3.6, 0, 1.0,
      3.9, 0, 0.0,
    } );
    
    ObjAnimate( "spr_jukebox_crestfragment_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      3.6, 0, 1.0,
      3.9, 0, 0.0,
    } );
    
    interface.InventoryItemRemove( "inv_elf_2_1" ); 
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_bar_2_jukebox", false ) and not cmn.IsEventDone( "use_elf_2_2" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_jukebox", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_25pence()

  local item = "inv_25pence";

  if ( common.ApplyObj( item, "obj_jukebox_use_25pence", true ) and cmn.IsEventDone( "use_musictracklist" ) ) then

    cmn.CallEventHandler( "use_25pence_inv" );
    cmn.CallEventHandler( "use_25pence_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_25pence" );
        cmn.CallEventHandler( "use_25pence_end" );
        
      end;
      
      --ObjAnimate( "spr_jukebox_door_add", "alp", 0, 0, "",
      --{ 
      --  0.0, 0, 0.0, 
      --  0.3, 0, 1.0
      --} );
      ObjAnimate( "spr_jukebox_lamp_add", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_25pence_jukebox", 0, "", 0 );
    
    AnimPlay( "anm_jukebox_coin", "DoAnim", func_after );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_bar_2_jukebox", false ) and cmn.IsEventDone( "use_musictracklist" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_jukebox", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_musictracklist()

  local item = "inv_musictracklist";

  if ( common.ApplyObj( item, "obj_jukebox_use_musictracklist", true ) ) then

    cmn.CallEventHandler( "use_musictracklist_inv" );
    cmn.CallEventHandler( "use_musictracklist_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_musictracklist" );
      cmn.CallEventHandler( "use_musictracklist_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_musictracklist_jukebox", 0, "", 0 );
    
    ObjAnimate( "spr_jukebox_list", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_bar_2_jukebox", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_jukebox", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_crestfragment()

  local item = "inv_crestfragment";

  if ( common.ApplyObj( item, "obj_crest_use_crestfragment", true ) ) then

    cmn.CallEventHandler( "use_crestfragment_inv" );
    cmn.CallEventHandler( "use_crestfragment_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_crestfragment" );
        cmn.CallEventHandler( "use_crestfragment_end" );
        
      end;
      
      --ObjAnimate( "spr_crest_crest", "alp", 0, 0, func_end,
      --{ 
      --  0.0, 0, 1.0, 
      --  0.3, 0, 0.0
      --} );
      
      ObjSet( "anm_crest_falling", { alp = 1, playing = true, endtrig = func_end } );
      ObjSet( "spr_crest_crest", { alp = 0 } );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_crestfragment_crest", 0, "", 0 );
    
    ObjAnimate( "spr_crest_crestfragment", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_bar_2_crest", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_crest", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bomb()

  local item = "inv_bomb";

  if ( common.ApplyObj( item, "obj_crest_use_bomb", true ) and cmn.IsEventDone("use_crestfragment") 
    and cmn.IsEventDone("get_musictracklist") and cmn.IsEventDone("get_mtmap") ) then

    cmn.CallEventHandler( "use_bomb_inv" );
    cmn.CallEventHandler( "use_bomb_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_bomb" );
      cmn.CallEventHandler( "use_bomb_end" );
      common.CloseSubRoom();
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_bomb_crest", 0, "", 0 );
    
    ObjAnimate( "spr_crest_bomb", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_bar_2_crest", false ) and cmn.IsEventDone("use_crestfragment")
    and cmn.IsEventDone("get_musictracklist") and cmn.IsEventDone("get_mtmap")  then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_crest", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_emblem()

  local item = "inv_emblem";

  if ( common.ApplyObj( item, "obj_crest_use_emblem", true ) and cmn.IsEventDone("use_bomb")) then

    cmn.CallEventHandler( "use_emblem_inv" );
    cmn.CallEventHandler( "use_emblem_beg" );

    local func_after = function ()
    
      local func_end = function ()
  
        common_impl.Lock( false );
        cmn.SetEventDone( "use_emblem" );
        cmn.CallEventHandler( "use_emblem_end" );
        
      end;
    
    ObjSet( "anm_crest_door", { alp = 1, playing = true, endtrig = func_end } );
    ObjSet( "spr_crest_door", { alp = 0 } );
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_emblem_crest", 0, "", 0 );
  
  ObjAnimate( "spr_crest_emblem", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
 
  return true;
  
  elseif common.ApplyObj( item, "gzz_bar_2_crest", false ) and cmn.IsEventDone("use_bomb") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_crest", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_device_2()
 
  --cmn.CallEventHandler( "use_device_2_inv" );
  --cmn.CallEventHandler( "use_device_2_beg" );

  local func_after = function ()
   
    cmn.SetEventDone( "use_device_2" );
    cmn.CallEventHandler( "use_device_2_end" );
    
    common_impl.LoupeMgStart();
 
  end;
  
  func_after();

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_zipperslider()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_zipperslider" );
  cmn.CallEventHandler( "get_zipperslider" );

      if port.isPortable()==1 then
      iOS_RateMe();
    end;
end;
--------------------------------------------------------------------------------------------
function private.get_ruby()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_ruby" );
  cmn.CallEventHandler( "get_ruby" );

end;
--------------------------------------------------------------------------------------------
function private.get_truckkey()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_truckkey" );
  cmn.CallEventHandler( "get_truckkey" );

end;
--------------------------------------------------------------------------------------------
function private.get_mechanismpart()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_mechanismpart" );
  cmn.CallEventHandler( "get_mechanismpart" );
  
  if( cmn.IsEventDone("get_rifle") and cmn.IsEventDone("get_crestfragment") )then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_crestfragment()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_crestfragment" );
  cmn.CallEventHandler( "get_crestfragment" );
  
  if( cmn.IsEventDone("get_rifle") and cmn.IsEventDone("get_mechanismpart") )then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_rifle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_rifle" );
  cmn.CallEventHandler( "get_rifle" );

  if( cmn.IsEventDone("get_crestfragment") and cmn.IsEventDone("get_mechanismpart") )then
    
    common.CloseSubRoom();
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_mtmap()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_mtmap" );
  cmn.CallEventHandler( "get_mtmap" );

end;
--------------------------------------------------------------------------------------------
function private.get_dart()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_dart" );
  cmn.CallEventHandler( "get_dart" );
  
  if( cmn.IsEventDone("get_mtmap") and cmn.IsEventDone("get_board") and common_impl.IsGetCollect( "get_collect_2_2_4" )
    and cmn.IsEventDone("get_musictracklist") and cmn.IsEventDone("get_button_2_1") and cmn.IsEventDone("get_badgeelement_2_1") )then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_musictracklist()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_musictracklist" );
  cmn.CallEventHandler( "get_musictracklist" );

end;
--------------------------------------------------------------------------------------------
function private.get_button_2_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_button_2_1" );
  cmn.CallEventHandler( "get_button_2_1" );
  
  if( cmn.IsEventDone("get_mtmap") and cmn.IsEventDone("get_dart") and common_impl.IsGetCollect( "get_collect_2_2_4" )
    and cmn.IsEventDone("get_musictracklist") and cmn.IsEventDone("get_board") and cmn.IsEventDone("get_badgeelement_2_1") )then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_board()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_board" );
  cmn.CallEventHandler( "get_board" );
  
  if( cmn.IsEventDone("get_mtmap") and cmn.IsEventDone("get_dart") and common_impl.IsGetCollect( "get_collect_2_2_4" )
    and cmn.IsEventDone("get_musictracklist") and cmn.IsEventDone("get_button_2_1") and cmn.IsEventDone("get_badgeelement_2_1") )then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_badgeelement_2_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_badgeelement_2_1" );
  cmn.CallEventHandler( "get_badgeelement_2_1" );
  
  if( cmn.IsEventDone("get_mtmap") and cmn.IsEventDone("get_dart") and common_impl.IsGetCollect( "get_collect_2_2_4" )
    and cmn.IsEventDone("get_musictracklist") and cmn.IsEventDone("get_button_2_1") and cmn.IsEventDone("get_board") )then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_collect_2_2_4()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_2_4");
    cmn.CallEventHandler("get_collect_2_2_4");

    if ( cmn.IsEventDone("get_dart") and cmn.IsEventDone("get_musictracklist") and cmn.IsEventDone("get_mtmap")
      and cmn.IsEventDone("get_button_2_1") and cmn.IsEventDone("get_board") and cmn.IsEventDone("get_badgeelement_2_1") ) then
      
      common.CloseSubRoom();
      
    end;    

  end;

  common_impl.PlayEffectHO( "spr_crest_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_button( number )

  cmn.CallEventHandler( "clk_jukebox_beg" );
  
  local func_after = function()
  
    local func_end = function()
    
      common_impl.Lock( false );
      cmn.SetEventDone( "clk_jukebox" );
      cmn.CallEventHandler( "clk_jukebox_end" );
      
    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_open_jukebox", 0, "", 0 );
    
    if ( common_impl.CheckMusPlaying() ) then
    
      common_impl.VolumeFadingOff();
      
    else
      
      private.value = GetSoundVolume( "soundtrack" );
      
      SetSoundVolume( "jukebox_zz",  private.value );
      
    end;
    
    ObjSet( "spr_jukebox_door_add", { alp = 0 } );
 
    ObjAnimate( "spr_jukebox_door", "pos_xy", 0, 0, func_end,
    { 
      0.0, 0, 33, 119, 
      0.5, 0, 25, 225
    } );
    
  end;
  
  if number == 2 then
  
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_click_jukebox", 0, "", 0 );
    
    if ( common_impl.CheckMusPlaying() ) then
    
      common_impl.VolumeFadingOn();
      
    else

      SetSoundVolume( "jukebox_zz",  0 );
      
    end;
    
    ObjSet( "anm_jukebox_lamp_add_2", { alp = 0 } );
        
    local volume = GetSoundVolume( "soundtrack" );
    
    SetSoundVolume( "jukebox_jinigle",  volume );
 
    SndPlay( "assets/levels/common/audio/level2/aud_rock_jinigle_mus", "jukebox_jinigle", 0, 0, 0.2 );
 
    ObjSet( "tmr_jukebox_sound", { time = 9, playing = true, endtrig = func_after } );
     
  else
    
    common_impl.ShowBbt( 'bbt_jukebox_clk_wrong_button', 1 );

  end;
  
end;
--*********************************************************************************************************************
function private.clk_airplane_2()
  
  local func_after = function()
  
    common_impl.Lock( false );
    cmn.SetEventDone( "clk_airplane" );
    cmn.CallEventHandler( "clk_airplane_end" );
    
  end;
  
  common_impl.Lock( true );
  
  AnimPlay( "anm_bar_2_airplane_2", "DoAnim", func_after );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_bottle( num )
 
  if ng_global.progress[ "std" ][ "win_bottle" ].flag == 0 then 
    
    private.position = ObjGet( "spr_wineshelf_2_bottle_"..num).pos_z;
    private.Choice( num );
   
    
  else
    
    if  num == ng_global.progress[ "std" ][ "win_bottle" ].flag then
      
      ObjSet( "spr_wineshelf_2_bottle_"..num.."_add", { alp = 0});
      ObjSet( "spr_wineshelf_2_bottle_"..num, { pos_y = ObjGet("spr_wineshelf_2_bottle_"..num).pos_y + 70});
      
      ng_global.progress[ "std" ][ "win_bottle" ].flag = 0;
      
    else  
    
      private.Swap( num );
    
    end;
  
  end;
  
end; 
--------------------------------------------------------------------------------------------
function private.clk_door_chest()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_wineshelf_2_use_bartenderbadge' );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_chest_wineshelf_2", 0, "", 0 );
  
  ObjAnimate( "spr_wineshelf_2_cap_close", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, -91, 
    0.3, 0, -93,
    0.6, 0, -91
  } );
 
  
end; 
--------------------------------------------------------------------------------------------
function private.clk_anim( name )
  
  local func_after = function()
  
    common_impl.Lock( false );
  
    ObjSet( "obj_bar_2_clk_"..name, { input = true } );
   
    ObjSet( "anm_bar_2_"..name.."_loop", { alp = 1, playing = true } );
    ObjSet( "anm_bar_2_"..name, { alp = 0 } );
    
    if name == "man" then
      
      common_impl.PlayAudio( "env", "common/audio/level2/aud_sleeping_man_env", 1, "", 0 );
  
    end;
    
  end;

  if name == "man" then 
    
    common_impl.ShowBbt( 'bbt_bar_2_clk_man' );
    
    common_impl.StopAudio( "env", "common/audio/level2/aud_sleeping_man_env", 0 );
  
  end;
  
  if name == "hat" then 
    
    common_impl.ShowBbt( 'bbt_bar_2_clk_hat' );
  
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_"..name.."_bar_2", 0, "", 0 );
  
  ObjSet( "obj_bar_2_clk_"..name, { input = false } );
    
  ObjSet( "anm_bar_2_"..name.."_loop", { alp = 0, playing = false } );
  ObjSet( "anm_bar_2_"..name, { alp = 1 } );

  
  AnimPlay( "anm_bar_2_"..name, "DoAnim", func_after );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.Choice( num )
  
   local func_after = function ()
   
      common_impl.Lock( false );
      ng_global.progress[ "std" ][ "win_bottle" ].flag = num;
   
   end;
  
   common_impl.Lock( true );
   common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_wineshelf_select", 0, "", 0 );
   
    ObjAnimate( "spr_wineshelf_2_bottle_"..num.."_add", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
      
    } );
    
  --  ObjAnimate( "spr_wineshelf_2_bottle_"..num, "scale_x", 0, 0, "",
  --  { 
  --    0.0, 0, ObjGet("spr_wineshelf_2_bottle_"..num).scale_x, 
  --    0.3, 0, ObjGet("spr_wineshelf_2_bottle_"..num).scale_x * 1.1
  --    
  --  } );
  --  
  --  ObjAnimate( "spr_wineshelf_2_bottle_"..num, "scale_y", 0, 0, "",
  --  { 
  --    0.0, 0, ObjGet("spr_wineshelf_2_bottle_"..num).scale_y, 
  --    0.3, 0, ObjGet("spr_wineshelf_2_bottle_"..num).scale_y * 1.1
  --    
  --  } );
    ObjAnimate( "spr_wineshelf_2_bottle_"..num, "pos_y", 0, 0, "",
    { 
      0.0, 0, ObjGet("spr_wineshelf_2_bottle_"..num).pos_y, 
      0.3, 0, ObjGet("spr_wineshelf_2_bottle_"..num).pos_y - 70
      
    } );

end; 
-----------------------------------------------------------------------------------------
function private.Swap( num )
  
   local position_1 = 0;
   local position_2 = 0;
   local buffer = 0;
   local count = 0;
   
   for i = 1, 5  do
     
     if ng_global.progress[ "std" ][ "win_bottle" ].flag  == ng_global.progress[ "std" ][ "win_bottle" ].array[i] then
       
         position_1 = i;
         
     end; 
     
     if num == ng_global.progress[ "std" ][ "win_bottle" ].array[i] then
       
        position_2 = i;
       
     end;   
     
   end;
   
  
   local func_after = function ()
   
    local func_end = function ()
   
      common_impl.Lock( false );
      local temp = { 0, 0, 0, 0, 0};
      
      for i = 1, 5  do
        
        temp[i] = ng_global.progress[ "std" ][ "win_bottle" ].array[i];
        
      end;
      --
      
      --
      buffer = ng_global.progress[ "std" ][ "win_bottle" ].flag;
      temp[position_1] = num;
      temp[position_2] = buffer;
      ng_global.progress[ "std" ][ "win_bottle" ].flag = 0;
      
      for i = 1, 5  do
        
        -- if ng_global.progress[ "std" ][ "win_bottle" ].array[i] == private.win[i] then 
        
        if temp[i] == private.win[i] then
          
          count = count + 1;
          
        end;
        
      end
      
      if  count == 5 then  
      
       DbgTrace(ng_global.progress[ "std" ][ "win_bottle" ].array[1]);
       DbgTrace(ng_global.progress[ "std" ][ "win_bottle" ].array[2]);
       DbgTrace(ng_global.progress[ "std" ][ "win_bottle" ].array[3]);
       DbgTrace(ng_global.progress[ "std" ][ "win_bottle" ].array[4]);
       DbgTrace(ng_global.progress[ "std" ][ "win_bottle" ].array[5]);
       private.win_anim_bottle()
      
      else
      
       for i = 1, 5  do
        
         ng_global.progress[ "std" ][ "win_bottle" ].array[i] = temp[i];
        
       end;
       
      end;
      
    end;
    
  
  --  ObjSet( "spr_wineshelf_2_bottle_"..num, { pos_x = private.matrix_pos_x[num][position_1] , pos_y = private.matrix_pos_y[num][position_1], pos_z = position_1, scale_x = private.matrix_scale[num][position_1], scale_y = private.matrix_scale[num][position_1]});
  --  ObjSet( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag, { pos_x = private.matrix_pos_x[ng_global.progress[ "std" ][ "win_bottle" ].flag][position_2], pos_y = private.matrix_pos_y[ng_global.progress[ "std" ][ "win_bottle" ].flag][position_2], pos_z = position_2, scale_x = private.matrix_scale[ng_global.progress[ "std" ][ "win_bottle" ].flag][position_2], scale_y = private.matrix_scale[ng_global.progress[ "std" ][ "win_bottle" ].flag][position_2]});
  --  ObjSet( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag.."_add", { alp = 0 });
  --  
  --  ObjAnimate( "spr_wineshelf_2_bottle_"..num, "alp", 0, 0, func_end,
  --  { 
  --    0.0, 0, 0.0, 
  --    0.2, 0, 1.0
  --  } );
  --  
  --  ObjAnimate( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag, "alp", 0, 0, "",
  --  { 
  --    0.0, 0, 0.0, 
  --    0.2, 0, 1.0
  --  } );
  --   
  -- 
  
---pos_x
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_wineshelf_move", 0, "", 0 );
    ObjAnimate( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag, "pos_x", 0, 0, "",
    { 
    
      0.0, 0, ObjGet( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag).pos_x,
      0.3, 0, private.matrix_pos_x[ng_global.progress[ "std" ][ "win_bottle" ].flag][position_2] 
      
    } );
    
    ObjAnimate( "spr_wineshelf_2_bottle_"..num, "pos_x", 0, 0, "",
    { 
    
      0.0, 0, ObjGet( "spr_wineshelf_2_bottle_"..num).pos_x,
      0.3, 0, private.matrix_pos_x[num][position_1] 
      
    } ); 
    
---pos_z 

    ObjAnimate( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag, "pos_z", 0, 0, "",
    { 
    
      0.0, 0, ObjGet( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag).pos_x,
      0.3, 0, position_2 
      
    } );
    
    ObjAnimate( "spr_wineshelf_2_bottle_"..num, "pos_z", 0, 0, "",
    { 
    
      0.0, 0, ObjGet( "spr_wineshelf_2_bottle_"..num).pos_z,
      0.3, 0, position_1 
      
    } ); 
   
---scale_x

    ObjAnimate( "spr_wineshelf_2_bottle_"..num, "scale_x", 0, 0, "",
    { 
    
      0.0, 0, ObjGet( "spr_wineshelf_2_bottle_"..num).scale_x, 
      0.3, 0, private.matrix_scale[num][position_1] 
      
    } );
    
    ObjAnimate( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag, "scale_x", 0, 0, "",
    { 
    
      0.0, 0, ObjGet( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag).scale_x, 
      0.3, 0, private.matrix_scale[ng_global.progress[ "std" ][ "win_bottle" ].flag][position_2] 
      
    } );

---scale_y  

    ObjAnimate( "spr_wineshelf_2_bottle_"..num, "scale_y", 0, 0, "",
    { 
    
      0.0, 0, ObjGet( "spr_wineshelf_2_bottle_"..num).scale_y, 
      0.3, 0, private.matrix_scale[num][position_1] 
      
    } );
    
    ObjAnimate( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag, "scale_y", 0, 0, "",
    { 
    
      0.0, 0, ObjGet( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag).scale_y, 
      0.3, 0, private.matrix_scale[ng_global.progress[ "std" ][ "win_bottle" ].flag][position_2] 
      
    } );  
---pos_y
    
    ObjAnimate( "spr_wineshelf_2_bottle_"..num, "pos_y", 0, 0, "",
    { 
    
      0.0, 0, ObjGet( "spr_wineshelf_2_bottle_"..num).pos_y,
      0.3, 0, ObjGet( "spr_wineshelf_2_bottle_"..num).pos_y,
      0.6, 0, private.matrix_pos_y[num][position_1] 
      
    } );
    
    ObjAnimate( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag, "pos_y", 0, 0, func_end,
    { 
    
      0.0, 0, ObjGet( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag).pos_y,
      0.3, 0, ObjGet( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag).pos_y,
      0.6, 0, private.matrix_pos_y[ng_global.progress[ "std" ][ "win_bottle" ].flag][position_2] 
        
    } );
    
  
    end;
  --
  -- common_impl.Lock( true );
  -- 
  --  ObjAnimate( "spr_wineshelf_2_bottle_"..num, "alp", 0, 0, func_after,
  --  { 
  --    0.0, 0, 1.0, 
  --    0.2, 0, 0.0
  --  } );
  --  
  --  ObjAnimate( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag, "alp", 0, 0, "",
  --  { 
  --    0.0, 0, 1.0, 
  --    0.2, 0, 0.0
  --  } );
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_wineshelf_select", 0, "", 0 );
  
  ObjSet( "spr_wineshelf_2_bottle_"..ng_global.progress[ "std" ][ "win_bottle" ].flag.."_add", { alp = 0 });
  
---pos_z  

  
---pos_y

    ObjAnimate( "spr_wineshelf_2_bottle_"..num, "pos_y", 0, 0, func_after,
    { 
    
      0.0, 0, ObjGet( "spr_wineshelf_2_bottle_"..num).pos_y, 
      0.3, 0, ObjGet( "spr_wineshelf_2_bottle_"..num).pos_y - 70
      
    } );
---pos_x    
    
  

    
end; 
----------------------------------------------------------------------------------------
function private.win_anim_bottle()
  
  local func_after = function()
  
    private.win_bottle();
  
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_wineshelf_win", 0, "", 0 );
  ObjSet( "obj_wineshelf_2_mmg_shelf", { alp = 0 } );
  ObjSet( "spr_wineshelf_2_door", { alp = 0 } );
  ObjSet( "anm_wineshelf_2_mmg", { alp = 1, playing = true, endtrig = func_after } );
  
end;
--------------------------------------------------------------------------------------------
function private.win_bottle()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   

  common_impl.Lock( false );
  cmn.MiniGameHide( "bottle" );
  common_impl.PassingMgWin( "bottle" );
  cmn.SetEventDone( "win_bottle" );
  cmn.CallEventHandler( "win_bottle" );
  
  
end;  
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.skip_jukebox()
  
  private.win_anim();
  
end;
--------------------------------------------------------------------------------------------
function private.skip_bottle()
  
  local func_after = function()
  
   local func_end = function()
  
    private.win_anim_bottle();
    
   end;
   
   for  i = 1, 5  do
    
     ObjSet( "spr_wineshelf_2_bottle_"..private.win[i], { pos_x = private.matrix_pos_x[ private.win[i] ][i], pos_y = private.matrix_pos_y[private.win[i] ][i], pos_z = i , scale_x = private.matrix_scale[private.win[i] ][i], scale_y = private.matrix_scale[private.win[i] ][i]}); 
      ObjAnimate( "spr_wineshelf_2_bottle_"..i, "alp", 0, 0, func_end,
      { 
        0.0, 0, 0,  
        0.2, 0, 1
        
      });
      func_end = "";
    end;
  
  end;
  
  common_impl.Lock( true );
  
  for  i = 1, 5  do
    
    ObjAnimate( "spr_wineshelf_2_bottle_"..i, "alp", 0, 0, func_after,
    { 
      0.0, 0, 1,  
      0.2, 0, 0
      
    });
    func_after ="";
  end;
  
end;  
--------------------------------------------------------------------------------------------
function private.reset_jukebox()
  
  
end;
-------------------------------------------------------------------------------------------
function private.reset_bottle()
  
  for i = 1, 5  do
    
    ObjSet( "spr_wineshelf_2_bottle_"..i.."_add", { alp = 0});
    DbgTrace( private.startmas[i] );
    DbgTrace( private.matrix_pos_x[private.startmas[i] ][i] );
    --ObjSet( "spr_wineshelf_2_bottle_"..private.start[i], { pos_x = private.matrix_pos_x[private.startmas[i] ][i], pos_y = private.matrix_pos_y[private.start[i] ][i], pos_z = i, scale_x = private.matrix_scale[private.startmas[i] ][i], scale_y = private.matrix_scale[private.startmas[i] ][i]});
    ObjSet( "spr_wineshelf_2_bottle_"..private.startmas[i], { pos_x = private.matrix_pos_x[private.startmas[i] ][i], pos_y = private.matrix_pos_y[private.startmas[i] ][i], pos_z = i , scale_x = private.matrix_scale[private.startmas[i] ][i], scale_y = private.matrix_scale[private.startmas[i] ][i]}); 
  
  end;
                        
  --private.startmas = { 5, 2, 1, 4, 3 }; 
  
  --ng_global.progress[ "std" ][ "win_bottle" ].array = private.startmas;
  ng_global.progress[ "std" ][ "win_bottle" ].array = { 5, 2, 1, 4, 3 };
  ng_global.progress[ "std" ][ "win_bottle" ].flag = 0;
  
end;
--*********************************************************************************************************************
function public.Skip( name )

  if name == "win_jukebox" then
      
      private.skip_jukebox();

  end;
    
  if name == "win_bottle" then
      
    private.skip_bottle();

  end;
  
  if name == "win_bar_2" then

    private.skip_loupe();
    
  end;
    

end;
--*********************************************************************************************************************
function public.Reset( name )
  
  if name == "win_jukebox" then
      
    private.reset_jukebox();

  end;
  
  if name == "win_bottle" then
      
    private.reset_bottle();

  end;
  
  if event == "win_bar_2" then
    
    private.loupe_mmg_wrong_anim();
    
  end;
    
end;
--*********************************************************************************************************************
function private.opn_bar_2()

  if not ( cmn.IsEventDone( "opn_bar_2" ) ) then
    cmn.SetEventDone( "opn_bar_2" );
    interface.KeyTaskAdd( 'storage', true );
    ng_global.progress["std"]["opn_bar_2"].see_anim = false;
    --common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0 );
    --common_impl.SetSoundTimer( 54, "mus", "common/audio/aud_adventure1_mus" );
    
  end;
  
  cmn.CallEventHandler( "opn_bar_2" ); 

end;
--*********************************************************************************************************************
function private.AnimPlay()
  
  if not ng_global.progress["std"]["opn_bar_2"].see_anim then
    
    ng_global.progress["std"]["opn_bar_2"].see_anim = true;
    
    common_impl.Lock( true );
    
    ObjSet( "anm_bar_2_airplane", { alp = 1, playing = true, endtrig = function() common_impl.Lock( false ); end } );
    
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_paper_plane", 0, "", 0 );
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.StopAnims()
  
  local list = { "man", "hat", "jacket" };
  
  for i = 1, #list do
    
    AnimStop( "anm_bar_2_"..list[i] );
    
    ObjSet( "obj_bar_2_clk_"..list[i], { input = true } );
    
    if ( ObjGet( "anm_bar_2_"..list[i].."_loop" ) ) then
    
      ObjSet( "anm_bar_2_"..list[i].."_loop", { alp = 1, playing = true } );
      ObjSet( "anm_bar_2_"..list[i], { alp = 0 } );
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.vid_bar_2_loupe()

  local func_after = function ()

    common_impl.Lock( false );

    int_loupe.Hide();
  
    cmn.SetEventDone( "vid_bar_2_loupe" );
    cmn.CallEventHandler( "vid_bar_2_loupe" );
    common_impl.ShowBbt( 'bbt_vid_bar_2_loupe', 1 );
    
    private.zoom_darts();
 
  end;

  common_impl.Lock( true );
  
  local func_after_man_1 = function ()
  
    local func_after_stand_1 = function ()
        
      local func_after_man_2 = function ()
       
         local func_after_stand_2 = function ()
         
         ObjSet( "anm_bar_2_loupe_man_2", { alp = 0 } );
    
           ObjSet( "anm_bar_2_loupe_man_3", { alp = 1, playing = true, endtrig = func_after } );
           
           common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_hide", 0, "", 0 );
         
         end;
  
         ObjAnimate( "spr_bar_2_loupe_text_2", "alp", 0, 0, func_after_stand_2, { 0,0,0, 0.3,0,1 , 2.3,0,1, 2.6,0,0 } );
         
         common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_txt", 0, "", 0 );
       
       end;
       
       ObjSet( "anm_bar_2_loupe_man_1", { alp = 0 } );
    
       ObjSet( "anm_bar_2_loupe_man_2", { alp = 1, playing = true, endtrig = func_after_man_2 } );
       
       common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_move", 0, "", 0 );
    
    end;
    
     ObjAnimate( "spr_bar_2_loupe_text_1", "alp", 0, 0, func_after_stand_1, { 0,0,0, 0.3,0,1 , 1.3,0,1, 1.6,0,0 } );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_txt", 0, "", 0 );
  
  end;

  --common_impl.StopAllMus();
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_show", 0, "", 0 );
 
  ObjSet( "obj_bar_2_loupe_anim", { active = true, visible = true } );
  ObjSet( "anm_bar_2_loupe_man_1", { alp = 1, playing = true, endtrig = func_after_man_1 } );

end;
--*********************************************************************************************************************
function private.zoom_darts()
  
  local func_after = function()
  
    local func_after_zoom = function()
    
      common_impl.Lock( false );
      
      --interface.KeyTaskDone( "find_avenger_2", true, function() interface.KeyTaskAdd( "open_staircase", true ) end  );
      --
      --ng_global.task_current = "open_staircase";
    
    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_out", 0, "", 0 );
    
    ObjAnimate( "rm_bar_2", "scale_xy", 0, 0, func_after_zoom, { 0,0,1.2,1.2, 0.6,0,1,1 } );  
    ObjAnimate( "rm_bar_2", "pos_xy", 0, 0, "", { 0,0,-235,-1, 0.6,0,0,0 } );
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_in", 0, "", 0 );
  
  ObjAnimate( "rm_bar_2", "scale_xy", 0, 0, func_after, { 0,0,1,1, 0.6,0,1.2,1.2, 1.3,0,1.2,1.2 } );  
  ObjAnimate( "rm_bar_2", "pos_xy", 0, 0, "", { 0,0,0,0, 0.6,0,-235,-1, 1.3,0,-235,-1 } );
  
end;
--*********************************************************************************************************************
function private.skip_loupe()

  private.win_loupe();
  
end;
--*********************************************************************************************************************
function private.reset_loupe()

  private.loupe_mmg_wrong_anim();
  
end;
--*********************************************************************************************************************
function private.win_loupe()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   

  common_impl.Lock( false );
  cmn.MiniGameHide( "bar_2" );
  common_impl.PassingMgWin( "bar_2" );
  cmn.SetEventDone( "win_bar_2" );
  cmn.CallEventHandler( "win_bar_2" );
  
  public.vid_bar_2_loupe();
 
end;
--*********************************************************************************************************************
-- function *** LOUPE *** () end;
--*********************************************************************************************************************
  function private.loupe_mmg_anim()
    
    ObjAnimate( "obj_bar_2_loupe_mg_signs", "pos_xy", 1, 0, "", { 0,0,0,0, 2.5,0,-5,-4, 5,0,0,0 } );
  
  end;
--*********************************************************************************************************************
  function private.loupe_mmg_clk_sign( i, j )
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_click", 0, "", 0 );
    
    local params = GetObjPosByObj( "spr_bar_2_loupe_mg_sign_"..i.."_"..j, "obj_bar_2_loupe_mg" );

    ObjSet( "obj_bar_2_loupe_mg_line", { pos_x = params[1], pos_y = params[2],
                                            event_startdrag = function() private.loupe_mmg_start_drag( i, j ) end,
                                            event_drag = function() private.loupe_mmg_drag( i, j ) end,
                                            event_dragdrop = function() private.loupe_mmg_drag_drop( i, j ) end } );
    
    ObjStartDrag( "obj_bar_2_loupe_mg_line" );

  end;
--*********************************************************************************************************************
  function public.loupe_mmg_start()
 
    if not ng_global.progress["std"]["win_bar_2"].saves then
                                                        
      ng_global.progress["std"]["win_bar_2"].saves = { { { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 } }, 
                                                            
                                                          { { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 } } }; 
    end;

  end;
--*********************************************************************************************************************
  function private.loupe_mmg_start_drag( i, j )
  
    if not private.start_drag_auto then
    
    private.pos_x_line = GetObjPosByObj( "spr_bar_2_loupe_mg_sign_"..i.."_"..j, "rm_bar_2_loupe" )[1] - 511;
    private.pos_y_line = GetObjPosByObj( "spr_bar_2_loupe_mg_sign_"..i.."_"..j, "rm_bar_2_loupe" )[2] - 383;
    
    if i == 2 then

      private.pos_y_line = private.pos_y_line + 4;
      
    end;
    
    private.pos = GetObjPosByObj( "spr_bar_2_loupe_mg_sign_"..i.."_"..j, "rm_bar_2_loupe" );
   
    private.pos_x_cur = private.pos[1];
    private.pos_y_cur = private.pos[2];
    
    --DbgTrace( private.pos_x_line.." "..private.pos_y_line.."   "..private.pos_x_cur.." "..private.pos_y_cur );
 
    --common_impl.PlayAudio( "sfx", "common/audio/level1/aud_int_tablet_click", 0, "", 0 );

  end;

  private.loupe_mmg_input_stop_drag = false;
  private.loupe_mmg_stop_drag_flag = false;

  end;
--*********************************************************************************************************************
  function private.loupe_mmg_drag( i, j )

  common_impl.SetCursor( CURSOR_GET );

    if ObjIntersect( "obj_bar_2_loupe_mg_line", "obj_bar_2_loupe_mg" ) then

      local cur_pos = GetZoomCursorPos();
      pos_x1 = cur_pos[ 1 ];
      pos_y1 = cur_pos[ 2 ];

      dx = pos_x1 - private.pos_x_cur;
      dy = pos_y1 - private.pos_y_cur;
      s = math.sqrt(dx^2+dy^2);
      angl = (math.atan2(dx,dy))- 1.57; 
  
      lenght = 2;--коэффициент

      ObjSet( "tmr_bar_2_loupe_mmg", 
      { 
        playing = true, 
        time = 0.01,  
        endtrig = function() private.loupe_mmg_drag(i, j) end ;
      } );
      
 

      ObjSet( "spr_bar_2_loupe_mg_line", { alp = 1 } );
      ObjSet( "spr_bar_2_loupe_mg_line",
        {
         pos_x = private.pos_x_line,
         pos_y = private.pos_y_line,
         ang = angl, 
         scale_x = s / lenght,
         blendmode = 2;
        } );
        
      --ObjSet( "obj_bar_2_loupe_mg_line_input",
      --{
      -- pos_x = s/2,
      -- pos_y = 0,
      -- inputrect_w = s - 20, 
      -- inputrect_x = - ( ( s - 20 )/2 ),
      -- inputrect_h = 10,
      -- inputrect_y = -3,
      -- attachtype = 2,
      --} );

    else 
        
        private.loupe_mmg_wrong_anim();

      if private.loupe_mmg_stop_drag_flag == false then

        private.loupe_mmg_input_stop_drag = true;

        ObjStopDrag( "obj_bar_2_loupe_mg_line" );

        private.loupe_mmg_stop_drag_flag = true;
        
        --common_impl.PlayAudio( "sfx", "common/audio/level1/aud_int_tablet_wrong", 0, "", 0 );

      end;
        
    end;

  end;
--*********************************************************************************************************************
  function private.loupe_mmg_stop_drag()

  ObjSet( "tmr_bar_2_loupe_mmg", { playing = 0 } );
  ObjSet( "spr_bar_2_loupe_mg_line", { alp = 0 } );

  end;
---------------------------------------------------------------------------------
  function private.loupe_mmg_drag_drop( i, j )
    
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_click", 0, "", 0 );

  common_impl.SetCursor( CURSOR_DEFAULT );
  local name = "obj_bar_2_loupe_mg_line";
  local points = {};
  local old = {};
  old[1] = i;
  old[2] = j;

  --[[поиск куда бросили ]]

  private.start_drag_auto = false;

  if not private.loupe_mmg_input_stop_drag then
   
    for k = 1, 2 do  
      for l = 1, 4 do  
        if ObjIntersect( name, "spr_bar_2_loupe_mg_sign_"..k.."_"..l ) and not ( k == i and l == j ) then
          points[1] = k;
          points[2] = l;
        end;
      end;
    end;

    local pos_star = { 
      private.pos_x_line, 
      private.pos_y_line
    };

    if points[1] and points[2] and points[1] ~= old[1] then
      
      local pos_star_2 = GetObjPosByObj( "spr_bar_2_loupe_mg_sign_"..points[1].."_"..points[2], "obj_bar_2_loupe_mg" );
      
      if points[1] == 2 then
        
        pos_star_2[2] = pos_star_2[2] + 4;
        
      end;

      private.loupe_mmg_make_line( pos_star, pos_star_2, points[1],points[2], old[1],old[2], false );

      --common_impl.PlayAudio( "sfx", "common/audio/aud_mg_key_true", 0, "", 0 );
      
      elseif  private.loupe_mmg_win_pointer ~= 8 then
      
      private.loupe_mmg_wrong_anim();
      
    end;

  end;

  private.loupe_mmg_stop_drag();

  end;
---------------------------------------------------------------------------------
  function private.loupe_mmg_make_line( elem_1, elem_2, i, j, n, m, save )
  
  local pos_x1 = elem_1[ 1 ];
  local pos_y1 = elem_1[ 2 ];

  local pos_x2 = elem_2[ 1 ]
  local pos_y2 = elem_2[ 2 ];
  
  local dx = pos_x1 - pos_x2;
  local dy = pos_y1 - pos_y2;
  local s = math.sqrt(dx^2+dy^2);
  local angl = (math.atan2(dx,dy)) - 1.57; 
  local lenght = 2;
  
  --DbgTrace( pos_x1.." "..pos_y1.."  "..pos_x2.." "..pos_y2 );

  ObjSet( "spr_bar_2_loupe_mg_line", { alp = 0 } );

  if not ObjGet( "spr_bar_2_loupe_mg_line_"..i.."_"..j ) and i ~= n then
  
    ObjCreate( "spr_bar_2_loupe_mg_line_"..i.."_"..j, "spr" );
    ObjAttach( "spr_bar_2_loupe_mg_line_"..i.."_"..j, "obj_bar_2_loupe_mg_signs" );
    ObjSet( "spr_bar_2_loupe_mg_line_"..i.."_"..j,
      {
       res = "assets/interface/resources/apparatus/line",
       pos_x =  pos_x1,
       pos_y =  pos_y1,
       ang = angl, 
       scale_x = s / lenght,
       scale_y = 1;
       drawoff_x = -1,
       blendmode = 2;
      } );
     
     ObjCreate( "obj_bar_2_loupe_mg_line_"..i.."_"..j.."_input", "obj" );
     ObjAttach( "obj_bar_2_loupe_mg_line_"..i.."_"..j.."_input", "spr_bar_2_loupe_mg_line_"..i.."_"..j ); 
     
     local weight = 0.76 + 0.01* ( s / 50 );
     
     ObjSet( "obj_bar_2_loupe_mg_line_"..i.."_"..j.."_input",
      {
      pos_x = -1,
       pos_y = 0,
       input = true,
       inputrect_init = true,
       inputrect_w = 2*weight, 
       inputrect_x = -weight,
       inputrect_h = 10,
       inputrect_y = -5,
      } ); 
      
    local pos_star_2 = GetObjPosByObj( "spr_bar_2_loupe_mg_sign_"..i.."_"..j, "obj_bar_2_loupe_mg" );
      
    if not save then

      ObjSet( "obj_bar_2_loupe_mg_line", { 
      pos_x = pos_x2,
      pos_y = pos_y2,
      event_startdrag = function () private.loupe_mmg_start_drag(i,j) end,
      event_drag = function () private.loupe_mmg_drag(i,j) end,
      event_dragdrop = function () private.loupe_mmg_drag_drop(i,j) end } );
      
      ObjSet( "spr_bar_2_loupe_mg_sign_"..n.."_"..m, { input = false } );
      
      if not private.loupe_mmg_check_intersect() then
      
        --ng_global.progress["std"]["win_bar_2"].saves[i][j][m] = 1;
        ng_global.progress["std"]["win_bar_2"].saves[n][m][j] = 1;
        
        private.loupe_mmg_win_pointer = private.loupe_mmg_win_pointer + 1;
     
        if private.loupe_mmg_win_pointer ~= 8 then

          private.pos_x_line = ObjGet( "spr_bar_2_loupe_mg_sign_"..i.."_"..j ).pos_x;
          private.pos_y_line = ObjGet( "spr_bar_2_loupe_mg_sign_"..i.."_"..j ).pos_y;

          private.pos = GetObjPosByObj( "spr_bar_2_loupe_mg_sign_"..i.."_"..j );
            
          private.pos_x_cur = private.pos[1];
          private.pos_y_cur = private.pos[2];

          private.start_drag_auto = true; 
          
        else
          
          private.loupe_mmg_win_anim();
            
        end;
        
        private.loupe_mmg_light_anim( i, j );
        
      else
        
        private.loupe_mmg_wrong_anim();
        
      end;
      
    end;

  else

    private.loupe_mmg_wrong_anim();

  end;
 
  end;
------------------------------------------------------------------------------------------
 function private.loupe_mmg_check_intersect()
 
   local intersect_array = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
 
   for i = 1, 15 do

   for j = 1, 2 do
     
     for k = 1, 4 do
 
       if ObjGet( "obj_bar_2_loupe_mg_line_"..j.."_"..k.."_input" ) and
         ObjIntersect( "obj_bar_2_loupe_mg_intersect_"..i, "obj_bar_2_loupe_mg_line_"..j.."_"..k.."_input" ) then
          
          intersect_array[i] = intersect_array[i] + 1;
          
          if intersect_array[i] > 1 then
            
            return true;
            
          end;
          
        end;
       
     end;
     
   end;
   
 end;
  
  return false;
   
 end;
------------------------------------------------------------------------------------------
  function private.loupe_mmg_wrong_anim()
    
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_wrong", 0, "", 0 );

  private.loupe_mmg_stop_drag();
    
  private.loupe_mmg_win_pointer = 0;
  
  local lines = ObjGetRelations( "obj_bar_2_loupe_mg_signs" ).childs;

  for j = 1, #lines do
    
    if ObjGet( lines[j] ) and string.find( ObjGet( lines[j] ).name, "line" ) then

      ObjDelete( lines[j] );

    end;

  end;
  
  for i = 1, 2 do
    
    for k = 1, 4 do
      
      ObjSet( "spr_bar_2_loupe_mg_sign_"..i.."_"..k.."_light", { alp = 0 } );
      ObjSet( "spr_bar_2_loupe_mg_sign_"..i.."_"..k, { input = true } );
   
    end;
    
  end;
    
   ng_global.progress["std"]["win_bar_2"].saves = { { { 0,0,0,0 },
                                                      { 0,0,0,0 },
                                                      { 0,0,0,0 },
                                                      { 0,0,0,0 } }, 
                                                      
                                                    { { 0,0,0,0 },
                                                      { 0,0,0,0 },
                                                      { 0,0,0,0 },
                                                      { 0,0,0,0 } } }; 
    
  end;
------------------------------------------------------------------------------------------
  function private.loupe_mmg_light_anim( i, j )
  
  local func_after = function()

    common_impl.Lock( false );
    
    if not private.loupe_mmg_stop_drag_flag and private.loupe_mmg_win_pointer ~= 8 then
      
      common_impl.SetCursor( CURSOR_GET );

      ObjStartDrag( "obj_bar_2_loupe_mg_line" );
      
    end;

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_true", 0, "", 0 );
  
  ObjAnimate( "spr_bar_2_loupe_mg_sign_"..i.."_"..j.."_light", "alp", 0, 0, func_after, { 0,0,0, 0.2,0,1 } );
  
  end;
------------------------------------------------------------------------------------------
  function private.loupe_mmg_win_anim()
    
    local func_after = function()
    
      private.win_loupe();
      
      common_impl.Lock( false );
    
    end;
    
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_win", 0, "", 0 );
    
    ObjStopDrag( "obj_bar_2_loupe_mg_line" );
    
    for i = 1, 2 do
      
      for j = 1, 4 do
        
        ObjAnimate( "spr_bar_2_loupe_mg_sign_"..i.."_"..j.."_light_win", "alp", 0, 0, func_after, { 0,0,0, 0.2,0,0, 0.5,0,1, 0.9,0,1, 1.2,0,0 } );
        
        func_after = "";
        
      end;
      
    end;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
ObjAnimate( "spr_bar_2_lamp_light", "alp", 1, 0, "",
{ 
  0.0, 0, 1, 
  2.4, 0, 0.7,
  4.8, 0, 1
});
ObjAnimate( "spr_bar_2_light", "alp", 1, 0, "",
{ 
  0.0, 0, 1, 
  2.4, 0, 0.7,
  4.8, 0, 1
});
ObjAnimate( "spr_bar_2_lamp", "ang", 1, 0, "",
{ 
  0.0, 0, -0.01, 
  1.2, 3, 0.01,
  2.4, 3, -0.01
});