-- name=rm_atbar_3
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_atbar_3";
  --------------------------------------------------------------------------------------------
  
  ObjAttach( "zz_telephonebooth_3", "room_hub" );
  ObjAttach( "zz_motocycle_3", "room_hub" );
  
  private.Init_Subroom();

  
  ObjMultiSet({ 
  
  { "spr_telephonebooth_3_note",             { event_mdown = function () common_impl.NoteScale( "open", "spr_telephonebooth_3_note" );common_impl.ShowBbt( 'bbt_telephonebooth_note', 1 ); end }},    
  { "spr_telephonebooth_3_note_big",         { event_mdown = function () common_impl.NoteScale( "close", "spr_telephonebooth_3_note" ); end } },
  { "spr_motocycle_3_note", { event_mdown = function () common_impl.NoteScale( "open", "spr_motocycle_3_note" ) end }},    
  { "spr_motocycle_3_note_big",{ event_mdown = function () common_impl.NoteScale( "close", "spr_motocycle_3_note" ); common_impl.ShowBbt( 'bbt_motocycle_note', 1 ); end } },
  { "spr_atbar_3_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_2_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_motorcycle_3_collect_2", { event_mdown = function () private.get_collect_2_2_5(); end,
                                  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
  { "spr_telephonebooth_3_collect_2", { event_mdown = function () private.get_collect_2_2_6(); end,
                                  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},                                
  { "spr_atbar_3_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_5" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
 
  });
 

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_atbar_3 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
   
    "gzz_atbar_3_telephonebooth",
    "gzz_atbar_3_motocycle",
    "grm_atbar_3_wheelbarrow",
    "grm_atbar_3_bar_2"
  
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    
    "zz_telephonebooth_3",
    "zz_motocycle_3"
    
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_atbar_3", update_game_mode_atbar_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_atbar_3 = function ()

  local effects_table = 
  {
    "obj_atbar_3_anim",
    "anm_atbar_3_smoke",
    "anm_atbar_3_door_static",
    "spr_motocycle_light"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
cmn.AddSubscriber( "update_performance_mode_atbar_3", update_performance_mode_atbar_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_atbar_3 () end;
  --------------------------------------------------------------------------------------------
  local opn_atbar_3_map = function ()

    common_impl.VisitMapRoom( "atbar" );

  end;
  cmn.AddSubscriber( "opn_atbar_3", opn_atbar_3_map );
 
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_2_2 = function ()
  
    ObjDelete( "obj_atbar_3_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_2_2", get_collect_item_2_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_2_6 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_2_6 = function ()
 
  ObjDelete( "spr_telephonebooth_3_collect_2");
    
  end;
  
  cmn.AddSubscriber( "get_collect_2_2_6", get_collect_2_2_6, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_2_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_2_5 = function ()
 
    ObjDelete( "spr_motorcycle_3_collect_2" );
    ObjDelete( "spr_motorcycle_3_collect_2_shadow" );
   
    
  end;
  cmn.AddSubscriber( "get_collect_2_2_5", get_collect_2_2_5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_5 = function ()
  
    ObjDelete( "obj_atbar_3_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_5", get_collect_morph_item_2_5, private.room_objname );
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  

  subroom.Define( "zz_telephonebooth_3" );
  subroom.Define( "zz_motocycle_3" );
 

  --------------------------------------------------------------------------------------------
  function zz_telephonebooth_3.PreOpen()

    if not common_impl.atbar_3 then

      common_impl.atbar_3 = {}
      common_impl.atbar_3.note = "close";

    end;

    if  ObjGet( "spr_telephonebooth_3_note" ).input == true then

      ObjSet( "spr_telephonebooth_3_note_big", { input = false, alp = 0 } );
      ObjSet( "spr_telephonebooth_3_note",     { alp = 1 } );
      
    end;

  end;

  function zz_telephonebooth_3.Close()

    common_impl.atbar_3.note = "close"; 

  end;
  --------------------------------------------------------------------------------------------
  function zz_motocycle_3.PreOpen()

    if not common_impl.atbar_3 then

      common_impl.atbar_3 = {}
      common_impl.atbar_3.note = "close";

    end;

    if  ObjGet( "spr_motocycle_3_note" ).input == true then

      ObjSet( "spr_motocycle_3_note_big", { input = false, alp = 0 } );
      ObjSet( "spr_motocycle_3_note",     { alp = 1 } );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_motocycle_3.Close()

    common_impl.atbar_3.note = "close"; 

  end;
 
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_atbar_3();
 

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.MorphItemMorphing();
  common_impl.CollectItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/level2/aud_atbar_env" }, "", 0.5 );
 
    --local func_after = function()
    --
    --  ng_global.progress[ "std" ][ "win_doorhos" ].anim = 2;
    --  cmn.CallEventHandler( "win_doorhos" )
    --  interface.KeyTaskDone( 'enter_pub', true);
    --
    --end;
  
    --interface.Lock( true, 3 );
    --AnimPlay( "anm_atbar_door", "DoAnim", func_after );
    
    -- common_impl.PlayAudio( "sfx", "common/audio/level2/aud_open_pub_doors", 0, "", 0 );
    
    --end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_collect_2_2_5()

  local func_after = function ()
    
  common_impl.GetCollectDone("get_collect_2_2_5");
  cmn.CallEventHandler("get_collect_2_2_5");

  end;

  common_impl.PlayEffectHO( "spr_motorcycle_3_collect_2", func_after ); 

end;
----------------------------------------------------------------------------------------------------
function private.get_collect_2_2_6()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_2_6");
    cmn.CallEventHandler("get_collect_2_2_6");
    common.CloseSubRoom(); 
      
  
  end;

  common_impl.PlayEffectHO( "spr_telephonebooth_3_collect_2", func_after ); 

end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_atbar_3()

  if not ( cmn.IsEventDone( "opn_atbar_3" ) ) then
    cmn.SetEventDone( "opn_atbar_3" );
   
  end;
  
  cmn.CallEventHandler( "opn_atbar_3" ); 

end;

--*********************************************************************************************************************
  ObjAnimate( "spr_atbar_3_light_1", "alp", 1, 0, "", 
  { 
    0.0, 0, 1, 
    1.5, 0, 0.5,
    3.0, 0, 1
  } );
  ObjAnimate( "spr_atbar_3_light_2", "alp", 1, 0, "", 
  { 
    0.0, 0, 1, 
    1.5, 0, 0.5,
    3.0, 0, 1
  } );
 
  