-- name=mg_bridge_scr
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_bridge_scr";
  
  private.bridge = {};
  private.bridge_checkpoint = 1;

  private.bridge_active_panels =  { 0,1,0,1,0,0,0,1,0,0,1,0,0,0,0,1,1,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,1,1,0,0 };
  private.bridge_necessary = { {1,0}, {3,1}, {3,0}, {1,1}, {2,0} };
  private.bridge_chip_ang = { 0, -1.57, -3.14, -4.71, -6.28, - 7.85 };
  private.bridge_current_ang = 1;
  private.bridge_current_color = 0;

  local table_multiset = {};
  
  table.insert( table_multiset, { "obj_bridge_scr_panels_2", { event_mdown = function() private.ClkPanel( 2 ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_bridge_scr_panels_3", { event_mdown = function() private.ClkPanel( 3 ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_bridge_scr_panels_4", { event_mdown = function() private.ClkPanel( 4 ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_bridge_scr_panels_8", { event_mdown = function() private.ClkPanel( 8 ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_bridge_scr_panels_9", { event_mdown = function() private.ClkPanel( 9 ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_bridge_scr_panels_11", { event_mdown = function() private.ClkPanel( 11 ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_bridge_scr_panels_16", { event_mdown = function() private.ClkPanel( 16 ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_bridge_scr_panels_17", { event_mdown = function() private.ClkPanel( 17 ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_bridge_scr_panels_19", { event_mdown = function() private.ClkPanel( 19 ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_bridge_scr_panels_23", { event_mdown = function() private.ClkPanel( 23 ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_bridge_scr_panels_25", { event_mdown = function() private.ClkPanel( 25 ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_bridge_scr_panels_28", { event_mdown = function() private.ClkPanel( 28 ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_bridge_scr_panels_29", { event_mdown = function() private.ClkPanel( 29 ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_bridge_scr_panels_33", { event_mdown = function() private.ClkPanel( 33 ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_bridge_scr_panels_34", { event_mdown = function() private.ClkPanel( 34 ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_bridge_scr_panels_35", { event_mdown = function() private.ClkPanel( 35 ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
 
  table.insert( table_multiset, { "spr_bridge_scr_button", { event_mdown = function() private.ClkButton(); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
         
  ObjMultiSet( table_multiset );
  --------------------------------------------------------------------------------------------
  -- function win_mg_5_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_mg_5_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_5_big_check_mg_5", { alp = 1 } );
    ObjDelete( "anm_mysteryroom_mt_check_mark_mg_5" );

  end;

  cmn.AddSubscriber( "win_mg_5_scr", win_mg_5_scr_loc, "rm_mysteryroom" );
  --------------------------------------------------------------------------------------------
  -- function win_bridge_scr () end;
  --------------------------------------------------------------------------------------------
  local win_bridge_scr = function ()
    
    if ( cmn.IsEventDone( "win_bridge_scr" ) ) then
      
      ObjSet( "obj_bridge_scr_panels", { input = false });
      
    else
  
    for i = 2,35 do
    
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ i ]  == 1 then
      
      ObjSet( "spr_bridge_scr_backlight_"..i, { alp = 1 } );
      
      end;
      
    end;
  
  end;
  
  end;

end;
--*********************************************************************************************************************
function public.Open() 

  ObjSet("obj_int_button_info_impl", { pos_y = -111 });
  ObjSet("obj_int_button_reset_impl", { pos_y = -75 });
  
  if not cmn.IsEventDone( "win_bridge_scr" ) then

    cmn.MiniGameShow();
   
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_bridge_scr" ) ) then
  
    ng_global.progress["scr"]["win_bridge_scr"].active_panels = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, };
  
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  ObjSet("obj_int_button_info_impl", { pos_y = -91 });
  ObjSet("obj_int_button_reset_impl", { pos_y = -105 });
  
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_bridge_scr" ) then

    cmn.MiniGameHide();

  end;
  
end;
--*********************************************************************************************************************
function private.Win()

  common_impl.Lock( false );
  cmn.MiniGameHide();
  cmn.SetEventDone( "win_bridge_scr" );  
  cmn.CallEventHandler( "win_bridge_scr" );
  cmn.SetEventDone( "win_mg_5_scr" );
  --cmn.CallEventHandler( "win_mg_5_scr" );
  rm_mysteryroom.WinEnd( private.room_objname );
  
end;
--*********************************************************************************************************************
function private.WinAnim()

end;
--*********************************************************************************************************************
function public.Skip()

  common_impl.Lock( true );

  for i = 1,36 do
  
    ng_global.progress["scr"]["win_bridge_scr"].active_panels[i] = private.bridge_active_panels[i];
  
  end;

  ObjSet( "spr_bridge_scr_backlight_2",  { alp = 1 } );
  ObjSet( "spr_bridge_scr_backlight_3",  { alp = 0 } );
  ObjSet( "spr_bridge_scr_backlight_4",  { alp = 1 } );
  ObjSet( "spr_bridge_scr_backlight_8",  { alp = 1 } );
  ObjSet( "spr_bridge_scr_backlight_9",  { alp = 0 } );
  ObjSet( "spr_bridge_scr_backlight_11", { alp = 1 } );
  ObjSet( "spr_bridge_scr_backlight_16", { alp = 1 } );
  ObjSet( "spr_bridge_scr_backlight_17", { alp = 1 } );
  ObjSet( "spr_bridge_scr_backlight_19", { alp = 0 } );
  ObjSet( "spr_bridge_scr_backlight_23", { alp = 1 } );
  ObjSet( "spr_bridge_scr_backlight_25", { alp = 1 } );
  ObjSet( "spr_bridge_scr_backlight_28", { alp = 0 } );
  ObjSet( "spr_bridge_scr_backlight_29", { alp = 0 } );
  ObjSet( "spr_bridge_scr_backlight_33", { alp = 1 } );
  ObjSet( "spr_bridge_scr_backlight_34", { alp = 1 } );
  ObjSet( "spr_bridge_scr_backlight_35", { alp = 0 } );

  private.ClkButton();
  
  private.Win();

end;
--*********************************************************************************************************************
function public.Reset()

  common_impl.Lock( false );

  private.bridge_checkpoint = 1;
  
  for i = 1,36 do
  
    ng_global.progress["scr"]["win_bridge_scr"].active_panels[ i ] = 0;
    ObjSet( "spr_bridge_scr_backlight_"..i, { alp = 0 } );
  
  end;

  ObjSet( "spr_bridge_scr_button", { alp = 0 } );
  ObjSet( "spr_bridge_scr_chip_1", { pos_x = 94, pos_y = 530, ang = 0 } );
  ObjSet( "spr_bridge_scr_chip_2", { alp = 0 } );
  
  private.bridge_current_ang = 1;
  private.bridge_current_color = 0;

end;
--*********************************************************************************************************************
function private.BackStart()

  common_impl.Lock( false );

  private.bridge_checkpoint = 1;
  ObjSet( "spr_bridge_scr_button", { alp = 0 } );
  ObjSet( "spr_bridge_scr_chip_1", { pos_x = 94, pos_y = 530, ang = 0 } );
  ObjSet( "spr_bridge_scr_chip_2", { alp = 0 } );
  private.bridge_current_ang = 1;
  private.bridge_current_color = 0;

end;
--*********************************************************************************************************************
-------------------------------------------------------------------------------------
----- Клик на кнопку
function private.ClkButton()

  local func_after = function()
  
  private.ChipAnim();
  
  end;
  
  common_impl.Lock( true );
  
  ObjAnimate( "spr_bridge_scr_button", "alp",0,0, func_after,
  { 
  0.0,0,0,
  0.3,0,1 
  } );

end;
--*********************************************************************************************************************
-------------------------------------------------------------------------------------
----- Анимация панели
function private.ChipAnim()

  local func_after = function()
  
  private.ChipCheck();
  
  end;
  
  local chip_xy = 
  { {94,530,0.67},{94,397,0.55},{94,288,0.52},{94,184,0.37},{94,110,0.4},{174,110,0.4},{256,110,0.36},{256,182,0.55},{256,292,0.33},{256,358,0.34},
    {324,358,0.4},{405,358,0.58},{405,474,0.39},{482,474,0.37},{555,474,0.37},{555,400,0.5},{555,298,0.39},{555,220,0.29},{498,220,0.36},{426,220,0.3},
    {426,161,0.3},{426,100,0.8},{586,100,0.78},{742,100,0.3},{742,161,0.3},{742,220,0.47},{648,220,0.39},{648,298,0.55},{648,408,0.52},{648,512,0.54},
    {755,512,0.5},{853,512,0.37},{853,438,0.5},{853,340,0.5},{853,240,0.69},{853,102} };

  ObjAnimate( "spr_bridge_scr_chip_1", "pos_xy", 0, 0, func_after, 
  { 
  0,0,   chip_xy[ private.bridge_checkpoint ][1],   chip_xy[ private.bridge_checkpoint ][2],
    chip_xy[ private.bridge_checkpoint ][3],0, chip_xy[ private.bridge_checkpoint+1 ][1], chip_xy[ private.bridge_checkpoint+1 ][2] 
  } );

  private.bridge_checkpoint = private.bridge_checkpoint + 1;

end;
--*********************************************************************************************************************
-------------------------------------------------------------------------------------
----- Проверка состояния панели
function private.ChipCheck()

  local func_after = function()
  
  private.ChipAnim();
  
  end;
  
  if private.bridge_checkpoint <= 36 then

    if private.bridge_checkpoint == 2 then
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ private.bridge_checkpoint ] == 1 then
    
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
      0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
      0.3,0,private.bridge_chip_ang[ private.bridge_current_ang + 1 ] 
    } );
    
        if private.bridge_current_ang == 4 then
    
          private.bridge_current_ang = 1;
      
        else
    
          private.bridge_current_ang = private.bridge_current_ang + 1;
      
        end;
    
      else
    
        private.ChipAnim();
    
      end;

    elseif private.bridge_checkpoint == 3 then
  
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ private.bridge_checkpoint ] == 1 then
    
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_change_color", 0, "", 0 );
        if private.bridge_current_color == 0 then
    
          ObjAnimate( "spr_bridge_scr_chip_2", "alp",0,0, "", 
      { 
      0.0,0,0,
      0.2,0,1 
      } );
      
          private.bridge_current_color = 1;
      
        else
    
          ObjAnimate( "spr_bridge_scr_chip_2", "alp",0,0, "", 
      { 
      0.0,0,1,
      0.2,0,0 
      } );
      
          private.bridge_current_color = 0;
      
        end;
    
      end;
    
      private.ChipAnim();

    elseif private.bridge_checkpoint == 4 then
  
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ private.bridge_checkpoint ] == 1 then
    
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
      0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
      0.6,0,private.bridge_chip_ang[ private.bridge_current_ang + 2 ] 
    } );
    
        if private.bridge_current_ang == 4 then
    
          private.bridge_current_ang = 2;
      
        elseif private.bridge_current_ang == 3 then
    
          private.bridge_current_ang = 1;
      
        else
    
          private.bridge_current_ang = private.bridge_current_ang + 2;
      
        end;
    
      else
    
        private.ChipAnim();
    
      end;

    elseif private.bridge_checkpoint == 5 then
  
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
      ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
    0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
    0.3,0,private.bridge_chip_ang[ private.bridge_current_ang + 1 ] 
    } );
          
      if private.bridge_current_ang == 4 then
    
        private.bridge_current_ang = 1;
    
      else
    
        private.bridge_current_ang = private.bridge_current_ang + 1;
    
      end;

    elseif private.bridge_checkpoint == 6 then
  
      if private.bridge_current_ang ~= private.bridge_necessary[1][1] or
         private.bridge_current_color ~= private.bridge_necessary[1][2] then
     
        private.BackStart();
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_wrongapply1_sfx", 0, "", 0 );
    
      else
    
        private.ChipAnim();
    
      end;

    elseif private.bridge_checkpoint == 7 then
  
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
      ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
    0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
    0.3,0,private.bridge_chip_ang[ private.bridge_current_ang + 1 ] 
    } );
          
      if private.bridge_current_ang == 4 then
    
        private.bridge_current_ang = 1;
    
      else
    
        private.bridge_current_ang = private.bridge_current_ang + 1;
    
      end;

    elseif private.bridge_checkpoint == 8 then
  
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ private.bridge_checkpoint ] == 1 then
    
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
      0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
      0.6,0,private.bridge_chip_ang[ private.bridge_current_ang + 2 ] 
    } );
            
        if private.bridge_current_ang == 4 then
    
          private.bridge_current_ang = 2;
      
        elseif private.bridge_current_ang == 3 then
    
          private.bridge_current_ang = 1;
      
        else
    
          private.bridge_current_ang = private.bridge_current_ang + 2;
      
        end;
    
      else
    
        private.ChipAnim();
    
      end;

    elseif private.bridge_checkpoint == 9 then
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ private.bridge_checkpoint ] == 1 then
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
                    { 0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
                      0.6,0,private.bridge_chip_ang[ private.bridge_current_ang + 2 ] } );
        if private.bridge_current_ang == 4 then
          private.bridge_current_ang = 2;
        elseif private.bridge_current_ang == 3 then
          private.bridge_current_ang = 1;
        else
          private.bridge_current_ang = private.bridge_current_ang + 2;
        end;
      else
        private.ChipAnim();
      end;

    elseif private.bridge_checkpoint == 10 then
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
      if private.bridge_current_ang == 1 then
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
                    { 0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
                      0.3,0,-private.bridge_chip_ang[ private.bridge_current_ang + 1 ] } );
        private.bridge_current_ang = 4;
      else
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
                    { 0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
                      0.3,0,private.bridge_chip_ang[ private.bridge_current_ang - 1 ] } );
        private.bridge_current_ang = private.bridge_current_ang - 1;
      end;

    elseif private.bridge_checkpoint == 11 then
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ private.bridge_checkpoint ] == 1 then
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_change_color", 0, "", 0 );
        if private.bridge_current_color == 0 then
          ObjAnimate( "spr_bridge_scr_chip_2", "alp",0,0, "", 
                      { 0.0,0,0,
                        0.2,0,1 } );
          private.bridge_current_color = 1;
        else
          ObjAnimate( "spr_bridge_scr_chip_2", "alp",0,0, "", 
                      { 0.0,0,1,
                        0.2,0,0 } );
          private.bridge_current_color = 0;
        end;
      end;
      private.ChipAnim();

    elseif private.bridge_checkpoint == 12 then
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
      ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
                  { 0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
                    0.3,0,private.bridge_chip_ang[ private.bridge_current_ang + 1 ] } );
      if private.bridge_current_ang == 4 then
        private.bridge_current_ang = 1;
      else
        private.bridge_current_ang = private.bridge_current_ang + 1;
      end;

    elseif private.bridge_checkpoint == 13 then
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
      if private.bridge_current_ang == 1 then
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
                    { 0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
                      0.3,0,-private.bridge_chip_ang[ private.bridge_current_ang + 1 ] } );
        private.bridge_current_ang = 4;
      else
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
                    { 0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
                      0.3,0,private.bridge_chip_ang[ private.bridge_current_ang - 1 ] } );
        private.bridge_current_ang = private.bridge_current_ang - 1;
      end;

    elseif private.bridge_checkpoint == 14 then
      if private.bridge_current_ang ~= private.bridge_necessary[2][1] or
         private.bridge_current_color ~= private.bridge_necessary[2][2] then
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_wrongapply1_sfx", 0, "", 0 );
        private.BackStart();
      else
        private.ChipAnim();
      end;

    elseif private.bridge_checkpoint == 15 then
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
      if private.bridge_current_ang == 1 then
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
                    { 0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
                      0.3,0,-private.bridge_chip_ang[ private.bridge_current_ang + 1 ] } );
        private.bridge_current_ang = 4;
      else
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
                    { 0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
                      0.3,0,private.bridge_chip_ang[ private.bridge_current_ang - 1 ] } );
        private.bridge_current_ang = private.bridge_current_ang - 1;
      end;

    elseif private.bridge_checkpoint == 16 then
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ private.bridge_checkpoint ] == 1 then
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_change_color", 0, "", 0 );
        if private.bridge_current_color == 0 then
          ObjAnimate( "spr_bridge_scr_chip_2", "alp",0,0, "", 
                      { 0.0,0,0,
                        0.2,0,1 } );
          private.bridge_current_color = 1;
        else
          ObjAnimate( "spr_bridge_scr_chip_2", "alp",0,0, "", 
                      { 0.0,0,1,
                        0.2,0,0 } );
          private.bridge_current_color = 0;
        end;
      end;
      private.ChipAnim();

    elseif private.bridge_checkpoint == 17 then
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ private.bridge_checkpoint ] == 1 then
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
                    { 0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
                      0.3,0,private.bridge_chip_ang[ private.bridge_current_ang + 1 ] } );
        if private.bridge_current_ang == 4 then
          private.bridge_current_ang = 1;
        else
          private.bridge_current_ang = private.bridge_current_ang + 1;
        end;
      else
        private.ChipAnim();
      end;


    elseif private.bridge_checkpoint == 18 then
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
      if private.bridge_current_ang == 1 then
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
                    { 0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
                      0.3,0,-private.bridge_chip_ang[ private.bridge_current_ang + 1 ] } );
        private.bridge_current_ang = 4;
      else
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
                    { 0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
                      0.3,0,private.bridge_chip_ang[ private.bridge_current_ang - 1 ] } );
        private.bridge_current_ang = private.bridge_current_ang - 1;
      end;

    elseif private.bridge_checkpoint == 19 then
  
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ private.bridge_checkpoint ] == 1 then
    
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
      0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
      0.6,0,private.bridge_chip_ang[ private.bridge_current_ang + 2 ] 
    } );
            
        if private.bridge_current_ang == 4 then
    
          private.bridge_current_ang = 2;
      
        elseif private.bridge_current_ang == 3 then
    
          private.bridge_current_ang = 1;
      
        else
    
          private.bridge_current_ang = private.bridge_current_ang + 2;
      
        end;
    
      else
    
        private.ChipAnim();
    
      end;

    elseif private.bridge_checkpoint == 20 then
  
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
      ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
    0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
    0.3,0,private.bridge_chip_ang[ private.bridge_current_ang + 1 ] 
    } );
          
      if private.bridge_current_ang == 4 then
    
        private.bridge_current_ang = 1;
    
      else
    
        private.bridge_current_ang = private.bridge_current_ang + 1;
    
      end;

    elseif private.bridge_checkpoint == 21 then
  
      if private.bridge_current_ang ~= private.bridge_necessary[3][1] or
         private.bridge_current_color ~= private.bridge_necessary[3][2] then
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_wrongapply1_sfx", 0, "", 0 );
        private.BackStart();
    
      else
    
        private.ChipAnim();
    
      end;

    elseif private.bridge_checkpoint == 22 then
  
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
      ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
    0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
    0.3,0,private.bridge_chip_ang[ private.bridge_current_ang + 1 ] 
    } );
          
      if private.bridge_current_ang == 4 then
    
        private.bridge_current_ang = 1;
    
      else
    
        private.bridge_current_ang = private.bridge_current_ang + 1;
    
      end;

    elseif private.bridge_checkpoint == 23 then
  
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ private.bridge_checkpoint ] == 1 then
    
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
      0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
      0.3,0,private.bridge_chip_ang[ private.bridge_current_ang + 1 ] 
    } );
            
        if private.bridge_current_ang == 4 then
    
          private.bridge_current_ang = 1;
      
        else
    
          private.bridge_current_ang = private.bridge_current_ang + 1;
      
        end;
    
      else
    
        private.ChipAnim();
    
      end;

    elseif private.bridge_checkpoint == 24 then
  
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
      ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
    0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
    0.3,0,private.bridge_chip_ang[ private.bridge_current_ang + 1 ] 
    } );
          
      if private.bridge_current_ang == 4 then
    
        private.bridge_current_ang = 1;
    
      else
    
        private.bridge_current_ang = private.bridge_current_ang + 1;
    
      end;

    elseif private.bridge_checkpoint == 25 then
  
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ private.bridge_checkpoint ] == 1 then
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_change_color", 0, "", 0 );
        if private.bridge_current_color == 0 then
    
          ObjAnimate( "spr_bridge_scr_chip_2", "alp",0,0, "", 
      { 
      0.0,0,0,
      0.2,0,1 
      } );
            
          private.bridge_current_color = 1;
      
        else
    
          ObjAnimate( "spr_bridge_scr_chip_2", "alp",0,0, "", 
      { 
      0.0,0,1,
      0.2,0,0 
      } );
      
          private.bridge_current_color = 0;
      
        end;
    
      end;
    
      private.ChipAnim();

    elseif private.bridge_checkpoint == 26 then
  
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
      ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
    0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
    0.3,0,private.bridge_chip_ang[ private.bridge_current_ang + 1 ] 
    } );
          
      if private.bridge_current_ang == 4 then
    
        private.bridge_current_ang = 1;
    
      else
    
        private.bridge_current_ang = private.bridge_current_ang + 1;
    
      end;

    elseif private.bridge_checkpoint == 27 then
  
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
      if private.bridge_current_ang == 1 then
    
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
      0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
      0.3,0,-private.bridge_chip_ang[ private.bridge_current_ang + 1 ] 
    } );
            
        private.bridge_current_ang = 4;
    
      else
    
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
      0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
      0.3,0,private.bridge_chip_ang[ private.bridge_current_ang - 1 ] 
    } );
            
        private.bridge_current_ang = private.bridge_current_ang - 1;
    
      end;

    elseif private.bridge_checkpoint == 28 then
  
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ private.bridge_checkpoint ] == 1 then
    
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_change_color", 0, "", 0 );
        if private.bridge_current_color == 0 then
    
          ObjAnimate( "spr_bridge_scr_chip_2", "alp",0,0, "", 
      { 
      0.0,0,0,
      0.2,0,1 
      } );
            
          private.bridge_current_color = 1;
      
        else
    
          ObjAnimate( "spr_bridge_scr_chip_2", "alp",0,0, "", 
      { 
      0.0,0,1,
      0.2,0,0 
      } );
            
          private.bridge_current_color = 0;
      
        end;
    
      end;
    
      private.ChipAnim();

    elseif private.bridge_checkpoint == 29 then
  
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ private.bridge_checkpoint ] == 1 then
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
      0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
      0.6,0,private.bridge_chip_ang[ private.bridge_current_ang + 2 ] 
    } );
            
        if private.bridge_current_ang == 4 then
    
          private.bridge_current_ang = 2;
      
        elseif private.bridge_current_ang == 3 then
    
          private.bridge_current_ang = 1;
      
        else
    
          private.bridge_current_ang = private.bridge_current_ang + 2;
      
        end;
    
      else
    
        private.ChipAnim();
    
      end;

    elseif private.bridge_checkpoint == 30 then
  
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
      if private.bridge_current_ang == 1 then
    
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
      0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
      0.3,0,-private.bridge_chip_ang[ private.bridge_current_ang + 1 ] 
    } );
            
        private.bridge_current_ang = 4;
    
      else
    
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
      0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
      0.3,0,private.bridge_chip_ang[ private.bridge_current_ang - 1 ] 
    } );
            
        private.bridge_current_ang = private.bridge_current_ang - 1;
    
      end;

    elseif private.bridge_checkpoint == 31 then
  
      if private.bridge_current_ang ~= private.bridge_necessary[4][1] or
         private.bridge_current_color ~= private.bridge_necessary[4][2] then
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_wrongapply1_sfx", 0, "", 0 );
        private.BackStart();
    
      else
    
        private.ChipAnim();
    
      end;

    elseif private.bridge_checkpoint == 32 then
  
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
      if private.bridge_current_ang == 1 then
    
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
      0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
      0.3,0,-private.bridge_chip_ang[ private.bridge_current_ang + 1 ] 
    } );
            
        private.bridge_current_ang = 4;
    
      else
    
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
      0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
      0.3,0,private.bridge_chip_ang[ private.bridge_current_ang - 1 ] 
    } );
            
        private.bridge_current_ang = private.bridge_current_ang - 1;
    
      end;

    elseif private.bridge_checkpoint == 33 then
  
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ private.bridge_checkpoint ] == 1 then
    
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
      0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
      0.6,0,private.bridge_chip_ang[ private.bridge_current_ang + 2 ] 
    } );
    
        if private.bridge_current_ang == 4 then
    
          private.bridge_current_ang = 2;
      
        elseif private.bridge_current_ang == 3 then
    
          private.bridge_current_ang = 1;
      
        else
    
          private.bridge_current_ang = private.bridge_current_ang + 2;
      
        end;
    
      else
    
        private.ChipAnim();
    
      end;

    elseif private.bridge_checkpoint == 34 then
  
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ private.bridge_checkpoint ] == 1 then
        
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_change_color", 0, "", 0 );
    
        if private.bridge_current_color == 0 then
    
          ObjAnimate( "spr_bridge_scr_chip_2", "alp",0,0, "", 
      { 
      0.0,0,0,
      0.2,0,1 
      } );
            
          private.bridge_current_color = 1;
      
        else
    
          ObjAnimate( "spr_bridge_scr_chip_2", "alp",0,0, "", 
      { 
      0.0,0,1,
      0.2,0,0 
      } );
          private.bridge_current_color = 0;
      
        end;
    
      end;
    
      private.ChipAnim();

    elseif private.bridge_checkpoint == 35 then
  
      if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ private.bridge_checkpoint ] == 1 then
    
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_rotate", 0, "", 0 );
        ObjAnimate( "spr_bridge_scr_chip_1", "ang",0,0, func_after, 
    { 
      0.0,0,private.bridge_chip_ang[ private.bridge_current_ang ],
      0.3,0,private.bridge_chip_ang[ private.bridge_current_ang + 1 ] 
    } );
            
        if private.bridge_current_ang == 4 then
    
          private.bridge_current_ang = 1;
      
        else
    
          private.bridge_current_ang = private.bridge_current_ang + 1;
      
        end;
    
      else
    
        private.ChipAnim();
    
      end;

    elseif private.bridge_checkpoint == 36 then

      if private.bridge_current_ang ~= private.bridge_necessary[5][1] or
         private.bridge_current_color ~= private.bridge_necessary[5][2] then
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_wrongapply1_sfx", 0, "", 0 );
        private.BackStart();
    
      else
    
        private.Win();
    
      end;

    end;

  else

    private.bridge_checkpoint = 1;
    ObjAnimate( "spr_bridge_scr_button", "alp",0,0, function() common_impl.Lock( false ); end,
    { 
      0.0,0,1,
      0.3,0,0
    } );
    ObjSet( "spr_bridge_scr_chip_1", { pos_x = 94, pos_y = 530 } );
    ObjSet( "spr_bridge_scr_chip_2", { alp = 0 } );

  end;

end;

-------------------------------------------------------------------------------------
----- Клик на панель
function private.ClkPanel( str_num )

  local func_after = function() 
  
    common_impl.Lock( false );
    
    if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ tonumber( str_num ) ] == 0 then
      ng_global.progress["scr"]["win_bridge_scr"].active_panels[ tonumber( str_num ) ] = 1;
    else
      ng_global.progress["scr"]["win_bridge_scr"].active_panels[ tonumber( str_num ) ] = 0;
    end;

  end;

  common_impl.Lock( true );

  if ng_global.progress["scr"]["win_bridge_scr"].active_panels[ tonumber( str_num ) ] == 0 then

    ObjAnimate( "spr_bridge_scr_backlight_"..str_num, "alp",0,0, func_after,
                { 0.0,0,0,
                  0.2,0,1 } );
    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_click_on", 0, "", 0 );

  else

    ObjAnimate( "spr_bridge_scr_backlight_"..str_num, "alp",0,0, func_after,
                { 0.0,0,1,
                  0.2,0,0 } );

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_bridge_click_off", 0, "", 0 );
  end;

end;