-- name=int_button_apparat
--******************************************************************************************
function public.Init ()

  ObjAttach( "obj_int_button_apparat", "obj_int_inventory_impl" );
  MsgSubscribe( Command_Interface_UpdateTextures, public.WideScreenUpdate );
  --public.DIRECTION = 1;
  --public.POSITION = -171;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet("obj_int_button_apparat", {

  event_mdown = function() ObjStartDrag( "obj_int_button_apparat_drag" ) end,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim,
    pos_x = -318,
    pos_y = 26,
    pos_z = 3,
    drag = true,

  });
  
end;
--******************************************************************************************
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    ObjSet( "int_button_apparat", { pos_x = public.POSITION } );
  
  else

    ObjSet( "int_button_apparat", { pos_x = public.POSITION } );

  end;

end;
--******************************************************************************************
function private.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

  PlaySfx( "assets/levels/common/audio/aud_guidance", 0, 0 );

  local obj = "spr_int_button_apparat_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

  interface.InventoryOpen();

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT ); 
  local obj = "spr_int_button_apparat_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

  interface.InventoryClose();

end;
--******************************************************************************************