-- name=int_button_lock_impl
--******************************************************************************************
function public.Init ()

  public.DIRECTION = 0;
  private.BUTTON_MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet( "obj_int_button_lock", {
    event_mdown = function () int_button_lock.MouseDown(); end,
    event_menter = function () private.MouseEnterAnim(); end,
    event_mleave = function () private.MouseLeaveAnim(); end
  } );

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    --

  else

    --

  end;

end;
--******************************************************************************************
function public.LockAnim( lock, event_id )

  -- lock: true or false
  local res = "assets/interface/resources/button_lock/lock_";
  if lock then
    ObjSet( "spr_int_button_lock", { res = res.."on" } );  
  else                                
    ObjSet( "spr_int_button_lock", { res = res.."off" } );  
  end;

end;
--******************************************************************************************
function private.MouseEnterAnim()

	if ( cmn.IsPC() ) then
  
		int_button_lock.MouseEnter();

		SetCursor( CURSOR_HAND );

		local obj = "spr_int_button_lock_focus";
		local alp = ObjGet( obj ).alp;
		local tme = ( 1 - alp ) * private.BUTTON_MOUSE_OVER_ANIM_TIME;

		ObjAnimate( obj, "alp", 0, 0, "",
		{
			0.0, 2, alp,
			tme, 2, 1
		} );
		  
	end;
	
end;
--******************************************************************************************
function private.MouseLeaveAnim()

	if ( cmn.IsPC() ) then
	
		int_button_lock.MouseLeave();

		SetCursor( CURSOR_DEFAULT );

		local obj = "spr_int_button_lock_focus";
		local alp = ObjGet( obj ).alp;
		local tme = alp * private.BUTTON_MOUSE_OVER_ANIM_TIME;

		ObjAnimate( obj, "alp", 0, 0, "",
		{
			0.0, 1, alp,
			tme, 1, 0
		} );
		
	end;
	
end;
--******************************************************************************************