-- name=int_dialog_impl
--******************************************************************************************
function public.Init ()

  public.GRID_CORNER_W =  65;
  public.GRID_CORNER_H =  65;
  public.GRID_MID_W    =   2;
  public.GRID_MID_H    =   2;

  public.GRID_BORDER_W = 100;
  public.GRID_BORDER_H = 100;

  public.MIN_W = 400;
  public.MAX_W = 500;
  public.MIN_H = 134;
  public.MAX_H = 220;

  private.SHOW_ANIM_TIME = 0.3;
  ObjSet( "obj_dialog_transpanent", {
    event_mdown = int_dialog.MouseDown
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id, extended )

  local trg = function () int_dialog.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "obj_int_dialog_impl", "alp", 0, 0, trg,
  {
    0.0, 2, 1,
    tme, 2, 0
  } );

end;
--******************************************************************************************
function public.ShowAnim( event_id, extended, params )

  local trg = function () int_dialog.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "obj_int_dialog_impl", "alp", 0, 0, trg,
  {
    0.0, 2, 0,
    tme, 2, 1
  } );

end;
--******************************************************************************************