-- name=int_lock
--******************************************************************************************
function public.Init (pos_z)
  ObjAttach( "int_lock", interface.originhub );
  ObjSet( "int_lock", { pos_z = pos_z } );
  ObjCreate( "tmr_interface_lock", "timer" );
  ObjAttach( "tmr_interface_lock", "cmn_timers" );

end;
--******************************************************************************************
function public.Destroy()

end;
--******************************************************************************************
function public.Show( inv_obj )

  ObjSet( "obj_int_lock", { input = 1 } );
  ObjSet( "spr_cheater_current_lock_1", { color_r = 1, color_g = 0 } );

end;
--******************************************************************************************
function public.Hide()

  ObjSet( "obj_int_lock", { input = 0 } );
  ObjSet( "spr_cheater_current_lock_1", { color_r = 0, color_g = 1 } );

end;
--******************************************************************************************
--******************************************************************************************
function public.StartTimer( time )

  local func_after = function() public.StopTimer() end;

  if ObjGet( "tmr_interface_lock" ).time < time then
    
    ObjSet( "tmr_interface_lock", { playing = true, time = time, endtrig = func_after } );
  
  end;
  ObjSet( "obj_int_lock_timer", { input = true } );
  ObjSet( "spr_cheater_current_lock_2", { color_r = 1, color_g = 0 } );

end;
--******************************************************************************************
function public.StopTimer()

  ObjSet( "obj_int_lock_timer", { input = false } );
  ObjSet( "spr_cheater_current_lock_2", { color_r = 0, color_g = 1 } );

end;
--******************************************************************************************

