-- name=mg_superpuzzle_1
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_superpuzzle_1";
  
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_superpuzzle_1 = function ()

  local effects_table = 
  {
    "",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_superpuzzle_1", update_performance_mode_superpuzzle_1, private.room_objname );
  
  
  local  table_multiset = {};
  
  table.insert( table_multiset, { "obj_superpuzzle_1_hint_clk", { event_mdown = function() private.PuszzleHintClk() end, event_menter = function() private.PuszzleHintEnter(); end, event_mleave = function() private.PuszzleHintLeave(); end } } );

  table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_small_note_1", { event_mdown = function() private.DragNote_1() end, event_dragdrop = function() private.DropNote_1() end; } } );
  
  for i = 1,8 do
    
    table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_key_"..i, { event_mdown = function() private.DragNote_2(i) end, event_dragdrop = function() private.DropNote_2(i) end; } } );
    
  end;
  
  for i = 1,4 do

    table.insert( table_multiset, { "spr_superpuzzle_1_mg_1_part_"..i, { event_mdown = function() private.clk_block_1( i ) end } } );

  end;
  
  for i = 1,5 do

    table.insert( table_multiset, { "spr_superpuzzle_1_mg_2_chip_"..i, { event_mdown = function() 
      private.DragChip( i );
      ObjStartDrag( "spr_superpuzzle_1_mg_2_chip_"..i ); 
      end,
      event_dragdrop = function() private.DropChip( i ) end,
      event_drag = function() private.DragLight( i ) end,
      event_menter = function() private.EnterChip( i ) end,
      event_mleave = function() private.LeaveChip( i ) end;
        } } );

  end;
  
  for i = 1,5 do

    table.insert( table_multiset, { "obj_superpuzzle_1_mg_3_clk_"..i, 
    { event_mdown  = function() private.clk_block_3( i ) end,
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ); end,
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end
    } } );

  end;
  
  for i = 1, 5 do
    table.insert( table_multiset,{ "obj_superpuzzle_1_mg_4_clk_"..i, 
    { event_mdown  = function() private.clk_block_4( i ) end, 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ); end,
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end
    } } );
  end;
  
  for i = 1, 4 do  
    for j = 1, 5 do
     table.insert( table_multiset,{ "obj_superpuzzle_1_mg_5_clk_"..i.."_"..j, 
     { event_mdown  = function() private.clk_block_5( i, j ) end, 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ); end,
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end
     } } );
  end
  end;
  
  ObjMultiSet( table_multiset );
  
  common_impl.hint[ "win_superpuzzle_1" ] = {
    type = "win",
    room = "rm_beforepuzzle",
    zz = "mg_superpuzzle_1",
    zz_gate = "gmg_beforepuzzle_superpuzzle_1"
  };
  
  --------------------------------------------------------------------------------------------
  -- function win_superpuzzle_1_loc () end;
  --------------------------------------------------------------------------------------------
  local win_superpuzzle_1_loc = function ()
      
    if ( cmn.IsEventDone( "win_superpuzzle_1" ) ) then  

      ObjDelete( "gmg_beforepuzzle_superpuzzle_1" );

    else

    end;

  end;
  --------------------------------------------------------------------------------------------
  -- function win_superpuzzle_1 () end;
  --------------------------------------------------------------------------------------------
  local win_superpuzzle_1 = function ()

    private.block_1 = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_1;
    private.block_2 = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_2;
    private.block_3 = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_3;
    private.block_4 = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_4;  
    private.block_5 = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_5; 
    
    if ( cmn.IsEventDone( "win_superpuzzle_1" ) ) then  

    else

    end;
    
    if ( ng_global.progress[ "std" ][ "win_superpuzzle_1" ].begin ) then
      ObjSet( "anm_superpuzzle_1_diaphragm_1", { frame = 120 });
    end
    
    --------------------------------------------------------------------------------------------
    --mmg block_1
    --------------------------------------------------------------------------------------------
    if ( private.block_1.win ) then

      private.block_1_win_set();
      
    else 
      
      for i = 1, 4 do

        ObjSet( "spr_superpuzzle_1_mg_1_part_"..private.block_1.part_cond[i] , { pos_x = private.block_1.coord_x[i] });   
          
      end;
    
      if private.block_1.part_get ~= 0 then

        ObjSet( "spr_superpuzzle_1_mg_1_part_"..private.block_1.part_get , { scale_x = 1.1, scale_y = 1.1, pos_z = 50; });

      end;
      
    end;
    
    --------------------------------------------------------------------------------------------
    --mmg block_2
    --------------------------------------------------------------------------------------------
    if ( private.block_2.win ) then

      private.block_2_win_set();
      
    else 
      
      for i = 1, 5  do
      
        for j = 1, 5  do
          
          if ( private.block_2.state[i][j] ~= 0 ) then
            
            ObjSet( "spr_superpuzzle_1_mg_2_chip_"..private.block_2.state[i][j],{ pos_x = private.block_2_coord[1][j], pos_y = private.block_2_coord[2][i] } );

          end;
          
        end;
      
      end;
    
    end;
    
    --------------------------------------------------------------------------------------------
    --mmg block_3
    --------------------------------------------------------------------------------------------
    if ( private.block_3.win ) then

      private.block_3_win_set();
      
    else 
      
      for i = 1,5 do

        if private.block_3.pressed[i] ~= 0 then
         
          ObjSet( "obj_superpuzzle_1_mg_3_clk_"..private.block_3.pressed[i], { input = false });
          ObjSet( "spr_superpuzzle_1_mg_3_clk_"..private.block_3.pressed[i].."_light", { alp = 1 });
           
        else  

          ObjSet( "obj_superpuzzle_1_mg_3_clk_"..private.block_3.pressed[i], { input = true });

        end;
      
        ObjSet( "spr_superpuzzle_1_mg_3_hint_"..i, { alp = 0 });
        
      end;
    
      ObjSet( "spr_superpuzzle_1_mg_3_hint_"..private.block_3_wins[ private.block_3.used ], { alp = 1 });
  
    end;
    
    --------------------------------------------------------------------------------------------
    --mmg block_4
    --------------------------------------------------------------------------------------------
    if ( private.block_4.win ) then

      private.block_4_win_set();
      
    else 
      
      for i = 1, 5 do

        if ( private.block_4.state[i] == 0 ) then

          ObjSet( "obj_superpuzzle_1_mg_4_clk_"..i, { input = false } );

        else 
        
          ObjSet( "spr_superpuzzle_1_mg_4_tile_"..private.block_4.state[i], { pos_x = private.block_4.pos_xy[i][1], pos_y = private.block_4.pos_xy[i][2] } );
          ObjSet( "obj_superpuzzle_1_mg_4_clk_"..i, { input = true } );

        end;

      end;
      
    end;
    
    --------------------------------------------------------------------------------------------
    --mmg block_5
    --------------------------------------------------------------------------------------------
    if ( private.block_5.win ) then

      private.block_5_win_set();
      
    else 
      
      local k = 1;
      
      for i = 1,4 do
        
        private.block_5.wins[i] = {};
        
        for j = 1,5 do
          
          if (private.block_5.used == 1) then
            private.block_5.wins[i][j] = private.block_5.start_1[i][j];
          elseif(private.block_5.used == 2)then
            private.block_5.wins[i][j] = private.block_5.start_2[i][j];
          elseif(private.block_5.used == 3)then
            private.block_5.wins[i][j] = private.block_5.start_3[i][j];
          end;
          
          if private.block_5.pressed[i][j] ~= 0 then
           
            ObjSet( "obj_superpuzzle_1_mg_5_clk_"..i.."_"..j, { input = false });
            ObjSet( "spr_superpuzzle_1_mg_5_clk_"..i.."_"..j.."_light", { alp = 1 });
             
          else  

            ObjSet( "obj_superpuzzle_1_mg_5_clk_"..i.."_"..j, { input = true });

          end;
      
          ObjSet( "spr_superpuzzle_1_mg_5_hint_"..i, { alp = 0 });
        
          if ( private.block_5.wins[i][j] ~= 0 ) then
            
            private.block_5_rec_mas[k] = { i, j } ;
            k=k+1;
            
          end;
      
        end;
        
      end;
      
      ObjSet( "spr_superpuzzle_1_mg_5_hint_1", { alp = 1 });
  
    end;
    --------------------------------------------------------------------------------------------
    --mmg block_6
    --------------------------------------------------------------------------------------------
    private.match3.win_1    = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.win_1;
    private.match3.win_2    = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.win_2;
    private.match3.points   = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.points;
    private.match3.key_done = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.key_done;
    private.match3.current_key = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.current_key;
    
    private.note_1 = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].note_1;
    private.note_2 = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].note_2;
    
    if ( private.match3.win_1 and not private.note_1 and not private.match3.win_2 ) then

      private.Match3GenerateFieldSave();
      private.Match3WinSet_1();
    
    elseif ( private.match3.win_1 and private.note_1 and not private.match3.win_2 ) then
      
      private.WinDropNote_1();
      
    elseif ( private.match3.win_2 and not private.note_2 ) then

      private.Match3GenerateFieldSave ();
      private.Match3WinSet_2();

    else

      private.Match3Load();
     
    end;
    --------------------------------------------------------------------------------------------
    
  end;

  cmn.AddSubscriber( "win_superpuzzle_1", win_superpuzzle_1, private.room_objname );
  cmn.AddSubscriber( "win_superpuzzle_1", win_superpuzzle_1_loc, "rm_beforepuzzle" );
 
  --------------------------------------------------------------------------------------------
  --Init MMG
  -------------------------------------------------------------------------------------------
  
  --------------------------------------------------------------------------------------------
  --mmg block_1
  --------------------------------------------------------------------------------------------
  private.block_1 = {}; 
  private.block_1.part_cond = { 3, 4, 1, 2 };
  private.block_1.part_get = 0; 
  private.block_1.coord_x = { -106, -48, 11, 69 };
  private.block_1.reset_x = { 11, 69, -106, -48 };
  private.block_1.wins = { 1, 2, 3, 4 };
  
  --------------------------------------------------------------------------------------------
  --mmg block_2
  -------------------------------------------------------------------------------------------  
  private.block_2 = {};
  
  --private.block_2_coord = { { -115, -48, 19, 79, 146 }, { -29, -16, -1, 13, 28 } };
  private.block_2_coord = { { -115, -48, 19, 79, 146 }, { 91, 104, 119, 133, 148 } };
  private.block_2.number = 0;
  private.block_2.current = { 0, 0 };
  private.block_2.old = { 0, 0 };
  private.block_2_wins = { 
                          {  0, 0, 0, 0, 4 },
                          {  0, 0, 2, 0, 0 },
                          {  0, 0, 0, 0, 0 },      
                          {  0, 1, 0, 5, 0 },
                          {  3, 0, 0, 0, 0 }
                        };
                        
  private.block_2_init = { 
                          {  1, 0, 0, 0, 0 },
                          {  0, 0, 0, 0, 2 },
                          {  0, 0, 0, 0, 0 },
                          {  0, 4, 0, 0, 0 },
                          {  0, 0, 5, 3, 0 }
                        };
                        
  private.block_2.state = { 
                          {  1, 0, 0, 0, 0 },
                          {  0, 0, 0, 0, 2 },
                          {  0, 0, 0, 0, 0 },
                          {  0, 4, 0, 0, 0 },
                          {  0, 0, 5, 3, 0 }
                         };
                         
  --------------------------------------------------------------------------------------------
  --mmg block_3
  -------------------------------------------------------------------------------------------                       
  private.block_3 = {};  
  private.block_3_wins = { 4, 1, 3, 5, 2 };
  private.block_3.pressed = { 0, 0, 0, 0, 0 };
  private.block_3.used = 1; 
  
  --------------------------------------------------------------------------------------------
  --mmg block_4
  -------------------------------------------------------------------------------------------                     
  private.block_4 = {};
  private.block_4.state = { 4, 3, 2, 0, 1 };
  private.block_4.wins = {  1, 2, 0, 3, 4 }; 
  private.block_4.pos_xy = { {-100, -80}, {95, -80}, { 0, 15}, {-100, 110}, {95, 105} };
  private.block_4.neighbor = { { 2, 3, 4 }, { 1, 3, 5 }, { 1, 2, 4, 5 }, { 1, 3, 5 }, { 2, 3, 4 } };
  private.block_4.first = 0;
  private.block_4.second = 0;
  
  --------------------------------------------------------------------------------------------
  --mmg block_5
  -------------------------------------------------------------------------------------------
  private.block_5 = {}; 
  private.block_5.used = 1;
  private.block_5_rec_mas = {};
  private.block_5.start_1 = { { 0, 0, 1, 0, 0 },
                             { 0, 1, 0, 1, 0 },
                             { 0, 0, 1, 0, 0 },
                             { 0, 0, 1, 0, 0 } };
                             
  private.block_5.start_2 = { { 0, 0, 0, 0, 0 },
                             { 1, 1, 0, 0, 0 },
                             { 0, 0, 1, 1, 1 },
                             { 0, 0, 0, 0, 0 } };
                             
  private.block_5.start_3 = { { 0, 1, 0, 1, 0 },
                             { 0, 1, 0, 1, 0 },
                             { 0, 0, 1, 0, 0 },
                             { 0, 0, 0, 0, 0 } };
                             
  private.block_5.wins = {};
  
  private.block_5.pressed = { { 0, 0, 0, 0, 0 },
                             { 0, 0, 0, 0, 0 },
                             { 0, 0, 0, 0, 0 },
                             { 0, 0, 0, 0, 0 } };
                         
  --------------------------------------------------------------------------------------------
  --mmg block_6
  ------------------------------------------------------------------------------------------- 
  private.Match3Init();
    
end;
--*********************************************************************************************************************
function public.Load()
    
end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_superpuzzle_1" ) then

    if ( not ng_global.progress[ "std" ][ "win_superpuzzle_1" ].begin ) then
      
      local func_after = function()
    
        ng_global.progress[ "std" ][ "win_superpuzzle_1" ].begin = true;
      
      end;
      
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_open_circle", 0, "", 0 );
      AnimPlay( "anm_superpuzzle_1_diaphragm_1", "DoAnim", func_after );
      
    end;
    
    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_superpuzzle_1" ) ) then
    
    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].puzzletimer = 1;
    ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( private.room_objname ) ].puzzle_num = 1;
    -----------------------------------------   
    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_1 = private.block_1;
    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_2 = private.block_2;
    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_3 = private.block_3;
    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_4 = private.block_4;
    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_5 = private.block_5;
    -----------------------------------------
    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3 = {};
    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.win_1   = private.match3.win_1; 
    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.win_2   = private.match3.win_2; 
    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.points  = private.match3.points;
    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.key_done = false;
    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.current_key = private.match3.current_key;
    
    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field = {};

    for i = 1, private.match3_cell_y do

      ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ] = {};
      for j = 1, private.match3_cell_x do

        ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j ] = 0;

      end;

    end;
    
    private.Match3GenerateField( true );  
      
  end;
  
  common_impl.EnvPlay( { "common/audio/level1/aud_beforepuzzle_env" }, "", 0.5 );
  
  common_impl.PlayAudio( "mus", "common/audio/aud_enigma_mus", 0, "", 0 );
  
end;
--*********************************************************************************************************************
function public.Close()
  
  common_impl.StopAudio( "mus", "common/audio/aud_enigma_mus", 0.5 );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_superpuzzle_1" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  
  private.block_1_reset_set()
  private.block_2_reset_set();
  private.block_3_reset_set()
  private.block_4_reset_set()
  private.block_5_reset_set()
  private.Match3ResetSet();
   
  ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( private.room_objname ) ].puzzle_num = 1;
  
end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   

  cmn.MiniGameHide();
  common_impl.PassingMgWin();
  cmn.SetEventDone( "win_superpuzzle_1" );
  cmn.CallEventHandler( "win_superpuzzle_1" );

  common.GotoRoom( "rm_beforepuzzle" );
  
end;
--*********************************************************************************************************************
function private.Win()

  private.WinEnd();

end;
--*********************************************************************************************************************
--function *** Mmg Block_1 *** ()
--*********************************************************************************************************************
function private.clk_block_1( number )

  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_central_click", 0, "", 0 );
      
  local flag ;
  local first_part;

  for i = 1,4 do

    if ObjGet("spr_superpuzzle_1_mg_1_part_"..i).scale_x > 1.05 then 

        flag = true;
        first_part = i;
            
    end;  

  end; 

  if flag then 

    if number == first_part then 
        
      local func_after = function()

        common_impl.Lock( false );
        private.block_1.part_get = 0;
        ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_1 = private.block_1;

      end;

      common_impl.Lock( true );
    
      ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..number , "scale_x", 0, 0, "", 
      {          
        0.0, 0,  1.1, 
        0.3, 0,  1       
      });

      ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..number , "scale_y", 0, 0, "", 
      {          
        0.0, 0,  1.1, 
        0.3, 0,  1     
      }); 

      ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..number , "pos_z", 0, 0, func_after, 
      {          
        0.0, 0,  ObjGet( "spr_superpuzzle_1_mg_1_part_"..number ).pos_z, 
        0.3, 0,  0     
      });  

    else

      private.Part_Move( first_part, number );

    end;         

  else 

    common_impl.Lock( true );

    local func_after = function()

      private.Part_Get( number );

    end;
        
    ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..number , "scale_x", 0, 0, "", 
    {          
      0.0, 0,  1, 
      0.3, 0,  1.1       
    });

    ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..number , "scale_y", 0, 0, "", 
    {          
      0.0, 0,  1, 
      0.3, 0,  1.1      
    }); 

    ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..number , "pos_z", 0, 0, func_after, 
    {          
      0.0, 0,  ObjGet("spr_superpuzzle_1_mg_1_part_"..number).pos_z, 
      0.3, 0,  50     
    });  
  
  end; 

end;
-----------------------------------------------------------------------------------
function private.Part_Get( number )
  
  common_impl.Lock( false );
  private.block_1.part_get = number;
  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_1 = private.block_1;

end;
------------------------------------------------------------------------------------------
function private.Part_Move( first_part, number )

  common_impl.Lock( true );

  local func_after =  function()

    private.Part_Move_1( first_part, number );

  end;

  ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..number , "scale_x", 0, 0, "", 
  {          
    0.0, 0,  1, 
    0.3, 0,  1.1     
  });

  ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..number , "scale_y", 0, 0, func_after, 
  {          
    0.0, 0,  1, 
    0.3, 0,  1.1  
  });

  ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..number , "pos_z", 0, 0, "", 
  {          
    0.0, 0,  ObjGet("spr_superpuzzle_1_mg_1_part_"..number).pos_z, 
    0.3, 0,  51     
  });  

end;
--*********************************************************************************************************************
function private.Part_Move_1( first_part, number )

  local first_part_pos_x = ObjGet( "spr_superpuzzle_1_mg_1_part_"..first_part ).pos_x;

  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_central_move", 0, "", 0 );
      
  ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..first_part , "pos_x", 0, 0, "", 
  {          
    0.0, 0,  ObjGet( "spr_superpuzzle_1_mg_1_part_"..first_part ).pos_x, 
    0.3, 0,  ObjGet( "spr_superpuzzle_1_mg_1_part_"..number ).pos_x      
  }); 

  ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..number , "pos_x", 0, 0, "", 
  {          
    0.0, 0,  ObjGet( "spr_superpuzzle_1_mg_1_part_"..number ).pos_x, 
    0.3, 0,  first_part_pos_x  
  }); 


  local place_1, place_2;

  for i = 1, 4 do

    if private.block_1.part_cond[i] == first_part then 

      place_1 = i; 

    end;

    if private.block_1.part_cond[i] == number then 

      place_2 = i;

    end;

  end;

  cup = private.block_1.part_cond[ place_1 ];
  
  private.block_1.part_cond[ place_1 ]= private.block_1.part_cond[ place_2 ];

  private.block_1.part_cond[ place_2 ]= cup;

  local func_after = function()

    private.Part_Move_2();

  end;

  ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..first_part , "scale_x", 0, 0, "", 
  {          
    0.0, 0,  1.1, 
    0.3, 0,  1       
  });

  ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..first_part , "scale_y", 0, 0, "", 
  {          
    0.0, 0,  1.1, 
    0.3, 0,  1      
  }); 

  ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..first_part , "pos_z", 0, 0, "", 
  {          
    0.0, 0,  ObjGet( "spr_superpuzzle_1_mg_1_part_"..first_part ).pos_z, 
    0.3, 0,  0     
  }); 

  ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..number , "scale_x", 0, 0, "", 
  {          
    0.0, 0,  1.1, 
    0.3, 0,  1       
  });

  ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..number , "scale_y", 0, 0, "", 
  {          
    0.0, 0,  1.1, 
    0.3, 0,  1      
  }); 

  ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..number , "pos_z", 0, 0, func_after, 
  {          
    0.0, 0,  ObjGet( "spr_superpuzzle_1_mg_1_part_"..number ).pos_z, 
    0.3, 0,  0     
  });

end;
--*********************************************************************************************************************
function private.Part_Move_2()

  if ( private.check_block_1_win() ) then

    private.block_1_win_anim();

  else 

    common_impl.Lock( false);
    private.block_1.part_get = 0;
    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_1 = private.block_1;

  end;
 
end;
--*********************************************************************************************************************
function private.check_block_1_win()
  
  local win = true;
  for i = 1, 4 do

    if ( private.block_1.part_cond[i] ~= private.block_1.wins[i]) then

      win = false;

    end;

  end;

  return win;
  
end;
--*********************************************************************************************************************
function private.block_1_win_anim()

  local func_after = function()
  
    local func_end = function()
      
        private.block_1_win();

    end;
      
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_open_circle", 0, "", 0 );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_part_arrive", 0, "", 0 );    
    ObjSet("anm_superpuzzle_1_diaphragm_2", { alp = 0, frame = 0 });
    ObjSet("anm_superpuzzle_1_diaphragm_1", { alp = 1 });
    ObjSet("obj_superpuzzle_1_mg_1", { alp = 0 });
    ObjSet("spr_superpuzzle_1_mg_2_hint", { alp = 1 });
    AnimPlay( "anm_superpuzzle_1_mg_2", "DoAnim", func_end );
    AnimPlay( "anm_superpuzzle_1_diaphragm_1", "DoAnim", "" );  
    
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_close_circle", 0, "", 0 );
  ObjSet("anm_superpuzzle_1_diaphragm_1", { alp = 0, frame = 0 });
  ObjSet("anm_superpuzzle_1_diaphragm_2", { alp = 1 });
  AnimPlay( "anm_superpuzzle_1_diaphragm_2", "DoAnim", func_after );
  
end;
--*********************************************************************************************************************
function private.block_1_win()

  common_impl.Lock( false );
  private.block_1.win = true;
  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_1 = private.block_1;
  ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( private.room_objname ) ].puzzle_num = 2; 
  private.block_1_win_set();

end;
--*********************************************************************************************************************
function private.block_1_win_set()

  local table_multiset = {};
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_1", { input = false, alp = 0 } } );
  for i = 1, 4 do
    table.insert( table_multiset, { "spr_superpuzzle_1_mg_1_part_"..private.block_1.wins[i], { scale_x = 1, scale_y = 1, pos_z = 0, pos_x = private.block_1.coord_x[i] } } );
  end;
  
  --2 blocks
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_2_hint", { alp = 1 } } );
  table.insert( table_multiset, { "anm_superpuzzle_1_mg_2", { alp = 0 } } );
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_2", { input = true, alp = 1 } } );

  ObjMultiSet( table_multiset );

end;
--*********************************************************************************************************************
function private.block_1_reset_set()

  private.block_1.reset = false;
  private.block_1.win = false;

  for i = 1, 4  do

    ObjSet("spr_superpuzzle_1_mg_1_part_"..i,{ pos_x = private.block_1.reset_x[i], alp = 1, input = true });

  end;

  if private.block_1.part_get ~= 0 then

    local part_get = private.block_1.part_get;
    ObjSet( "spr_superpuzzle_1_mg_1_part_"..part_get , { scale_x = 1, scale_y = 1, pos_z = 0; });

  end;
  
  private.block_1.part_cond = { 3, 4, 1, 2 };
  private.block_1.part_get = 0; 

  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_1 = private.block_1;
  
  local table_multiset = {};

  table.insert( table_multiset, { "obj_superpuzzle_1_mg_1", { input = true, alp = 1 } } );
  table.insert( table_multiset, { "anm_superpuzzle_1_diaphragm_1", { playing = true, frame =0, alp = 1 } } );
  table.insert( table_multiset, { "anm_superpuzzle_1_diaphragm_2", { frame =0, alp = 0 } } );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_open_circle", 0, "", 0 );
  
  ObjMultiSet( table_multiset );

end;
--*********************************************************************************************************************
function public.SkipPuzzle1()

  local func_after = function ()

    common_impl.Lock( false );
    private.block_1_win_anim();

    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].puzzletimer = 1;
    interface.PuzzleHelpReload( 1 );
    interface.PuzzleHelpHide();
    ObjSet( "tmr_superpuzzle_1_skip", { playing = false } );

  end;

  common_impl.Lock( true );

  for i = 1, 4 do
    
    ObjSet( "spr_superpuzzle_1_mg_1_part_"..private.block_1.wins[i], { scale_x = 1, scale_y = 1, pos_z = 0; });
    ObjAnimate( "spr_superpuzzle_1_mg_1_part_"..private.block_1.wins[i], "pos_x", 0, 0, "", 
    {          
      0.0, 0,  ObjGet("spr_superpuzzle_1_mg_1_part_"..private.block_1.wins[i]).pos_x, 
      0.3, 0,  private.block_1.coord_x[i]     
    });
    
  end;
  
  ObjSet( "tmr_superpuzzle_1_skip", { playing = true, time = 0.4, endtrig = func_after } );
  
end;
--*********************************************************************************************************************
--function *** Mmg Block_2 *** ()
--*********************************************************************************************************************
function private.DragChip( number )

  ObjClone("spr_superpuzzle_1_mg_2_chip_"..number, "_clone", false, "obj_superpuzzle_1_mg_2_crop");
  ObjSet("spr_superpuzzle_1_mg_2_chip_"..number.."_clone",{ pos_z = 5, input = false });
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_get_animal", 0, "", 0 );
  ObjSet( "spr_superpuzzle_1_mg_2_chip_"..number, { pos_z = 5, alp = 0 } );
  private.block_2.number = number;
  
  for i = 1, 5 do
    
    for j = 1, 5  do
      
      if ObjGet( "spr_superpuzzle_1_mg_2_chip_"..number ).pos_x == private.block_2_coord[1][i] and ObjGet( "spr_superpuzzle_1_mg_2_chip_"..number ).pos_y == private.block_2_coord[2][j] then

        private.block_2.current = {i, j};
        break;
         
       end;
     
    end;

  end; 
  
end;
--*********************************************************************************************************************
function private.DropChip( number, two_step )
  
  private.LeaveChip(number);
  
  --DbgTrace("private.DropChip number:"..tostring(number).." two_step:"..tostring(two_step));
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_set_animal", 0, "", 0 );
  ObjDelete("spr_superpuzzle_1_mg_2_chip_"..number.."_clone");
  ObjSet("spr_superpuzzle_1_mg_2_chip_"..number,{ alp = 1 });
  
  local new_number = 0;
  local new_i = 0;
  local new_j = 0;  
  local znach_i = 0;
  local znach_j = 0;  
  local change_flag = false;
  local drag = false;
  
  local param_old = GetObjPosByObj( "spr_superpuzzle_1_mg_2_chip_"..number, "obj_superpuzzle_1_mg_2_crop" );
  
  local func_after = function( num )

    common_impl.Lock( false );
    common_impl.SetCursor( CURSOR_HAND );
    
    if ( drag ) then

      --ObjStartDrag( "spr_superpuzzle_1_mg_2_chip_"..new_number );
      private.block_2.old = {private.block_2.current[2], private.block_2.current[1] };
      private.block_2.state[ private.block_2.current[2] ][ private.block_2.current[1] ] = 0;
      private.block_2.state[ znach_i ][ znach_j ] = 0;
      private.block_2.state[ new_i ][ new_j ] = number;
      ObjSet( "spr_superpuzzle_1_mg_2_string_"..new_j.."_"..new_i.."_light", { alp = 0 } ); 
      private.block_2.current = { znach_i, znach_j };
      private.block_2.number = new_number;
      
      private.DropChip( new_number, true );
      
     
    else

      private.block_2.state[ private.block_2.current[2] ][ private.block_2.current[1] ] = 0;
      private.block_2.old = {new_i, new_j};
      private.block_2.state[ new_i ][ new_j ] = number;
      ObjSet( "spr_superpuzzle_1_mg_2_string_"..new_j.."_"..new_i.."_light", { alp = 0 } );
      private.block_2.current = { 0, 0 };
      private.block_2.number = 0;
      
      
    end;

    if ( private.check_block_2_win() ) then
      
      private.block_2_win_anim();
      common_impl.SetCursor( CURSOR_DEFAULT );
      
    else
      
      ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_2 = private.block_2;
          
    end;
     
  end;

  for j = 1, 5 do
    
    for i = 1, 5 do
      
      --если пересекли область
      if ( common.ApplyObj( "obj_superpuzzle_1_mg_2_chip_"..number.."_rect", "obj_superpuzzle_1_mg_2_string_"..j.."_"..i ) ) then
       
          change_flag = true;
          common_impl.Lock( true );

          for k = 1, 5  do

            if( private.block_2.state[k][j] ~= 0 )then

              new_number = private.block_2.state[k][j];
              new_i = i;
              new_j = j;

              if ( new_number ~= number ) then --если не равны числа в массиве в столбце
                
                drag = true;
                znach_i = k;
                znach_j = j;
 
              else
                
                drag = false;
                
              end;
              
            else 
              
              --drag = false;
              new_i = i;
              new_j = j;
              
            end;

          end;

          ObjSet( "spr_superpuzzle_1_mg_2_chip_"..new_number, { pos_z = 5 } );
          ObjSet( "spr_superpuzzle_1_mg_2_chip_"..number, { pos_z = 0 } );
        
          ObjAnimate( "spr_superpuzzle_1_mg_2_chip_"..number, "pos_xy", 0, 0, function() func_after(j) end, { 0,0,param_old[1],param_old[2], 0.3,0,private.block_2_coord[1][ j ],private.block_2_coord[2][ i ] } ); 
 
          break;

      end;
        
    end;
      
  end;
    
  if two_step then
    change_flag = false;
  end;
  
  
  if change_flag == false then --бросили мимо области

    if ( private.block_2.old[1] == 0 or private.block_2.old[2] == 0) then
      private.block_2.old[1] = private.block_2.current[2];
      private.block_2.old[2] = private.block_2.current[1];
      znach_i = private.block_2.current[1];
      znach_j = private.block_2.current[2];
      new_i = znach_i;
      new_j = znach_j;
      
    else 

       for i = 1, 5 do
    
         for j = 1, 5 do
           
           if( private.block_2.state[i][j] == number )then
             
              private.block_2.old[1] = i;
              private.block_2.old[2] = j;
              break;
              
           end;
           
         end;
        
      end;
      
    end;
    
    common_impl.Lock( true );
    local func_2_after = function()

      common_impl.Lock( false );
      ObjSet( "spr_superpuzzle_1_mg_2_chip_"..number, { pos_z = 0 } );
      common_impl.SetCursor( CURSOR_DEFAULT );
      ObjSet( "spr_superpuzzle_1_mg_2_string_"..private.block_2.old[2].."_"..private.block_2.old[1].."_light", { alp = 0 } );
      private.block_2.state[ private.block_2.old[1] ][ private.block_2.old[2] ] = number;
      ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_2 = private.block_2;
      
    end;
    
    
    --if ( private.block_2.old[1] == private.block_2.current[1] and private.block_2.old[1] == private.block_2.current[1]) then
    if( private.block_2.state[ private.block_2.old[1] ][ private.block_2.old[2] ] ~= 0 
      and private.block_2.state[ private.block_2.old[1] ][ private.block_2.old[2] ] ~= number ) then
      
      local num = 0;
      local sum = 0;
      for i = 1, 5  do
        for j = 1, 5  do
          
          if( private.block_2.state[j][i] == 0 )then
            
            sum = sum + 1;
            
          end;
          
          if( sum == 5 )then
            
            num = i;
            break;
            
          end;
          
        end;
      end;
      
      private.block_2.old[2] = num;
      private.block_2.old[1] = 1;
      
      ObjAnimate( "spr_superpuzzle_1_mg_2_chip_"..number, "pos_xy", 0, 0, func_2_after, { 0,0,param_old[1],param_old[2], 0.4,0, private.block_2_coord[1][ private.block_2.old[2] ], private.block_2_coord[2][ private.block_2.old[1] ] } ); 
    
    else 
      
      ObjAnimate( "spr_superpuzzle_1_mg_2_chip_"..number, "pos_xy", 0, 0, func_2_after, { 0,0,param_old[1],param_old[2], 0.4,0, private.block_2_coord[1][ private.block_2.old[2] ], private.block_2_coord[2][ private.block_2.old[1] ] } ); 
    
    end;
    
  end;

end;
--*********************************************************************************************************************
function private.DragLight( number )
 
  for j = 1, 5 do
    
    for i = 1, 5 do
      
      if ( common.ApplyObj( "obj_superpuzzle_1_mg_2_chip_"..number.."_rect", "obj_superpuzzle_1_mg_2_string_"..j.."_"..i ) ) then
        ObjSet( "spr_superpuzzle_1_mg_2_string_"..j.."_"..i.."_light", { alp = 1 } );  
      else 
        ObjSet( "spr_superpuzzle_1_mg_2_string_"..j.."_"..i.."_light", { alp = 0 } ); 
      end; 
      
    end;
    
  end;  
  
  local pos = GetZoomCursorPos();
  
  if pos[1] < 10 then pos[1] = 10; end;
  if pos[1] > 415 then pos[1] = 415; end;
  if pos[2] < 200 then pos[2] = 200; end;
  if pos[2] > 340 then pos[2] = 340; end;
  
  pos[1] = pos[1] - 213;
  pos[2] = pos[2] - 167;
  ObjSet( "spr_superpuzzle_1_mg_2_chip_"..number.."_clone", { pos_x = pos[1], pos_y = pos[2] });
  
end;
--*********************************************************************************************************************
function private.EnterChip( number )
  
  common_impl.SetCursor( CURSOR_GET );
  --ObjSet( "spr_superpuzzle_1_mg_2_chip_"..number.."_light", { alp = 1 } );
     
end;
--*********************************************************************************************************************
function private.LeaveChip( number )
  
  common_impl.SetCursor( CURSOR_DEFAULT );
  --ObjSet( "spr_superpuzzle_1_mg_2_chip_"..number.."_light", { alp = 0 } );
    
end;
--*********************************************************************************************************************
function private.check_block_2_win()

  local win = true;

  for i = 1, 5  do
    
    for j = 1, 5  do
      
      if ( private.block_2.state[i][j] ~= private.block_2_wins[i][j] ) then
        win = false;
        break;
      end;
      
    end;
    
  end;

  if ( win ) then
    return true;
  else 
    return false;
  end;
  
end;
--*********************************************************************************************************************
function private.block_2_win_anim()

  local func_after = function()
  
    local func_end = function()
      
      private.block_2_win();

    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_open_circle", 0, "", 0 );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_part_arrive", 0, "", 0 );  
    ObjSet("anm_superpuzzle_1_diaphragm_2", { alp = 0, frame = 0 });
    ObjSet("anm_superpuzzle_1_diaphragm_1", { alp = 1 });
    ObjSet("spr_superpuzzle_1_mg_2_hint", { alp = 0 });
    ObjSet("obj_superpuzzle_1_mg_3_hint", { alp = 1 });
    AnimPlay( "anm_superpuzzle_1_mg_3", "DoAnim", func_end );
    AnimPlay( "anm_superpuzzle_1_diaphragm_1", "DoAnim", "" );  
    
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_close_circle", 0, "", 0 );
  ObjSet("spr_superpuzzle_1_mg_2_light", { alp = 1 });
  ObjSet("anm_superpuzzle_1_diaphragm_1", { alp = 0, frame = 0 });
  ObjSet("anm_superpuzzle_1_diaphragm_2", { alp = 1 });
  AnimPlay( "anm_superpuzzle_1_diaphragm_2", "DoAnim", func_after );
  
end;
--*********************************************************************************************************************
function private.block_2_win()

  common_impl.Lock( false );
  private.block_2.win = true;
  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_2 = private.block_2;
  ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( private.room_objname ) ].puzzle_num = 3;
  private.block_2_win_set();

end;

function private.block_2_win_set()

  local table_multiset = {};
  
  for i = 1, 5  do
      
    for j = 1, 5  do
      
      if ( private.block_2_wins[i][j] ~= 0 ) then
        
        table.insert( table_multiset, { "spr_superpuzzle_1_mg_2_chip_"..private.block_2_wins[i][j], { pos_x = private.block_2_coord[1][j], pos_y = private.block_2_coord[2][i] } } );

      end;
      
    end;
  
  end;
  
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_2", { input = false } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_2_light", { alp = 1 } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_2_hint", { alp = 0 } } );

  --3 blocks
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_3_hint", { alp = 1 } } );
  table.insert( table_multiset, { "anm_superpuzzle_1_mg_3", { alp = 0 } } );
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_3", { input = true, alp = 1 } } );

  ObjMultiSet( table_multiset );

end;
--*********************************************************************************************************************
function private.block_2_reset_set()

  private.block_2.reset = false;
  private.block_2.win = false;

  private.block_2.number = 0;
  private.block_2.current = { 0, 0 };
  private.block_2.old = { 0, 0 };
  
  for i = 1, 5  do
    
    for j = 1, 5  do
      
      private.block_2.state[i][j] = private.block_2_init[i][j];
      
      if ( private.block_2.state[i][j] ~= 0 ) then
        
        ObjSet( "spr_superpuzzle_1_mg_2_chip_"..private.block_2.state[i][j],{ pos_x = private.block_2_coord[1][j], pos_y = private.block_2_coord[2][i] } );
      
      end;
      
    end;
    
  end;
  
  local table_multiset = {};
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_2", { input = false, alp = 0 } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_2_hint", { alp = 0 } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_2_light", { alp = 0 } } );
  table.insert( table_multiset, { "anm_superpuzzle_1_mg_2", { alp = 1, frame = 0 } } );
  ObjMultiSet( table_multiset );  
  
end;
--*********************************************************************************************************************
function public.SkipPuzzle2()

  local func_after = function ()

    common_impl.Lock( false );
    private.block_2_win_anim();

    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].puzzletimer = 1;
    interface.PuzzleHelpReload( 1 );
    interface.PuzzleHelpHide();
    ObjSet( "tmr_superpuzzle_1_skip", { playing = false, endtrig = func_after } );
    
  end;

  common_impl.Lock( true );
  
  for i = 1, 5  do
      
    for j = 1, 5  do
      
      if ( private.block_2_wins[i][j] ~= 0 ) then
        
        ObjAnimate( "spr_superpuzzle_1_mg_2_chip_"..private.block_2_wins[i][j], "pos_xy", 0, 0, "", 
        {          
          0.0, 0,  ObjGet("spr_superpuzzle_1_mg_2_chip_"..private.block_2_wins[i][j]).pos_x, ObjGet("spr_superpuzzle_1_mg_2_chip_"..private.block_2_wins[i][j]).pos_y,
          0.3, 0,  private.block_2_coord[1][j], private.block_2_coord[2][i]     
        });
        
      end;
      
    end;
  
  end;
  
  ObjSet( "tmr_superpuzzle_1_skip", { playing = true, time = 0.4, endtrig = func_after } );  

end;
--*********************************************************************************************************************
-- function *** Mmg block_3 ***() end
--*********************************************************************************************************************
function private.anim_block_3( num )
  
  local func_after = function()
  
    common_impl.Lock( false );
    
    if private.block_3.used == 6 then 

      private.block_3_win_anim();
      
    else 
      
      ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_3 = private.block_3;
        
    end;
    
  end;
  
  common_impl.Lock( true );

  if private.block_3.used == 1 then
    
    ObjAnimate( "spr_superpuzzle_1_mg_3_hint_"..num, "alp", 0, 0, func_after, 
    { 
      0.0,0,0,  
      0.3,0,1
    });
    
  else 
    
    ObjAnimate( "spr_superpuzzle_1_mg_3_hint_"..private.block_3_wins[ private.block_3.used - 1 ], "alp", 0, 0, func_after, 
    { 
      0.0,0,1,  
      0.3,0,0
    });
    
    if private.block_3.used < 6 then
      
      ObjAnimate( "spr_superpuzzle_1_mg_3_hint_"..private.block_3_wins[ private.block_3.used ], "alp", 0, 0, "", 
      { 
        0.0,0,0,  
        0.3,0,1
      });
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function private.clk_block_3( num )
  
  common_impl.Lock( true );
    
  if private.block_3_wins[ private.block_3.used ] == tonumber( num ) then

    local func_after = function()
          
      ObjSet( "obj_superpuzzle_1_mg_3_clk_"..num, { input = false });

      private.block_3.pressed[ private.block_3.used ] = num;
      private.block_3.used = private.block_3.used + 1;

      private.anim_block_3( private.block_3_wins[ private.block_3.used ] );
      
    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_instruments_true", 0, "", 0 ); 
    ObjAnimate( "spr_superpuzzle_1_mg_3_clk_"..num.."_light", "alp", 0, 0, func_after, 
    { 
      0.0,0,0,  
      0.3,0,1
    });
    
  else 

    local func_after = function()
    
      common_impl.Lock( false );
      private.block_3_reset();
      
    end;
  
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_instruments_wrong", 0, "", 0 ); 
    ObjAnimate( "spr_superpuzzle_1_mg_3_clk_"..num.."_light", "alp", 0, 0, func_after, 
    { 
      0.0,0,0,  
      0.3,0,1
    });

  end;
  
end;
--*********************************************************************************************************************
function private.block_3_win_anim()

  local func_after = function()
  
    local func_end = function()
      
      private.block_3_win();

    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_open_circle", 0, "", 0 );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_part_arrive", 0, "", 0 ); 
    ObjSet("anm_superpuzzle_1_diaphragm_2", { alp = 0, frame = 0 });
    ObjSet("anm_superpuzzle_1_diaphragm_1", { alp = 1 });
    ObjSet("obj_superpuzzle_1_mg_3_hint", { alp = 0 });
    ObjSet("spr_superpuzzle_1_mg_4_hint", { alp = 1 });
    AnimPlay( "anm_superpuzzle_1_mg_4", "DoAnim", func_end );
    AnimPlay( "anm_superpuzzle_1_diaphragm_1", "DoAnim", "" );  
    
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_close_circle", 0, "", 0 );
  ObjSet("spr_superpuzzle_1_mg_3_light", { alp = 1 });
  ObjSet("anm_superpuzzle_1_diaphragm_1", { alp = 0, frame = 0 });
  ObjSet("anm_superpuzzle_1_diaphragm_2", { alp = 1 });
  AnimPlay( "anm_superpuzzle_1_diaphragm_2", "DoAnim", func_after );
  
end;
--*********************************************************************************************************************
function private.block_3_win()

  common_impl.Lock( false );
  private.block_3.win = true;

  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_3 = private.block_3;
  ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( private.room_objname ) ].puzzle_num = 4;
  private.block_3_win_set();

end;
--*********************************************************************************************************************
function private.block_3_win_set()

  local table_multiset = {};
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_3", { input = false } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_3_light", { alp = 1 } } );
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_3_hint", { alp = 0 } } );
  for i = 1, 5  do
    table.insert( table_multiset, { "spr_superpuzzle_1_mg_3_clk_"..i.."_light", { alp = 1 } } );
  end;
  
  --4 blocks
  table.insert( table_multiset, { "anm_superpuzzle_1_mg_4", { alp = 0 } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_4_hint", { alp = 1 } } );
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_4", { input = true, alp = 1 } } );

  ObjMultiSet( table_multiset );

end;
--*********************************************************************************************************************
function private.block_3_reset()
  
  private.block_3.pressed = { 0, 0, 0, 0, 0 };
  private.block_3.used = 1;   
  private.block_3.reset = false;
  private.block_3.win = false;
  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_3 = private.block_3;
  
  for i = 1,5 do

    ObjSet( "obj_superpuzzle_1_mg_3_clk_"..i, { input = true });
    ObjSet( "spr_superpuzzle_1_mg_3_clk_"..i.."_light", { alp = 0 });
    
  end;
  
  for i = 1,5 do

    ObjSet( "spr_superpuzzle_1_mg_3_hint_"..i, { alp = 0 });
    
  end;
  
  ObjSet( "spr_superpuzzle_1_mg_3_hint_"..private.block_3_wins[ private.block_3.used ], { alp = 1 });
  
end;
--*********************************************************************************************************************
function private.block_3_reset_set()
  
  private.block_3_reset();
  
  local table_multiset = {};
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_3", { input = false, alp = 0 } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_3_light", { alp = 0 } } );
  table.insert( table_multiset, { "anm_superpuzzle_1_mg_3", { alp = 1, frame = 0 } } );
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_3_hint", { alp = 0 } } );
  
  ObjMultiSet( table_multiset );
  
end;
--*********************************************************************************************************************
function public.SkipPuzzle3()

  local func_after = function ()

    common_impl.Lock( false );
    private.block_3_win_anim();

    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].puzzletimer = 1;
    interface.PuzzleHelpReload( 1 );
    interface.PuzzleHelpHide();
    ObjSet( "tmr_superpuzzle_1_skip", { playing = false } );  
    
  end;

  common_impl.Lock( true );
  
  for i = 1, 5  do
    
    ObjAnimate( "spr_superpuzzle_1_mg_3_clk_"..i.."_light", "alp", 0, 0, "", 
    {          
      0.0, 0, 0,
      0.3, 0, 1     
    });

  end;

  ObjSet( "tmr_superpuzzle_1_skip", { playing = true, time = 0.4, endtrig = func_after } );  

end;
--*********************************************************************************************************************
-- function *** Mmg block_4 ***() end
--*********************************************************************************************************************
function private.clk_block_4( num )

  local num = tonumber(num);
  private.block_4.reset = true;
  local func_after = function()

    local sym = private.block_4.state[private.block_4.first];
    private.block_4.state[private.block_4.first] = private.block_4.state[private.block_4.second];
    private.block_4.state[private.block_4.second] = sym ;
    
    private.check_block_4_smen( private.block_4.second );
        
    if private.check_block_4_win() then

      private.block_4_win_anim();

    else
     
      ng_global.progress["std"]["win_superpuzzle_1"].block_4 = private.block_4;
      common_impl.Lock( false );

    end; 

  end;

  for i = 1, #private.block_4.neighbor[num] do
    
    if ( private.block_4.state[ private.block_4.neighbor[num][i] ] == 0 ) then

      common_impl.Lock( true );
      
      private.block_4.first = num;
      private.block_4.second = private.block_4.neighbor[num][i];
      
      local x1 = private.block_4.pos_xy[private.block_4.first][1];
      local y1 = private.block_4.pos_xy[private.block_4.first][2];

      local x2 = private.block_4.pos_xy[private.block_4.second][1];
      local y2 = private.block_4.pos_xy[private.block_4.second][2];

      ObjAnimate( "spr_superpuzzle_1_mg_4_tile_"..private.block_4.state[private.block_4.first], "pos_xy", 0, 0, func_after, 
      { 
        0.0, 0, x1, y1,
        0.6, 0, x2, y2
      } );

      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_instruments_click", 0, "", 0 ); 
      
    end;
    
  end;
  
end;

--*********************************************************************************************************************
function private.check_block_4_smen( num )
  
  for i = 1, #private.block_4.neighbor[num] do
    if ( private.block_4.state[ private.block_4.neighbor[num][i] ] == 0 ) then
      ObjSet( "obj_superpuzzle_1_mg_4_clk_"..private.block_4.neighbor[num][i], { input = false } );
    end;
  end;
  
  ObjSet( "obj_superpuzzle_1_mg_4_clk_"..num, { input = true } );

end;
--*********************************************************************************************************************
function private.check_block_4_win()

  for i = 1, 5  do
    if ( private.block_4.state[i] ~= 0 ) then
      if (private.block_4.state[i] == private.block_4.wins[i] ) then
        common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_2_figures_win", 0, "", 0 );
      end;
    end;
  end;

  local win = true;

  for i = 1, 5  do
    if (private.block_4.state[i] ~= private.block_4.wins[i] ) then
      win = false;
      break;
    end;
  end;

  if ( win ) then
    return true;
  else 
    return false;
  end;

end;
--*********************************************************************************************************************
function private.block_4_win_anim()
  
  local func_after = function()
  
    local func_end = function()
      
      private.block_4_win();

    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_open_circle", 0, "", 0 );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_part_arrive", 0, "", 0 );  
    ObjSet("anm_superpuzzle_1_diaphragm_2", { alp = 0, frame = 0 });
    ObjSet("anm_superpuzzle_1_diaphragm_1", { alp = 1 });
    ObjSet("spr_superpuzzle_1_mg_4_hint", { alp = 0 });
    ObjSet("obj_superpuzzle_1_mg_5_hint", { alp = 1 })
    AnimPlay( "anm_superpuzzle_1_mg_5", "DoAnim", func_end );
    AnimPlay( "anm_superpuzzle_1_diaphragm_1", "DoAnim", "" );  
    
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_close_circle", 0, "", 0 );
  ObjSet("spr_superpuzzle_1_mg_4_light", { alp = 1 })
  ObjSet("anm_superpuzzle_1_diaphragm_1", { alp = 0, frame = 0 });
  ObjSet("anm_superpuzzle_1_diaphragm_2", { alp = 1 });
  AnimPlay( "anm_superpuzzle_1_diaphragm_2", "DoAnim", func_after );
  
end;
--*********************************************************************************************************************
function private.block_4_win()

  common_impl.Lock( false );
  private.block_4.win = true;

  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_4 = private.block_4;
  ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( private.room_objname ) ].puzzle_num = 5;
  private.block_4_win_set();
  private.init_block_5();

end;
--*********************************************************************************************************************
function private.block_4_win_set()

  local table_multiset = {};
  
  for i = 1, 5 do
    
    if ( private.block_4.wins[i] ~= 0 ) then
    
      table.insert( table_multiset, { "spr_superpuzzle_1_mg_4_tile_"..private.block_4.wins[i], { pos_x = private.block_4.pos_xy[i][1], pos_y = private.block_4.pos_xy[i][2] } } );
    
    end;
    
  end;
  
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_4", { input = false } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_4_hint", { alp = 0 } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_4_light", { alp = 1 } } );

  --5 blocks
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_5_hint", { alp = 1 } } );
  table.insert( table_multiset, { "anm_superpuzzle_1_mg_5", { alp = 0 } } );
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_5", { input = true, alp = 1 } } );
    
  ObjMultiSet( table_multiset );

end;
--*********************************************************************************************************************
function private.block_4_reset_set()

  private.block_4.reset = false;
  private.block_4.win = false;
  private.block_4.state = { 4, 3, 2, 0, 1 };
  private.block_4.first = 0;
  private.block_4.second = 0;

  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_4 = private.block_4;

  for i = 1, 5 do

    if ( private.block_4.state[i] == 0 ) then

      ObjSet( "obj_superpuzzle_1_mg_4_clk_"..i, { input = false } );

    else 

      ObjSet( "spr_superpuzzle_1_mg_4_tile_"..private.block_4.state[i], { pos_x = private.block_4.pos_xy[i][1], pos_y = private.block_4.pos_xy[i][2] } );
      ObjSet( "obj_superpuzzle_1_mg_4_clk_"..i, { input = true } );

    end;

  end;

  local table_multiset = {};
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_4", { input = false, alp = 0 } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_4_hint", { alp = 0 } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_4_light", { alp = 0 } } );
  table.insert( table_multiset, { "anm_superpuzzle_1_mg_4", { alp = 1, frame = 0 } } );
  ObjMultiSet( table_multiset );

end;
--*********************************************************************************************************************
function public.SkipPuzzle4()

  local func_after = function ()

    common_impl.Lock( false );
    private.block_4_win_anim();

    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].puzzletimer = 1;
    interface.PuzzleHelpReload( 1 );
    interface.PuzzleHelpHide();
    ObjSet( "tmr_superpuzzle_1_skip", { playing = false } );
    
  end;

  common_impl.Lock( true );
  
  for i = 1, 5 do

    if ( private.block_4.wins[i] ~= 0 ) then
      
      ObjAnimate( "spr_superpuzzle_1_mg_4_tile_"..private.block_4.wins[i], "pos_xy", 0, 0, "", 
      {          
        0.0, 0, ObjGet( "spr_superpuzzle_1_mg_4_tile_"..private.block_4.wins[i] ).pos_x, ObjGet( "spr_superpuzzle_1_mg_4_tile_"..private.block_4.wins[i] ).pos_y, 
        0.3, 0, private.block_4.pos_xy[i][1], private.block_4.pos_xy[i][2]     
      });
    
    end;
    
  end;  
  
  ObjSet( "tmr_superpuzzle_1_skip", { playing = true, time = 0.4, endtrig = func_after } ); 

end;
--*********************************************************************************************************************
-- function *** Mmg block_5 ***() end
--*********************************************************************************************************************
function private.init_block_5( reset_flag )
  
  local k = 1;
  for i = 1, 4  do
    
    private.block_5.wins[i] = {};

    for j = 1, 5  do
      
      private.block_5.wins[i][j] = private.block_5.start_1[i][j];
      ObjSet("spr_superpuzzle_1_mg_5_hint_part_"..i.."_"..j,{ alp = 0 });
      
      if ( private.block_5.wins[i][j] ~= 0 ) then
        
        private.block_5_rec_mas[k] = { i, j } ;
        k=k+1;
        
      end;
      
    end;
    
  end;
  
  private.rec_block_5( 1, reset_flag );
  
end;
--*********************************************************************************************************************
function private.rec_block_5( num, reset_flag )
  
  local func_after = function()
  
    common_impl.Lock( false );
    if ( num <= 4 ) then
      
      num = num + 1;
      private.rec_block_5( num, reset_flag );  
      
    else 
      
      for i = 1, 4  do

        for j = 1, 5  do
          
          ObjSet("spr_superpuzzle_1_mg_5_hint_part_"..i.."_"..j,{ alp = 0 });
          
        end;
        
      end;
      
    end;
   
  end;
  
  common_impl.Lock( true );  
  
  if not reset_flag then
  
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_square_"..private.block_5_rec_mas[num][1].."_"..private.block_5_rec_mas[num][2], 0, "", 0 ); 
  
  end;  
    
  ObjAnimate( "spr_superpuzzle_1_mg_5_hint_part_"..private.block_5_rec_mas[num][1].."_"..private.block_5_rec_mas[num][2], "alp", 0, 0, func_after, 
  {          
    0.0, 0, 0, 
    0.3, 0, 1     
  });
  
end;
--*********************************************************************************************************************
function private.anim_block_5( num )
  
  if ( num == 2 ) then
    
    local k = 1;
    
    for i = 1, 4  do
    
      private.block_5.wins[i] = {};
      
      for j = 1, 5  do
        
        private.block_5.wins[i][j] = private.block_5.start_2[i][j];
        ObjSet("spr_superpuzzle_1_mg_5_hint_part_"..i.."_"..j,{ alp = 0 });
        if ( private.block_5.wins[i][j] ~= 0 ) then
          
          private.block_5_rec_mas[k] = { i, j } ;
          k=k+1;
          
        end;
        
      end;
    
    end;
    
    private.rec_block_5( 1 );
    
  elseif ( num == 3 ) then
    
    local k = 1;
    
    for i = 1, 4  do
    
      private.block_5.wins[i] = {};
      
      for j = 1, 5  do
        
        private.block_5.wins[i][j] = private.block_5.start_3[i][j];
        ObjSet("spr_superpuzzle_1_mg_5_hint_part_"..i.."_"..j,{ alp = 0 });
        if ( private.block_5.wins[i][j] ~= 0 ) then
          
          private.block_5_rec_mas[k] = { i, j } ;
          k=k+1;
          
        end;
        
      end;
    
    end;
    
    private.rec_block_5( 1 );
    
  else 
    
    private.block_5_win_anim();
    
  end;
  
end;
--*********************************************************************************************************************
function private.clk_block_5( k, m )
   
  local func_after = function()  
  
    if private.block_5.wins[k][m] == 1 then
        
        private.block_5.pressed[k][m] = 1;
        ObjSet( "obj_superpuzzle_1_mg_5_clk_"..k.."_"..m, { input = false });
        
        if ( private.check_block_5_win() ) then
          
          private.block_5_reset();
          
          private.block_5.used = private.block_5.used + 1;
          private.anim_block_5( private.block_5.used );

        else 
          
          common_impl.Lock( false );
          ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_5 = private.block_5;
          
        end;
        
    else 
      
      private.block_5_reset();
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_squares_wrong", 0, "", 0 ); 
      private.rec_block_5( 1 );
      
    end;
    
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_square_"..k.."_"..m, 0, "", 0 ); 
  
  ObjAnimate( "spr_superpuzzle_1_mg_5_clk_"..k.."_"..m.."_light", "alp", 0, 0, func_after, 
  { 
    0.0,0,0,  
    0.3,0,1
  });
    
end;
--*********************************************************************************************************************
function private.check_block_5_win()
  
  local win = true;
  
  for i = 1, 4 do
    for j = 1, 5 do
      
      if ( private.block_5.wins[i][j] ~= private.block_5.pressed[i][j]) then

        win = false;

      end;
    
    end;
  end;

  return win;
  
end;
--*********************************************************************************************************************
function private.block_5_win_anim()
  
  local func_after = function()
  
    local func_end = function()
      
      private.block_5_win();

    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_show_match3", 0, "", 0 ); 
    ObjAnimate( "obj_superpuzzle_1_mg_6", "pos_y", 0, 0, func_end, 
    { 
      0.0, 0, -320,  
      0.5, 0, 220
    });
    
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_close_circle", 0, "", 0 );
  ObjSet("spr_superpuzzle_1_mg_5_light", { alp = 1 });
  ObjSet("spr_superpuzzle_1_mg_5_hint_1", { alp = 0 });
  ObjSet("anm_superpuzzle_1_diaphragm_1", { alp = 0, frame = 0 });
  ObjSet("anm_superpuzzle_1_diaphragm_2", { alp = 1 });
  AnimPlay( "anm_superpuzzle_1_diaphragm_2", "DoAnim", func_after );
  
end;
--*********************************************************************************************************************
function private.block_5_win()

  common_impl.Lock( false );
  private.block_5.win = true;

  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_5 = private.block_5;
  ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( private.room_objname ) ].puzzle_num = 6;
  private.block_5_win_set();

end;
--*********************************************************************************************************************
function private.block_5_win_set()

  local table_multiset = {};
  if ( private.block_5.used == 1 ) then
    
    for i = 1,4 do
      for j = 1,5 do 
        if private.block_5.start_1[i][j] ~= 0 then
          table.insert( table_multiset, { "spr_superpuzzle_1_mg_5_clk_"..i.."_"..j.."_light", { alp = 1 } } );
        end;
      end;
    end; 
  
  elseif( private.block_5.used == 2 )then 
  
    for i = 1,4 do
      for j = 1,5 do 
        if private.block_5.start_2[i][j] ~= 0 then
          table.insert( table_multiset, { "spr_superpuzzle_1_mg_5_clk_"..i.."_"..j.."_light", { alp = 1 } } );
        end;
      end;
    end; 
    
  elseif( private.block_5.used == 3 )then 
  
    for i = 1,4 do
      for j = 1,5 do 
        if private.block_5.start_3[i][j] ~= 0 then
          table.insert( table_multiset, { "spr_superpuzzle_1_mg_5_clk_"..i.."_"..j.."_light", { alp = 1 } } );
        end;
      end;
    end; 
    
  end;
  
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_5", { input = false } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_5_hint_1", { alp = 0 } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_5_light", { alp = 1 } } );
  
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_6", { input = true, pos_y = 220 } } );  
  ObjMultiSet( table_multiset );

end;
--*********************************************************************************************************************
function private.block_5_reset()
  
  common_impl.Lock( false );
  for i = 1,4 do
    for j = 1,5 do
      
      ObjSet("spr_superpuzzle_1_mg_5_hint_part_"..i.."_"..j,{ alp = 0 });
      private.block_5.pressed[i][j] = 0;
      ObjSet( "obj_superpuzzle_1_mg_5_clk_"..i.."_"..j, { input = true });
      ObjSet( "spr_superpuzzle_1_mg_5_clk_"..i.."_"..j.."_light", { alp = 0 });
      
    end;
  end;
  
end;
--*********************************************************************************************************************
function private.block_5_reset_set()
  
  private.block_5.reset = false;
  private.block_5.win = false;
  private.block_5.used = 1;
  private.block_5_rec_mas = {};
  private.block_5.pressed = { { 0, 0, 0, 0, 0 },
                             { 0, 0, 0, 0, 0 },
                             { 0, 0, 0, 0, 0 },
                             { 0, 0, 0, 0, 0 } };
                             
  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].block_5 = private.block_5;
  
  private.block_5_reset();
  private.init_block_5( true );
  
  local table_multiset = {};
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_5", { input = false, alp = 0 } } );
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_5_hint", { alp = 0 } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_5_hint_1", { alp = 1 } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_5_light", { alp = 0 } } );
  table.insert( table_multiset, { "anm_superpuzzle_1_mg_5", { alp = 1, frame = 0 } } );
  ObjMultiSet( table_multiset );
 
end;
--*********************************************************************************************************************
function public.SkipPuzzle5()

  local func_after = function ()

    common_impl.Lock( false );
    private.block_5_win_anim();

    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].puzzletimer = 1;
    interface.PuzzleHelpReload( 1 );
    interface.PuzzleHelpHide();
      
    ObjSet( "tmr_superpuzzle_1_skip", { playing = false } );

  end;

  common_impl.Lock( true );
  
  if ( private.block_5.used == 1 ) then
    
    for i = 1,4 do
    
      for j = 1,5 do
        
        if private.block_5.start_1[i][j] ~= 0 then
         
          ObjAnimate( "spr_superpuzzle_1_mg_5_clk_"..i.."_"..j.."_light", "alp", 0, 0, "", 
          { 
            0.0,0,0,  
            0.3,0,1
          });
      
        end;
        
      end;
    
    end;
  
  elseif( private.block_5.used == 2 )then 
  
    for i = 1,4 do
    
      for j = 1,5 do
        
        if private.block_5.start_2[i][j] ~= 0 then
         
          ObjAnimate( "spr_superpuzzle_1_mg_5_clk_"..i.."_"..j.."_light", "alp", 0, 0, "", 
          { 
            0.0,0,0,  
            0.3,0,1
          });
      
        end;
        
      end;
    
    end;
    
  elseif( private.block_5.used == 3 )then 
  
    for i = 1,4 do
    
      for j = 1,5 do
        
        if private.block_5.start_3[i][j] ~= 0 then
         
          ObjAnimate( "spr_superpuzzle_1_mg_5_clk_"..i.."_"..j.."_light", "alp", 0, 0, "", 
          { 
            0.0,0,0,  
            0.3,0,1
          });
      
        end;
        
      end;
    
    end; 
    
  end;
  
  ObjSet( "tmr_superpuzzle_1_skip", { playing = true, time = 0.4, endtrig = func_after } );  

end;
--*********************************************************************************************************************
--function *** Mmg Match3 *** ()
--*********************************************************************************************************************
function private.Match3Init()
  
  private.match3 = {};

  private.match3.win_1 = false;
  private.match3.win_2 = false;
  private.match3.current_key = 0;
  private.match3.key_done = false; 
  private.match3.points = 40;
  
  private.match3_cell_x = 8;
  private.match3_cell_y = 6;
  
  private.match3_first_note = nil;

  private.match3_toremove = {};
  private.match3_field    = {};
  private.match3_weidth   = {};

  private.delta_pos_y = 80;
  private.delta_pos_x = 80;
  private.start_pos_x = -280;
  private.start_pos_y = -200;

  private.note_pos = { {}, {} };
  for j = 1, private.match3_cell_y do

    private.note_pos[ 2 ][ j ] = private.start_pos_y + ( j - 1 ) * private.delta_pos_y;

  end;
  for j = 1, private.match3_cell_x do

    private.note_pos[ 1 ][ j ] = private.start_pos_x + ( j - 1 ) * private.delta_pos_x;

  end;

  for i = 1, private.match3_cell_y do

    private.match3_field[ i ]  = { 0, 0, 0, 0, 0, 0, 0, 0 };
    private.match3_weidth[ i ] = { 0, 0, 0, 0, 0, 0, 0, 0 };

  end;

  private.Match3ProgressBarSet();
  
end;
--*********************************************************************************************************************
function private.Match3Load ()
  
  for i = 1, private.match3_cell_y do

    for j = 1, private.match3_cell_x do

      ObjCreate( "obj_superpuzzle_1_mg_6_note_"..i.."_"..j, "obj" );
      ObjCreate( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j, "spr" );
      ObjCreate( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_back_light", "spr" );
      ObjCreate( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_light", "spr" );
      ObjCreate( "spr_superpuzzle_1_mg_6_light_cell_"..i.."_"..j, "spr" );
      ObjCreate( "spr_superpuzzle_1_mg_6_note_flash_"..i.."_"..j, "spr" );
      
      ObjAttach( "obj_superpuzzle_1_mg_6_note_"..i.."_"..j, "obj_superpuzzle_1_mg_6_notes" );
      ObjAttach( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_back_light", "obj_superpuzzle_1_mg_6_note_"..i.."_"..j );
      ObjAttach( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_light", "obj_superpuzzle_1_mg_6_note_"..i.."_"..j );
      ObjAttach( "spr_superpuzzle_1_mg_6_light_cell_"..i.."_"..j, "obj_superpuzzle_1_mg_6_note_"..i.."_"..j );
      ObjAttach( "spr_superpuzzle_1_mg_6_note_flash_"..i.."_"..j, "obj_superpuzzle_1_mg_6_note_"..i.."_"..j );
      ObjAttach( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j, "obj_superpuzzle_1_mg_6_note_"..i.."_"..j );

      local type = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j ];

      private.match3_field[ i ][ j ] = type;

      ObjSet( "obj_superpuzzle_1_mg_6_note_"..i.."_"..j,
      {
        pos_x = private.start_pos_x + ( j - 1 ) * private.delta_pos_x,
        pos_y = private.start_pos_y + ( i - 1 ) * private.delta_pos_x,
        input   = true,
        active  = true,
        visible = true,
        event_mdown  = function () private.Match3ClickNote( "obj_superpuzzle_1_mg_6_note_"..i.."_"..j ) end,
        event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
        event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end,
        inputrect_init = true,
        inputrect_x = -30,
        inputrect_y = -30,
        inputrect_w =  60,
        inputrect_h =  60,
      } );

      ObjSet( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j,
      {
        input = false,
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/note_"..type
      } );
      
      --под нотой
      ObjSet( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_back_light",
      {
        input = false,
        pos_z = -1,
        blendmode = 2,
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/backlight_"..type
      } );
      
      --над нотой
      ObjSet( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_light",
      {
        input = false,
        pos_z = 1,
        alp = 0,
        blendmode = 2,
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/light_"..type
      } );
      
      --вспышка
      ObjSet( "spr_superpuzzle_1_mg_6_note_flash_"..i.."_"..j,
      {
        input = false,
        alp = 0,
        scale_x = 0.5,
        pos_z = 2,
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/note_flash"
      } );
      
      -- выделенный ключ
      ObjSet( "spr_superpuzzle_1_mg_6_light_cell_"..i.."_"..j,
      {
        input = false,
        alp = 0,
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/box"
      } );
      
      if ( type == "key" and private.match3.win_1 ) then
        
        ObjSet( "spr_superpuzzle_1_mg_6_light_cell_"..i.."_"..j, { alp = 1 } );
        
      end;
      
    end;

  end;

  if ( not private.match3.win_1 ) then
    
    private.Match3ProgressBarSet();
    
  elseif( private.match3.win_1 and not private.match3.win_2 )then
    
    private.match3.key_done = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.key_done;

    if ( ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.key_done ) then

      ObjSet( "obj_superpuzzle_1_mg_6_key_1", { alp = 1 } );

    end;
    
  end;
  
end;
--*********************************************************************************************************************
------------------------------------------------------------
function private.Match3GenerateFieldSave ()
  
    for i = 1, private.match3_cell_y do

    for j = 1, private.match3_cell_x do

      local type = private.Match3GetRandomNote();

      ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j ] = type;

      if ( not ObjGet( "obj_superpuzzle_1_mg_6_note_"..i.."_"..j ) ) then
        
        ObjCreate( "obj_superpuzzle_1_mg_6_note_"..i.."_"..j, "obj" );
        ObjCreate( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j, "spr" );
        ObjCreate( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_back_light", "spr" );
        ObjCreate( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_light", "spr" );
        ObjCreate( "spr_superpuzzle_1_mg_6_light_cell_"..i.."_"..j, "spr" );
        ObjCreate( "spr_superpuzzle_1_mg_6_note_flash_"..i.."_"..j, "spr" );

        ObjAttach( "obj_superpuzzle_1_mg_6_note_"..i.."_"..j, "obj_superpuzzle_1_mg_6_notes" );
        ObjAttach( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_back_light", "obj_superpuzzle_1_mg_6_note_"..i.."_"..j );
        ObjAttach( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_light", "obj_superpuzzle_1_mg_6_note_"..i.."_"..j );
        ObjAttach( "spr_superpuzzle_1_mg_6_light_cell_"..i.."_"..j, "obj_superpuzzle_1_mg_6_note_"..i.."_"..j );
        ObjAttach( "spr_superpuzzle_1_mg_6_note_flash_"..i.."_"..j, "obj_superpuzzle_1_mg_6_note_"..i.."_"..j );
        ObjAttach( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j, "obj_superpuzzle_1_mg_6_note_"..i.."_"..j );
       
      end;

    end;

  end;
  
  for i = 1, private.match3_cell_y do

    for j = 1,private.match3_cell_x do

      local type = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j ];

      ObjSet( "obj_superpuzzle_1_mg_6_note_"..i.."_"..j,
      {
        pos_x = private.start_pos_x + ( j - 1 ) * private.delta_pos_x,
        pos_y = private.start_pos_y + ( i - 1 ) * private.delta_pos_x,
        input   = true,
        active  = true,
        visible = true,
        event_mdown  = function () private.Match3ClickNote( "obj_superpuzzle_1_mg_6_note_"..i.."_"..j ) end,
        event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
        event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end,
        inputrect_init = true,
        inputrect_x = -30,
        inputrect_y = -30,
        inputrect_w =  60,
        inputrect_h =  60,
      } );

      ObjSet( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j,
      {
        input = false,
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/note_"..type,
        pos_z = 1
      } );

      ObjSet( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_back_light",
      {
        input = false,
        pos_z = -1,
        blendmode = 2,
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/backlight_"..type
      } );
      
      ObjSet( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_light",
      {
        input = false,
        alp = 0,
        pos_z = 1,
        blendmode = 2,
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/light_"..type
      } );
      
      ObjSet( "spr_superpuzzle_1_mg_6_light_cell_"..i.."_"..j,
      {
        input = false,
        alp = 0,
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/box"
      } );
      
      if ( type == "key" and private.match3.win_1 ) then
        
        ObjSet( "spr_superpuzzle_1_mg_6_light_cell_"..i.."_"..j, { alp = 1 } );
        
      end;

      ObjSet( "spr_superpuzzle_1_mg_6_note_flash_"..i.."_"..j,
      {
        input = false,
        alp = 0,
        scale_x = 0.5,
        pos_z = 2,
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/note_flash"
      } );

    end;

  end;
  
end;
--*********************************************************************************************************************
------------------------------------------------------------
function private.Match3GenerateField ( is_first )
    
  local is_done = false;

  for i = 1, private.match3_cell_y do

    for j = 1, private.match3_cell_x do

      local type = private.Match3GetRandomNote();

      ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j ] = type;

      if ( not ObjGet( "obj_superpuzzle_1_mg_6_note_"..i.."_"..j ) ) then
        
        ObjCreate( "obj_superpuzzle_1_mg_6_note_"..i.."_"..j, "obj" );
        ObjCreate( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j, "spr" );
        ObjCreate( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_back_light", "spr" );
        ObjCreate( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_light", "spr" );
        ObjCreate( "spr_superpuzzle_1_mg_6_light_cell_"..i.."_"..j, "spr" );
        ObjCreate( "spr_superpuzzle_1_mg_6_note_flash_"..i.."_"..j, "spr" );

        ObjAttach( "obj_superpuzzle_1_mg_6_note_"..i.."_"..j, "obj_superpuzzle_1_mg_6_notes" );
        ObjAttach( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_back_light", "obj_superpuzzle_1_mg_6_note_"..i.."_"..j );
        ObjAttach( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_light", "obj_superpuzzle_1_mg_6_note_"..i.."_"..j );
        ObjAttach( "spr_superpuzzle_1_mg_6_light_cell_"..i.."_"..j, "obj_superpuzzle_1_mg_6_note_"..i.."_"..j );
        ObjAttach( "spr_superpuzzle_1_mg_6_note_flash_"..i.."_"..j, "obj_superpuzzle_1_mg_6_note_"..i.."_"..j );
        ObjAttach( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j, "obj_superpuzzle_1_mg_6_note_"..i.."_"..j );
       
      end;

    end;

  end;

  if ( private.match3.win_1 and not private.match3.win_2 ) then
  
    local key_pos = {};
    
    key_pos = { 1, math.random( 1, 8 ) };

    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ key_pos[ 1 ] ][ key_pos[ 2 ] ] = "key";
    
  end;

  while ( not is_done ) do

    is_done = private.Match3ShuffleField();

  end;

  for i = 1, private.match3_cell_y do

    for j = 1,private.match3_cell_x do

      local type = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j ];

      ObjSet( "obj_superpuzzle_1_mg_6_note_"..i.."_"..j,
      {
        pos_x = private.start_pos_x + ( j - 1 ) * private.delta_pos_x,
        pos_y = private.start_pos_y + ( i - 1 ) * private.delta_pos_x,
        input   = true,
        active  = true,
        visible = true,
        event_mdown  = function () private.Match3ClickNote( "obj_superpuzzle_1_mg_6_note_"..i.."_"..j ) end,
        event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
        event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end,
        inputrect_init = true,
        inputrect_x = -30,
        inputrect_y = -30,
        inputrect_w =  60,
        inputrect_h =  60,
      } );

      ObjSet( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j,
      {
        input = false,
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/note_"..type,
        pos_z = 1
      } );

      ObjSet( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_back_light",
      {
        input = false,
        pos_z = -1,
        blendmode = 2,
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/backlight_"..type
      } );
      
      ObjSet( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_light",
      {
        input = false,
        alp = 0,
        pos_z = 1,
        blendmode = 2,
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/light_"..type
      } );
      
      ObjSet( "spr_superpuzzle_1_mg_6_light_cell_"..i.."_"..j,
      {
        input = false,
        alp = 0,
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/box"
      } );
      
      if ( type == "key" and private.match3.win_1 ) then
        
        ObjSet( "spr_superpuzzle_1_mg_6_light_cell_"..i.."_"..j, { alp = 1 } );
        
      end;

      ObjSet( "spr_superpuzzle_1_mg_6_note_flash_"..i.."_"..j,
      {
        input = false,
        alp = 0,
        scale_x = 0.5,
        pos_z = 2,
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/note_flash"
      } );

    end;

  end;

end;
------------------------------------------------------------
function private.Match3ShuffleField ()

  local is_done = true;

  for i = 1, private.match3_cell_y do

    for j = 1, ( private.match3_cell_x - 2 ) do

      if ( ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j ] == ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j + 1 ] ) and
         ( ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j ] == ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j + 2 ] ) then

         ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j + 1 ] = private.Match3GetRandomNote();

        is_done = false;

      end;

    end;

  end;

  for i = 1, ( private.match3_cell_y - 2 ) do

    for j = 1, private.match3_cell_x do

      if ( ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j ] == ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i + 1 ][ j ] ) and
         ( ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j ] == ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i + 2 ][ j ] ) then

         ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i + 1 ][ j ] = private.Match3GetRandomNote();

        is_done = false;

      end;

    end;

  end;

  for i = 1, private.match3_cell_y do

    for j = 1, private.match3_cell_x do

      private.match3_field[ i ][ j ] = ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j ];

    end;

  end;

  return is_done;

end;
------------------------------------------------------------
function private.Match3GetRandomNote ()

  local type = math.random( 1, 100 );

  if     ( type > 0  and type < 21 ) then type = 2;
  elseif ( type > 21 and type < 41 ) then type = 3;
  elseif ( type > 41 and type < 61 ) then type = 4;
  elseif ( type > 61 and type < 81 ) then type = 5;
  else                                    type = 1;
  end;

  return type;
  
end;
------------------------------------------------------------
function private.Match3ClickNote ( note )

  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_match3_select", 0, "", 0 ); 
    
  if ( not private.match3_first_note ) then

    private.match3_first_note = note;

    local pos = ObjGet( note );

    ObjSet( "spr"..string.sub( private.match3_first_note, 4, 27 ).."_"..string.sub( private.match3_first_note, -3 ).."_light",{ alp = 1 } );

  else

    ObjSet( "spr"..string.sub( private.match3_first_note, 4, 27 ).."_"..string.sub( private.match3_first_note, -3 ).."_light", { alp = 0 } );

    if ( private.match3_first_note == note ) then

      private.match3_first_note = nil;

      return;

    end;

    private.match3_second_note = note;

    local old_x = ObjGet( private.match3_first_note ).pos_x;
    local old_y = ObjGet( private.match3_first_note ).pos_y;
    local new_x = ObjGet( note ).pos_x;
    local new_y = ObjGet( note ).pos_y;

    local old_i_x = 0;
    local old_i_y = 0;
    local new_i_x = 0;
    local new_i_y = 0;

    for i = 1, private.match3_cell_x do

      if ( old_x == private.note_pos[ 1 ][ i ] ) then

        old_i_y = i;

      end;

      if ( new_x == private.note_pos[ 1 ][ i ] ) then

        new_i_y = i;

      end;

    end;

    for i = 1, private.match3_cell_y do

      if ( old_y == private.note_pos[ 2 ][ i ] ) then

        old_i_x = i;

      end;

      if ( new_y == private.note_pos[ 2 ][ i ] ) then

        new_i_x = i;

      end;

    end;

    if ( old_i_x == new_i_x ) and ( math.abs( old_i_y - new_i_y ) == 1 ) or
       ( old_i_y == new_i_y ) and ( math.abs( old_i_x - new_i_x ) == 1 ) then

       private.Match3SwapNotes( new_x, new_y, old_x, old_y );

      local temp = private.match3_field[ old_i_x ][ old_i_y ];

      private.match3_field[ old_i_x ][ old_i_y ] = private.match3_field[ new_i_x ][ new_i_y ];
      private.match3_field[ new_i_x ][ new_i_y ] = temp;

      if ( private.Match3Checking() ) then

        ObjSet( "tmr_superpuzzle_1_mg_6_exchange", 
        {
          time = 0.201, 
          playing = true,
          endtrig = function ()

            private.Match3SetFieldState();

            private.Match3Disappearance();

          end;
        } );

      else

        local temp = private.match3_field[ old_i_x ][ old_i_y ];

        private.match3_field[ old_i_x ][ old_i_y ] = private.match3_field[ new_i_x ][ new_i_y ];
        private.match3_field[ new_i_x ][ new_i_y ] = temp; 

        ObjSet( "tmr_superpuzzle_1_mg_6_exchange", 
        {
          time = 0.201, 
          playing = true,
          endtrig = function ()

          private.Match3SwapNotes( old_x, old_y, new_x, new_y, true );

          end;
        } );


      end;

      private.match3_firstclk = nil;

    else

      private.match3_first_note = note;

      local pos = ObjGet( note );

      ObjSet("spr"..string.sub( private.match3_first_note, 4, 27 ).."_"..string.sub( private.match3_first_note, -3 ).."_light", { alp = 1 } );

    end;

  end;

end;
------------------------------------------------------------
function private.Match3SwapNotes ( new_x, new_y, old_x, old_y, is_back )

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_match3_move", 0, "", 0 ); 
  ObjAnimate( private.match3_second_note, "pos_xy", 0, 0,
  function ()

    if ( is_back ) then

      private.match3_first_note = nil;

      common_impl.Lock( false );

    end;

  end,
  {
    0.0, 0, new_x, new_y,
    0.2, 0, old_x, old_y
  } );

  ObjAnimate( private.match3_first_note, "pos_xy", 0, 0, "",
  {
    0.0, 0, old_x, old_y,
    0.2, 0, new_x, new_y
  } );

end;
------------------------------------------------------------
function private.Match3Checking ()

  for i = 1, private.match3_cell_y do

    for j = 1, ( private.match3_cell_x - 2 ) do

      if ( private.match3_field[ i ][ j ] == private.match3_field[ i ][ j + 1 ] ) and
         ( private.match3_field[ i ][ j ] == private.match3_field[ i ][ j + 2 ] ) and
         ( private.match3_field[ i ][ j ] ~= "key" ) then

        if ( private.Match3AddToQueue( i, j ) )     then private.match3_toremove[ #private.match3_toremove + 1 ] = { i, j,     0 }; end;
        if ( private.Match3AddToQueue( i, j + 1 ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { i, j + 1, 0 }; end;
        if ( private.Match3AddToQueue( i, j + 2 ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { i, j + 2, 0 }; end;

      end;

    end;

  end;

  for i = 1, ( private.match3_cell_y - 2 ) do

    for j = 1, private.match3_cell_x do

      if ( private.match3_field[ i ][ j ] == private.match3_field[ i + 1 ][ j ] ) and
         ( private.match3_field[ i ][ j ] == private.match3_field[ i + 2 ][ j ] )  and
         ( private.match3_field[ i ][ j ] ~= "key" ) then

        if ( private.Match3AddToQueue( i, j ) )     then private.match3_toremove[ #private.match3_toremove + 1 ] = { i,     j, math.pi / 2 }; end;
        if ( private.Match3AddToQueue( i + 1, j ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { i + 1, j, math.pi / 2 }; end;
        if ( private.Match3AddToQueue( i + 2, j ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { i + 2, j, math.pi / 2 }; end;

      end;

    end;

  end;
  
  local audio = false;
  
  if ( not private.match3.win_1 ) then
  
    for i = 1, ( #private.match3_toremove ) do
      
      if private.match3_field[ private.match3_toremove[ i ][ 1 ] ][ private.match3_toremove[ i ][ 2 ] ] == 4 then
        
        private.match3.points = private.match3.points - 1;
        ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.points = private.match3.points;
        
        if( not audio )then
          
          audio = true;
          common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_match3_remain", 0, "", 0 );
          
        end;
        
      end;
      
    end;
    
    private.Match3ProgressBarSet();
  
  elseif ( private.match3.win_1 and not private.match3.win_2 ) then
  
    for i = private.match3_cell_x, 1, -1 do

      for j = private.match3_cell_y, private.match3_cell_y, -1 do

        if ( private.match3_field[ j ][ i ] == "key" ) then

          if ( not private.match3.key_done ) then
            
            private.match3.key_done = true;
            
          end;
          
          if ( private.Match3AddToQueue( j, i ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { j, i, 0 }; end;
          private.Match3FallKey( j, i );

        end;

      end;

    end;
    
  end;
  
  if ( #private.match3_toremove == 0 ) then

    return false;

  end;

  return true;

end;
------------------------------------------------------------
function private.Match3AddToQueue ( pos_x, pos_y )

  for i = 1, #private.match3_toremove do

    if ( private.match3_toremove[ i ][ 1 ] == pos_x ) and
       ( private.match3_toremove[ i ][ 2 ] == pos_y ) then

      return false;

    end;

  end;

  return true;

end;
------------------------------------------------------------
function private.Match3SetFieldState ()

  for i = 1, private.match3_cell_y do

    for j = 1, private.match3_cell_x do

      local type = private.match3_field[ i ][ j ];

      ObjSet( "obj_superpuzzle_1_mg_6_note_"..i.."_"..j,
      {
        pos_x = private.note_pos[ 1 ][ j ],
        pos_y = private.note_pos[ 2 ][ i ],
      } );

      ObjSet( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j,
      {
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/note_"..type,
      } );
      
      ObjSet( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_back_light",
      {
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/backlight_"..type,
      } );
     
      ObjSet( "spr_superpuzzle_1_mg_6_note_"..i.."_"..j.."_light",
      {
        res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/light_"..type,
      } ); 

      if ( type == "key" and private.match3.win_1 ) then
        
        ObjSet( "spr_superpuzzle_1_mg_6_light_cell_"..i.."_"..j, { alp = 1 } );
        
      else
        
        ObjSet( "spr_superpuzzle_1_mg_6_light_cell_"..i.."_"..j, { alp = 0 } );
        
      end;
      
    end;

  end;

end;
------------------------------------------------------------
-- delete
------------------------------------------------------------
function private.Match3Disappearance ()

  common_impl.Lock( true );

  if ( #private.match3_toremove ~= 0 ) then
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_match3_hide", 0, "", 0 );
    
    for i = 1, ( #private.match3_toremove ) do
      
      local x = private.match3_toremove[ i ][ 1 ];
      local y = private.match3_toremove[ i ][ 2 ];
      local a = private.match3_toremove[ i ][ 3 ];

      ObjAnimate( "spr_superpuzzle_1_mg_6_note_"..x.."_"..y, "alp", 0, 0, "",
      {
        0.0, 0, 1,
        0.3, 0, 0
      } );
      
      ObjAnimate( "spr_superpuzzle_1_mg_6_note_"..x.."_"..y.."_back_light", "alp", 0, 0, "",
      {
        0.0, 0, 1,
        0.3, 0, 0
      } );

      ObjSet("spr_superpuzzle_1_mg_6_note_flash_"..x.."_"..y, { ang = a });
      ObjAnimate( "spr_superpuzzle_1_mg_6_note_flash_"..x.."_"..y, "alp", 0, 0, "",
      {
        0.00, 0, 0,
        0.15, 0, 1,
        0.30, 0, 0
      } );

      private.match3_field[ private.match3_toremove[ i ][ 1 ] ][ private.match3_toremove[ i ][ 2 ] ] = 0;

    end;
    
    ObjSet( "tmr_superpuzzle_1_mg_6_remove", 
    {
      time = 0.301, 
      playing = true,
      endtrig = function ()
      
      private.Match3FallNotes();

      end;
    } );

  end;

end;
------------------------------------------------------------
function private.Match3FallNotes ()

  for j = private.match3_cell_x, 1, -1 do

    for i = private.match3_cell_y, 1, -1 do

      if ( private.match3_field[ i ][ j ] == 0 ) then

        local index = i;

        while ( index > 0 ) do

          if ( private.match3_field[ index ][ j ] ~= 0 ) then

            private.match3_weidth[ index ][ j ] = private.match3_weidth[ index ][ j ] + 1;

          else

            private.match3_weidth[ index ][ j ] = private.match3_weidth[ index ][ j ] - 1;

          end;

          index = index - 1;

        end;

      end;

    end;

  end;

  for j = private.match3_cell_x, 1, -1 do

    local count = 0;

    for i = private.match3_cell_y, 1, -1 do

      local pos = private.match3_weidth[ i ][ j ];

      if ( pos < 0 ) then

        local note = "obj_superpuzzle_1_mg_6_note_"..i.."_"..j;

        ObjSet( note, { pos_y = ( 80 * pos - private.delta_pos_y ) } );

      end;

    end;

  end;
  local audio = false;
  for i = private.match3_cell_y, 1, -1 do

    for j = private.match3_cell_x, 1, -1 do

      if ( private.match3_weidth[ i ][ j ] > 0 ) then

        local note = "obj_superpuzzle_1_mg_6_note_"..i.."_"..j;

        local pos_start = private.note_pos[ 2 ][ i ];
        local pos_end   = pos_start + 80 * private.match3_weidth[ i ][ j ];

        local func_audio = function()
        
          if ( not audio ) then
            
            audio = true;
            common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_match3_fall", 0, "", 0 ); 
            
          end;
          
        end;
        ObjAnimate( note, "pos_y", 0, 0, func_audio,
        {
          0.0, 1, pos_start,
          0.3, 1, pos_end
        } );

        private.match3_field[ i + private.match3_weidth[ i ][ j ] ][ j ] = private.match3_field[ i ][ j ];
        private.match3_field[ i ][ j ] = 0;

      end;

    end;

  end;

  for i = 1, private.match3_cell_y do

    for j = 1, private.match3_cell_x do

      if ( private.match3_field[ i ][ j ] == 0 ) then

        private.match3_field[ i ][ j ] = private.Match3GetRandomNote();

        local x = 0;
        local y = 0;

        local loop = true;

        for i = 1, private.match3_cell_y do

          if ( loop ) then

            for j = 1, private.match3_cell_x do

              if ( private.match3_weidth[ i ][ j ] < 0 ) then

                x = i;
                y = j;

                private.match3_weidth[ i ][ j ] = 0;

                loop = false;

                break;

              end;

            end;

          end;

        end;

        local note = "obj_superpuzzle_1_mg_6_note_"..x.."_"..y;

        local pos_y = -300;

        ObjSet( "spr_superpuzzle_1_mg_6_note_"..x.."_"..y, { alp = 1, res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/note_"..private.match3_field[ i ][ j ], } );
        ObjSet( "spr_superpuzzle_1_mg_6_note_"..x.."_"..y.."_back_light", { alp = 1, res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/backlight_"..private.match3_field[ i ][ j ], } );
        ObjSet( "spr_superpuzzle_1_mg_6_note_"..x.."_"..y.."_light", { res = "assets/levels/level1/mg_superpuzzle_1/layers/mmg_6/light_"..private.match3_field[ i ][ j ], } );
        ObjAnimate( note, "pos_y", 0, 0, "",
        {
          0.00, 1, pos_y, 
          0.30, 1, private.note_pos[ 2 ][ i ],
        } );

      end;

    end;

  end;

  private.match3_toremove = {};
  private.match3_grain = {};

  for i = 1, private.match3_cell_y do 

    private.match3_weidth[ i ] = { 0, 0, 0, 0, 0, 0, 0, 0 };

  end;

  ObjSet( "tmr_superpuzzle_1_mg_6_fall", 
  {
    time = 0.301, 
    playing = true,
    endtrig = function ()

      private.Match3SetFieldState();

      local is_delete_notes = private.Match3Checking();

      if ( is_delete_notes ) then

        private.Match3Disappearance();

      else 

        private.Match3FallNotesEnd();

      end;

    end;
  } );

end;
------------------------------------------------------------
function private.Match3FallNotesEnd ()

  common_impl.Lock( false );

  private.match3_first_note = nil;

  if ( not private.match3.win_1 ) then
    

    local flag = true;

    if ( private.match3.points > 0 ) then
      
      flag = false;

    end;

    if ( flag ) then

      private.Match3WinAnim_1();

    else

      for i = 1, private.match3_cell_y do

        for j = 1, private.match3_cell_x do

          ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j ] = private.match3_field[ i ][ j ];

        end;

      end;

    end;
  
  elseif( private.match3.win_1 and not private.match3.win_2 )then
    
      local flag = true;

      if ( not private.match3.key_done ) then

        flag = false;

      end;

      if ( flag ) then

        private.Match3WinAnim_2();

      else

        for i = 1, private.match3_cell_y do

          for j = 1, private.match3_cell_x do

            ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j ] = private.match3_field[ i ][ j ];

          end;

        end;

        ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.key_done = private.match3.key_done;

      end;
    
  end;

end;
------------------------------------------------------------
function private.Match3ProgressBarSet()

  local obj_name = "txt_superpuzzle_1_mg_6_number";
  local value    = private.match3.points;
  local min      = 0;

  if ( value > 0 ) then
    ObjSet( obj_name, { text = value } );
  else 
    ObjSet( obj_name, { text = min } );
  end;
 
end;
------------------------------------------------------------
function private.Match3FallKey ( line, id )

  local func_continue = function ()

    ObjSet( "spr_superpuzzle_1_mg_6_key_"..id, { alp = 1 } );
    private.match3.current_key = id;
    
  end;
  
  ObjAnimate( "spr_superpuzzle_1_mg_6_key_"..id, "pos_y", 0, 0, func_continue,
  {
    0.0, 1, private.start_pos_y + ( line - 3 ) * private.delta_pos_x, 
    0.3, 1, 0
  } );

end;
--*********************************************************************************************************************
function private.Match3ResetSet()
  
  private.Match3Init()
  
  local table_multiset = {};
    
  for i = 1, private.match3_cell_y do

    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ] = {};
    for j = 1, private.match3_cell_x do

      table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_key_"..j, { input = false, alp = 0 } } );
      ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j ] = 0;

    end;

  end;
  
  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.win_1 =  private.match3.win_1;
  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.win_1 =  private.match3.win_1;
  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.current_key =  private.match3.current_key;
  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.points =  private.match3.points;
  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.key_done =  private.match3.key_done;

  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].note_1 = false;
  ng_global.progress[ "std" ][ "win_superpuzzle_1" ].note_2 = false;
  
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_6_crop", { input = true } } );
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_6_use_note_1",    { input = false } } );
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_6_use_note_2",    { input = false } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_small_note_1",    { alp = 0, input = false } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_big_note_1", { alp = 0 } } ); 
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_6_bottom", { alp = 0 } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_bottom_open", { pos_y = 215 } } ); 
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_right_open_1", { pos_x = 392, input = false } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_left_open_1", { pos_x = -461, input = false } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_left_open_2", { pos_x = -315, input = false } } );
  
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_6", { input = false, pos_y = -320 } } );
  
  ObjMultiSet( table_multiset );  
  
  private.Match3GenerateField( true ); 
  
end;
--*********************************************************************************************************************
function private.Match3WinAnim_1()

  common_impl.Lock( true );

  local func_end = function ()

    common_impl.Lock( false );
    private.match3.win_1 = true;
    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.win_1 = true;
    ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( private.room_objname ) ].puzzle_num = 7;
    private.Match3WinSet_1();
  
  end; 

  ObjAnimate( "txt_superpuzzle_1_mg_6_number", "alp", 0, 0, "", 
  { 
    0.0, 0, 1,    
    0.3, 0, 0 
  } ); 
  
  ObjAnimate( "spr_superpuzzle_1_mg_6_small_note_1", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 0,    
    0.3, 0, 1 
  } );  
  
end;
--*********************************************************************************************************************
function private.Match3WinAnim_2()
  
 common_impl.Lock( true );

  local func_end = function ()

    common_impl.Lock( false );

    private.match3.win_2 = true;
    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3.win_2 = true;
    ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( private.room_objname ) ].puzzle_num = 9;
    private.Match3WinSet_2();

  end;  

  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_match3_win", 0, "", 0 ); 
  ObjAnimate( "spr_superpuzzle_1_mg_6_left_open_2", "pos_x", 0, 0, func_end, 
  { 
    0.0, 0, -315,    
    0.5, 0, -436 
  } ); 

end;  
--*********************************************************************************************************************
function private.Match3WinSet_1()

  
  local table_multiset = {};
  
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_small_note_1",    { alp = 1, input = true } } );
  table.insert( table_multiset, { "txt_superpuzzle_1_mg_6_number",          { alp = 0 } } );
  
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_6_crop", { input = false } } ); 
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_6_use_note_1", { input = true } } );  

  ObjMultiSet( table_multiset );
    
end;
--*********************************************************************************************************************
function private.Match3WinSet_2()
  
  local table_multiset = {};
  
  if ( private.match3.current_key ~= 0 ) then
    table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_key_"..private.match3.current_key,    { pos_y = 0, input = true, alp = 1 } } );
  else 
    table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_key_1",    { pos_y = 0, input = true, alp = 1 } } );
  end;
  

  table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_left_open_2",    { pos_x = -436 } } );
  
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_6_crop", { input = false } } ); 
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_6_use_note_2", { input = true } } );  

  
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_big_note_1", { alp = 1 } } ); 
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_6_bottom", { alp = 1 } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_bottom_open", { pos_y = 310 } } ); 
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_right_open_1", { pos_x = 285, input = false } } );
  
  ObjMultiSet( table_multiset );

end;
--*********************************************************************************************************************
function public.SkipPuzzle6()

  local func_after = function ()

    common_impl.Lock( false );
    private.Match3WinAnim_1();

    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].puzzletimer = 1;
    interface.PuzzleHelpReload( 1 );
    interface.PuzzleHelpHide();

  end;

  common_impl.Lock( true );
  
  func_after();

end;
--*********************************************************************************************************************
function public.SkipPuzzle7()

  local func_after = function ()

    common_impl.Lock( false );
    private.WinDropNote_1_Anim();

    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].puzzletimer = 1;
    interface.PuzzleHelpReload( 1 );
    interface.PuzzleHelpHide();

  end;

  common_impl.Lock( true );
  
  func_after();

end;
--*********************************************************************************************************************
function public.SkipPuzzle8()

  local func_after = function ()

    common_impl.Lock( false );
    private.Match3WinAnim_2();

    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].puzzletimer = 1;
    interface.PuzzleHelpReload( 1 );
    interface.PuzzleHelpHide();

  end;

  common_impl.Lock( true );
  
  func_after();

end;
--*********************************************************************************************************************
function public.SkipPuzzle9()

  local func_after = function ()

    common_impl.Lock( false );
    private.WinDropNote_2_Anim();

    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].puzzletimer = 1;
    interface.PuzzleHelpReload( 1 );
    interface.PuzzleHelpHide();

  end;

  common_impl.Lock( true );
  
  func_after();

end;
--*********************************************************************************************************************
function private.DragNote_1()

  ObjSet( "spr_superpuzzle_1_mg_6_small_note_1", { pos_z = 10 } );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_match3_take", 0, "", 0 ); 
  
end;
--*********************************************************************************************************************
function private.DropNote_1()
  
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_superpuzzle_1_mg_6_small_note_1", "obj_superpuzzle_1_mg_6_use_note_1" ) ) then

    private.WinDropNote_1_Anim();

  else

    ObjSet( "spr_superpuzzle_1_mg_6_small_note_1", { pos_z = 0 } );
        
  end;
  
end;
--*********************************************************************************************************************
function private.WinDropNote_1_Anim()
  
  local func_after = function()

    local func_end = function()
  
      common_impl.Lock( false );
      
      if ( private.match3.win_1 and not private.match3.win_2 ) then
        
        ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( private.room_objname ) ].puzzle_num = 8;
        ng_global.progress[ "std" ][ "win_superpuzzle_1" ].note_1 = true;
        private.WinDropNote_1();
        
      end;
    
    end;
  
    ObjAnimate( "obj_superpuzzle_1_mg_6_bottom", "alp", 0, 0, "", 
    { 
      0.0, 0, 0,    
      0.3, 0, 1 
    } );
    
    ObjAnimate( "spr_superpuzzle_1_mg_6_right_open_1", "pos_x", 0, 0, "", 
    { 
      0.0, 0, 392,    
      0.5, 0, 285
    } );
    
    ObjAnimate( "spr_superpuzzle_1_mg_6_bottom_open", "pos_y", 0, 0, func_end, 
    { 
      0.0, 0, 215,    
      0.5, 0, 310 
    } );
  
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_match3_use", 0, "", 0 ); 
  ObjSet( "spr_superpuzzle_1_mg_6_small_note_1", { alp = 0 } );
  ObjAnimate( "spr_superpuzzle_1_mg_6_big_note_1", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 0,    
    0.3, 0, 1 
  } ); 
  
end;
--*********************************************************************************************************************
function private.WinDropNote_1()
  
  for i = 1, private.match3_cell_y do

    ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ] = {};
    for j = 1, private.match3_cell_x do

      ng_global.progress[ "std" ][ "win_superpuzzle_1" ].match3_field[ i ][ j ] = 0;

    end;

  end;
      
  private.Match3GenerateField( true ); 
          
  local table_multiset = {};
  
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_6_crop", { input = true } } );
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_6_use_note_1",    { input = false } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_small_note_1",    { alp = 0, input = false } } );
  
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_big_note_1", { alp = 1 } } ); 
  table.insert( table_multiset, { "obj_superpuzzle_1_mg_6_bottom", { alp = 1 } } );
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_bottom_open", { pos_y = 310 } } ); 
  table.insert( table_multiset, { "spr_superpuzzle_1_mg_6_right_open_1", { pos_x = 285, input = false } } ); 

  ObjMultiSet( table_multiset );

end;
--*********************************************************************************************************************
function private.DragNote_2( number )

  ObjSet( "spr_superpuzzle_1_mg_6_key_"..number, { pos_z = 10 } );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_match3_take", 0, "", 0 );
  
end;
--*********************************************************************************************************************
function private.DropNote_2( number )
  
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_superpuzzle_1_mg_6_key_"..number, "obj_superpuzzle_1_mg_6_use_note_2" ) ) then

    private.WinDropNote_2_Anim(number);

  else

    ObjSet( "spr_superpuzzle_1_mg_6_key_"..number, { pos_z = 0 } );
        
  end;
  
end;
--*********************************************************************************************************************
function private.WinDropNote_2_Anim(number)
  
  local func_after = function()
    
    common_impl.Lock( false );

    if ( private.match3.win_2 ) then
      
      ng_global.progress[ "std" ][ "win_superpuzzle_1" ].note_2 = true;
      private.WinDropSet_2(number);
      
    end;
    
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_match3_use", 0, "", 0 ); 
  if ( number ) then
  
    ObjSet( "spr_superpuzzle_1_mg_6_key_"..number, { alp = 0 } );
    ObjAnimate( "spr_superpuzzle_1_mg_6_big_note_2", "alp", 0, 0, func_after, 
    { 
      0.0, 0, 0,    
      0.3, 0, 1 
    } ); 
    
  else 
    
    ObjSet( "spr_superpuzzle_1_mg_6_key_1", { alp = 0 } );
    ObjAnimate( "spr_superpuzzle_1_mg_6_big_note_2", "alp", 0, 0, func_after, 
    { 
      0.0, 0, 0,    
      0.3, 0, 1 
    } ); 
    
  end;

end;
--********************************************************************************************************************
function private.WinDropSet_2(number)
  
  private.Win();
  ObjSet( "spr_superpuzzle_1_mg_6_key_"..number, { alp = 0 } );
  ObjSet("spr_superpuzzle_1_mg_6_key_1", { alp = 0 });
  ObjSet("spr_superpuzzle_1_mg_6_big_note_2", { alp = 1 });
  
end;
--*********************************************************************************************************************
-- function *** Puszzle Hint ***() end
--*********************************************************************************************************************
  function private.PuszzleHintClk ()
  
    local postfix = ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( private.room_objname ) ].puzzle_num;

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_puzzle_hint", 0, "", 0 );
    interface.PuzzleHelpShow( "ifo_superpuzzle_1_"..postfix );
  
    ObjAnimate( "spr_superpuzzle_1_pazzle_help_1", "alp", 0, 0, "", { 0,3,1, 0.3,0,0, 0.6,0,1 } );
    ObjAnimate( "spr_superpuzzle_1_pazzle_help_2", "alp", 0, 0, func_end, { 0,3,0, 0.3,0,1, 0.6,0,0 } );

  end;
--*********************************************************************************************************************
  function private.PuszzleHintEnter ()

    common_impl.SetCursor( CURSOR_HAND );
    ObjSet( "spr_superpuzzle_1_hint_add", { alp = 1 } );

  end;
--*********************************************************************************************************************
  function private.PuszzleHintLeave ()

    common_impl.SetCursor( CURSOR_DEFAULT );
    ObjSet( "spr_superpuzzle_1_hint_add", { alp = 0 } );

  end;
--*********************************************************************************************************************

ObjAnimate( "spr_superpuzzle_1_mg_6_arrow_1", "pos_y", 1, 0, "", { 0,3,256, 0.3,0,253, 0.6,0,256 } );
ObjAnimate( "spr_superpuzzle_1_mg_6_arrow_2", "pos_y", 1, 0, "", { 0,3,256, 0.3,0,253, 0.6,0,256 } );
ObjAnimate( "spr_superpuzzle_1_mg_6_arrow_3", "pos_y", 1, 0, "", { 0,3,256, 0.3,0,253, 0.6,0,256 } );
ObjAnimate( "spr_superpuzzle_1_mg_6_arrow_4", "pos_y", 1, 0, "", { 0,3,256, 0.3,0,253, 0.6,0,256 } );
