-- name=mg_doorhos
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_doorhos";
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_doorhos = function ()

  local effects_table = 
  {
    "spr_doorhos_light_add"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_doorhos", update_performance_mode_doorhos, private.room_objname );
  ------------------------------------------------------------------------------------------
  private.position = {
                      {152, 152},
                      {259, 92 },
                      {364, 152},
                      {259, 212},
                      {154, 274},
                      {258, 335},
                      {363, 274},
                      {153, 395},
                      {257, 455},
                      {363, 394},
                      {155, 516},
                      {257, 580},
                      {364, 516},
                      {466, 332},
                      {469, 456},
                      {469, 576},
                      {364, 637},
                      {573, 269},
                      {573, 393},
                      {574, 513},
                      {678, 209},
                      {782, 151},
                      {886, 209},
                      {782, 269},
                      {676, 332},
                      {781, 391},
                      {887, 332},
                      {676, 453},
                      {781, 514},
                      {887, 451},
                      {677, 574},
                      {782, 637},
                      {887, 573}
                     };
                     
  private.delta_x = 60;
  private.delta_y = 60;  
  
  private.start =  { 5, 20, 3, 4, 8, 19, 11, 9, 1, 10, 27, 2, 7, 12, 6, 33, 17, 18, 21, 23, 31, 22, 32, 30, 16, 13, 29, 28, 14, 25, 26, 24, 15 };
  
 
  
  private.casual = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 33, 22, 24, 30, 29, 31, 32, 23, 25, 26, 27, 28 };
  --                  {8 , 6, 10, 13, 17, 16, 15, 19, 28, 31, 32, 33, 30, 27, 24, 21 },
  --                  {10, 1, 6 , 2 , 4 , 9 , 5 , 1 , 6 , 8 , 7 , 9 , 2 , 6 , 3 , 3  }
  --                 };
  --                 
  --private.other = { 1, 2, 3, 4, 5, 7, 9, 11, 12, 14, 18, 20, 22, 23, 25, 26, 29 };
  local table_multiset = {};

  for i = 1, 33 do

      table.insert( table_multiset, { "obj_doorhos_hard_"..i, { 
      event_mdown = function()  private.Element_hard_clk( i ) end; 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, 
      } } );

  end;
    
  for i = 1, 33 do

      table.insert( table_multiset, { "obj_doorhos_casual_"..i, { 
      event_mdown = function()  private.Element_casual_clk( i ) end; 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, 
      } } );

  end;  
    
  --for i = 1, 33  do
  --   
  --  ObjSet("obj_doorhos_hard_"..private.start[i], { pos_x = private.position[i][1] , pos_y = private.position[i][2] });
  --    
  --end;  
    
    
  ObjMultiSet(table_multiset);  
  ObjMultiSet({
      { "obj_doorhos_btn_clk", { event_mdown = private.clk_button }},
      { "obj_doorhos_mode_hard", { event_mdown = function() private.SetHard() end,
       event_menter = function() private.MouseEnterAnim( "spr_doorhos_mode_btn_hard" ) end, 
       event_mleave = function() private.MouseLeaveAnim( "spr_doorhos_mode_btn_hard" ) end; 
                                   } },
      { "obj_doorhos_mode_casual", { event_mdown = function() private.SetNormal() end;
       event_menter = function() private.MouseEnterAnim( "spr_doorhos_mode_btn_casual" ) end, 
       event_mleave = function() private.MouseLeaveAnim( "spr_doorhos_mode_btn_casual" ) end; 
                                     } },
  });  

    for i = 1, 33  do
     
      ObjSet( "obj_doorhos_hard_"..private.start[i], { pos_x = private.position[i][1], pos_y = private.position[i][2] });
      
      
    end;   
  --ObjMultiSet({ 
  --});
  --------------------------------------------------------------------------------------------
  -- function clk_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_button" ] = {
    type = "click",
    use_place = "obj_doorhos_btn_clk",
    room = private.room_objname
   
  };
  local clk_button_beg = function ()
  
    ObjDelete( "obj_doorhos_btn_clk" );
  
  end;
  
  local clk_button_end = function ()
  
    --ObjDelete("gmg_atbar_doorhos");
       --ObjDelete( "anm_auto_key_2");
   
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_button", clk_button_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button", clk_button_end, private.room_objname );
  cmn.AddSubscriber( "clk_button_beg", clk_button_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button_end", clk_button_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function win_doorhos () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_doorhos" ] = {
    type = "win",
    room = "rm_atbar",
    zz = "mg_atbar",
    zz_gate = "gmg_atbar_doorhos"
  };
  local win_doorhos = function ()

    if ( cmn.IsEventDone( "win_doorhos" ) ) then  
      
      ObjSet( "obj_doorhos_btn_clk", { input = true });
      ObjSet( "obj_doorhos_hard", { input = false });
      ObjDelete("spr_doorhos_door");
      ObjSet("obj_doorhos_mode", { input = false });
      
           
        for i = 1, 33  do
          
          ObjSet( "obj_doorhos_hard_"..i, { pos_x = private.position[i][1], pos_y = private.position[i][2] });
          
        end

    else
    
      if ng_global.progress[ "std" ][ "win_doorhos" ].hardcore then
        
            ObjMultiSet({
              --{ "obj_harproom_mode_hard", { alp = 1, input = true } },
              { "obj_doorhos_mode_hard", { input = false } },
              { "obj_doorhos_mode_casual", { input = true } },
              
            });
        
      else 
            
             ObjMultiSet({
             --{ "obj_harproom_mode_hard", { alp = 1, input = true } },
             { "obj_doorhos_mode_hard", { input = true } },
              { "obj_doorhos_mode_casual", { input = false } },
              
            });
        
      end;  
        --ObjSet("obj_doorhos_hard", { input = true, alp = 1});
      
        --if  ng_global.progress[ "std" ][ "win_doorhos" ].flag ~=0 then 
        --  
        --  ObjSet( "spr_doorhos_hard_"..ng_global.progress[ "std" ][ "win_doorhos" ].flag.."_add", { alp = 1 });
        --  
        --end; 
     
        for i = 1, 33  do
          
          ObjSet( "obj_doorhos_hard_"..ng_global.progress[ "std" ][ "win_doorhos" ].state[i], { pos_x = private.position[i][1], pos_y = private.position[i][2] });
          
        end
      
      
     
     
    end;

  end;

  cmn.AddSubscriber( "win_doorhos", win_doorhos, private.room_objname );
  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_doorhos" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_doorhos" ) ) then
    
    --ng_global.progress[ "std" ][ "win_doorhos" ].state = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33 };
    ng_global.progress[ "std" ][ "win_doorhos" ].state = {5, 20, 3, 4, 8, 19, 11, 9, 1, 10, 27, 2, 7, 12, 6, 33, 17, 18, 21, 23, 31, 22, 32, 30, 16, 13, 29, 28, 14, 25, 26, 24, 15 };
    ng_global.progress[ "std" ][ "win_doorhos" ].hardcore = true;
    ng_global.progress[ "std" ][ "win_doorhos" ].flag = 0;
    
 
  end;
  private.Set_Backlight();
  
  if not cmn.IsEventDone( "win_doorhos" ) then
   if ng_global.gamemode == 0 then
      private.SetNormal();
    end;  
  end;
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_doorhos" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.clk_button()

  cmn.CallEventHandler( "clk_button_beg" );

  local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "clk_button" );
      cmn.CallEventHandler( "clk_button_end" );
      cmn.GotoRoom( "rm_atbar" );
      ng_global.progress[ "std" ][ "win_doorhos" ].anim = 1;
    
  end;

  common_impl.Lock( true );
 
  --common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_boards_armchair", 0, "", 0 );
   common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_doorhos_button", 0, "", 0 );
   ObjAnimate("spr_doorhos_button_add",  "alp", 0, 0, func_after,
   {
   
     0.0, 0, 0.0,
     0.3, 0, 3.0,
     0.6, 0, 0.0
          
   }); 
 
end;
-------------------------------------------------------------
function private.Element_hard_clk( num )
  
  if ng_global.progress[ "std" ][ "win_doorhos" ].flag~=0 then 
    
    if ng_global.progress[ "std" ][ "win_doorhos" ].flag ~= num then
    
     private.Swap( num );
   
    else
   
       ObjSet( "spr_doorhos_hard_"..num.."_add", { alp = 0 }); 
       common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_doorhos_click", 0, "", 0 );
       ng_global.progress[ "std" ][ "win_doorhos" ].flag = 0;
      
    end
 
 else
  
    ObjSet( "spr_doorhos_hard_"..num.."_add", { alp = 1 }); 
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_doorhos_click", 0, "", 0 ); 
    ng_global.progress[ "std" ][ "win_doorhos" ].flag = num;
    
 end;
  
end;  
--------------------------------------------------------------
function private.Swap( num )
  
  local buffer = 0;
  local index_2 = 0;
  local index_1 = 0;
  local new_x1 = 0;
  local new_x2 = 0;
  local new_y1 = 0;
  local new_y2 = 0;
 
   local func_after = function ()
     
      common_impl.Lock( false );
      
      buffer = ng_global.progress[ "std" ][ "win_doorhos" ].state[index_1]; 
      ng_global.progress[ "std" ][ "win_doorhos" ].state[index_1] = ng_global.progress[ "std" ][ "win_doorhos" ].state[index_2];
      ng_global.progress[ "std" ][ "win_doorhos" ].state[index_2] = buffer;
      ng_global.progress[ "std" ][ "win_doorhos" ].flag = 0;
      
      if ng_global.progress[ "std" ][ "win_doorhos" ].state[index_2] == index_2 or 
        
        ng_global.progress[ "std" ][ "win_doorhos" ].state[index_1] == index_1 then
        
        common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_doorhos_true", 0, "", 0 ); 
        
      end;
      
      if private.CheckExceptions( index_1, index_2 ) then common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_doorhos_true", 0, "", 0 );  end;
      
      private.Set_Backlight();
      
      if private.Check_Win_Hard() then 
        
        private.Win();
        
      end;   
        
     
   end;
  
   common_impl.Lock( true );
   common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_doorhos_move", 0, "", 0 );
   --if private.position[index_1][1]
   
   ObjSet("spr_doorhos_hard_"..ng_global.progress[ "std" ][ "win_doorhos" ].flag.."_add", {alp = 0});
   
    for i = 1, 33  do
        
        if ng_global.progress[ "std" ][ "win_doorhos" ].state[i] == num then index_1 = i; end;
        
        if ng_global.progress[ "std" ][ "win_doorhos" ].state[i] == ng_global.progress[ "std" ][ "win_doorhos" ].flag then index_2 = i; end;
        
    end;
      
      if private.position[index_1][1] < private.position[index_2][1] or private.position[index_1][1] == private.position[index_2][1]then
      
      new_x1 = private.position[index_1][1] + private.delta_x;
      new_x2 = private.position[index_2][1] - private.delta_x;
      
    else 
     
      new_x1 = private.position[index_1][1] - private.delta_x;
      new_x2 = private.position[index_2][1] + private.delta_x;
     
    end; 
    
    if private.position[index_1][2] < private.position[index_2][2] or private.position[index_1][2] == private.position[index_2][2] then
      
      new_y1 = private.position[index_1][2] + private.delta_y;
      new_y2 = private.position[index_2][2] - private.delta_y;
      
    else 
     
      new_y1 = private.position[index_1][2] - private.delta_y;
      new_y2 = private.position[index_2][2] + private.delta_y;
     
    end;  
      
    ObjAnimate( "obj_doorhos_hard_"..num, "pos_xy", 0, 0, func_after,
    { 
    
    0.0, 2, private.position[index_1][1], private.position[index_1][2],
    0.4, 2, new_x1, new_y1,
    0.8, 2, private.position[index_2][1], private.position[index_2][2]
     
    });
   
    ObjAnimate( "obj_doorhos_hard_"..ng_global.progress[ "std" ][ "win_doorhos" ].flag, "pos_xy", 0, 0, "",
    { 
    
    0.0, 2, private.position[index_2][1], private.position[index_2][2],
    0.4, 2, new_x2, new_y2,
    0.8, 2, private.position[index_1][1], private.position[index_1][2]
     
    });
  
 
end;
--------------------------------------------------------------------------------------------------------------
function private.Set_Backlight()
  
  --if ng_global.progress[ "std" ][ "win_doorhos" ].hardcore then 
  
    for i = 1, 33  do
      
      if ng_global.progress[ "std" ][ "win_doorhos" ].state[i] == i then
        
        ObjSet( "spr_doorhos_hard_"..i.."_add", { alp = 1 });
        
      else  
        
        ObjSet( "spr_doorhos_hard_"..i.."_add", { alp = 0 });
        
      end;
      
    end; 
    
      if ng_global.progress[ "std" ][ "win_doorhos" ].state[16] == 33 then
        
        ObjSet( "spr_doorhos_hard_33_add", { alp = 1 });
        
      end;
      
      if ng_global.progress[ "std" ][ "win_doorhos" ].state[33] == 16 then
        
        ObjSet( "spr_doorhos_hard_16_add", { alp = 1 });
        
      end;
      if ng_global.progress[ "std" ][ "win_doorhos" ].state[11] == 18 then
        
        ObjSet( "spr_doorhos_hard_18_add", { alp = 1 });
        
      end;
      
      if ng_global.progress[ "std" ][ "win_doorhos" ].state[18] == 11 then
        
        ObjSet( "spr_doorhos_hard_11_add", { alp = 1 });
        
      end;
      if ng_global.progress[ "std" ][ "win_doorhos" ].state[13] == 30 then
        
        ObjSet( "spr_doorhos_hard_30_add", { alp = 1 });
        
      end;
      if ng_global.progress[ "std" ][ "win_doorhos" ].state[30] == 13 then
        
        ObjSet( "spr_doorhos_hard_13_add", { alp = 1 });
        
      end;
        
      if  ng_global.progress[ "std" ][ "win_doorhos" ].flag ~=0 then 
            
         ObjSet( "spr_doorhos_hard_"..ng_global.progress[ "std" ][ "win_doorhos" ].flag.."_add", { alp = 1 });
            
       end; 
    --end;
    --else
    
    
  
    --end;
end;
---------------------------------------------------------------
function private.SetNormal()

  local func_after = function()
  
    common_impl.Lock( false );
    ObjMultiSet({
    --{ "obj_harproom_mode_hard", { alp = 0, input = false } },
    { "obj_doorhos_mode_casual", { input = false } },
    { "obj_doorhos_mode_hard", { input = true } },
    });
    ng_global.progress[ "std" ][ "win_doorhos" ].hardcore = false;
    
    for i = 1, 33  do
         
         ObjSet( "obj_doorhos_hard_"..private.casual[i], { pos_x = private.position[i][1], pos_y = private.position[i][2] });
          
    end; 
       
       ng_global.progress[ "std" ][ "win_doorhos" ].state = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 33, 22, 24, 30, 29, 31, 32, 23, 25, 26, 27, 28 };
    ng_global.progress[ "std" ][ "win_doorhos" ].flag = 0;  
    private.Set_Backlight();
    
  end;
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_doorhos_change_complexity", 0, "", 0 ); 
  common_impl.Lock( true );
  ObjAnimate("spr_doorhos_mode_btn_casual", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.2, 3, 1,
    0.4, 3, 0
  });  
  
end;  
--------------------------------------------------------------------------
function private.SetHard()

  local func_after = function()
  
    common_impl.Lock( false );
    ObjMultiSet({
    --{ "obj_harproom_mode_hard", { alp = 1, input = true } },
    { "obj_doorhos_mode_hard", { input = false } },
    { "obj_doorhos_mode_casual", { input = true } },
    });
    ng_global.progress[ "std" ][ "win_doorhos" ].hardcore = true;
    for i = 1, 33  do
         
      ObjSet( "obj_doorhos_hard_"..private.start[i], { pos_x = private.position[i][1], pos_y = private.position[i][2] });
          
    end; 
       
    ng_global.progress[ "std" ][ "win_doorhos" ].state = {5, 20, 3, 4, 8, 19, 11, 9, 1, 10, 27, 2, 7, 12, 6, 33, 17, 18, 21, 23, 31, 22, 32, 30, 16, 13, 29, 28, 14, 25, 26, 24, 15 };
    ng_global.progress[ "std" ][ "win_doorhos" ].flag = 0;  
    private.Set_Backlight();
    
  end;
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_doorhos_change_complexity", 0, "", 0 ); 
  common_impl.Lock( true );
  ObjAnimate("spr_doorhos_mode_btn_hard", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.2, 3, 1,
    0.4, 3, 0
  });  
  
end;
--------------------------------------------------------------------------------
function private.CheckExceptions(index_1, index_2)
  
  answer = false;
  array = { index_1, index_2 };
  
  for i = 1, 2  do
    
    if ( ng_global.progress[ "std" ][ "win_doorhos" ].state[array[i] ] == 33 and array[i] == 16 or 
    
      ng_global.progress[ "std" ][ "win_doorhos" ].state[array[i] ] == 16 and array[i] == 33 ) or 
      
     ( ng_global.progress[ "std" ][ "win_doorhos" ].state[array[i] ] == 11 and array[i] == 18 or 
    
     ng_global.progress[ "std" ][ "win_doorhos" ].state[array[i] ] == 18 and array[i] == 11 ) or 
     
     ( ng_global.progress[ "std" ][ "win_doorhos" ].state[array[i] ] == 13 and array[i] == 30 or 
    
     ng_global.progress[ "std" ][ "win_doorhos" ].state[array[i] ] == 30 and array[i] ==13 )
      
     then
     
       answer = true;
    
     end;
     
    
  end;
  
   return answer;
  
end;  
--------------------------------------------------------------------------------
function private.Check_Win_Hard()
  
  answer = false;
  
  local count = 0;
  
  for i = 1, 33  do
    
     if ng_global.progress[ "std" ][ "win_doorhos" ].state[i] == i then
       
      count = count + 1; 
      
     end;
  end;
    
    if ng_global.progress[ "std" ][ "win_doorhos" ].state[16] == 33 then
      
       count = count + 1;
      
    end;
     if ng_global.progress[ "std" ][ "win_doorhos" ].state[33] == 16 then
      
      count = count + 1;
      
    end;
    if ng_global.progress[ "std" ][ "win_doorhos" ].state[11] == 18 then
      
      count = count + 1;
      
    end;
    
    if ng_global.progress[ "std" ][ "win_doorhos" ].state[18] == 11 then
      
      count = count + 1;
      
    end;
    if ng_global.progress[ "std" ][ "win_doorhos" ].state[13] == 30 then
      
      count = count + 1;
      
    end;
    if ng_global.progress[ "std" ][ "win_doorhos" ].state[30] == 13 then
      
      count = count + 1;
      
    end;  
  
    if count == 33 then answer  = true; end;
    
    return answer;
  
  
end;  
--*********************************************************************************************************************
function public.Reset()
  
  if ng_global.progress[ "std" ][ "win_doorhos" ].hardcore then
    
     for i = 1, 33  do
       
        ObjSet( "obj_doorhos_hard_"..private.start[i], { pos_x = private.position[i][1], pos_y = private.position[i][2] });
        
    end; 
    ng_global.progress[ "std" ][ "win_doorhos" ].state = {5, 20, 3, 4, 8, 19, 11, 9, 1, 10, 27, 2, 7, 12, 6, 33, 17, 18, 21, 23, 31, 22, 32, 30, 16, 13, 29, 28, 14, 25, 26, 24, 15 };
    
  else 
    
     for i = 1, 33  do
       
       ObjSet( "obj_doorhos_hard_"..private.casual[i], { pos_x = private.position[i][1], pos_y = private.position[i][2] });
        
    end; 
     ng_global.progress[ "std" ][ "win_doorhos" ].state = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 33, 22, 24, 30, 29, 31, 32, 23, 25, 26, 27, 28 };
    
  end;  
    ng_global.progress[ "std" ][ "win_doorhos" ].flag = 0;  
    private.Set_Backlight();
    

end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  local func_end = function ()
  
     private.Win();
  
  end;
   
  common_impl.Lock( true ); 
  
  --if ng_global.progress[ "std" ][ "win_doorhos" ].hardcore then 
    
      local func_after = function ()
      
        for i = 1, 33  do
          
          ObjSet( "obj_doorhos_hard_"..i, { pos_x = private.position[i][1], pos_y = private.position[i][2]});
          ObjSet( "spr_doorhos_hard_"..i.."_add", { alp = 1 });
          
          
        end;
        
        ObjAnimate( "obj_doorhos_hard", "alp", 0, 0, func_end,
        { 
        
          0.0, 0, 0,
          0.2, 0, 1
         
        });
  
      end;
        
      ObjAnimate( "obj_doorhos_hard", "alp", 0, 0, func_after,
      { 
      
        0.0, 0, 1,
        0.2, 0, 0
       
      });
     
      
      --end;
    
    
    
    
      --else
    
    
      --end;  
end;
--*********************************************************************************************************************
function private.WinEnd()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   

  cmn.MiniGameHide();
  common_impl.PassingMgWin();
  cmn.SetEventDone( "win_doorhos" );
  cmn.CallEventHandler( "win_doorhos" );
  --cmn.GotoRoom( "rm_atbar" );

end;
--*********************************************************************************************************************
function private.Win()

  local func_after = function ()
     
      common_impl.Lock( false );
      private.WinEnd();
  
  end;
    
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_doorhos_win", 0, "", 0 );
  ObjAnimate( "spr_doorhos_door", "pos_y", 0, 0, func_after,
  { 
    
    0.0, 0, 96,
    0.6, 0, -39
    
  });
  

end;
--*********************************************************************************************************************
function private.MouseEnterAnim( name )

  if ( cmn.IsPC() ) then
  
    common_impl.SetCursor( CURSOR_HAND );

    local obj = name.."_focus";
    local alp = ObjGet( obj ).alp;
    local tme = ( 1 - alp ) * 0.3;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 2, alp,
      tme, 2, 1
    } );
    
  end;

end;
--******************************************************************************************
function private.MouseLeaveAnim( name )
  
    common_impl.SetCursor( CURSOR_DEFAULT );

    local obj = name.."_focus";
    local alp = ObjGet( obj ).alp;
    local tme = alp * 0.3;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 1, alp,
      tme, 1, 0
    } );

  end;